
package de.desy.mst.common.pintlk.badgerviewer;
import de.desy.mst.libs.framework.mstapp.Main;
import de.desy.mst.libs.framework.mstapp.MstApp;
import de.desy.mst.libs.framework.mstapp.MstFrameMain;
import de.desy.mst.libs.framework.mstapp.mode.IServerAnwahlObserver;
import de.desy.mst.libs.framework.mstapp.mode.ServerAnwahl;
import de.desy.mst.libs.pintlk.badgerviewer.config.EClientConfig;
import de.desy.mst.libs.pintlk.badgerviewer.display.DeviceDisplay;
import de.desy.mst.libs.pintlk.badgerviewer.network.IDevice;
public class BadgerViewer extends MstFrameMain {

	private static final long serialVersionUID = 1L;
	private static final String thisClassName = BadgerViewer.class.getName();
	private final javax.swing.JTabbedPane tabedPane = new javax.swing.JTabbedPane(1);
	private final java.util.Collection<IDevice> displayedDevices = new java.util.LinkedList<IDevice>();
	@Override
	protected void afterFrameCreated() {
		super.afterFrameCreated();
		this.getMstApp().getHelpMgr().setBKRWikiHilfe_AppPageName("Software:DachsViewer");
		this.setBounds(de.desy.mst.libs.framework.mstapp.Screen.QUARTER.BOTTOM_RIGHT);
		this.add(this.tabedPane);
		this.getMstApp().getServerAnwahlMgr().registerAnwahlObserver(new IServerAnwahlObserver(){

			public void onServerAnwahlChange(ServerAnwahl anwahl) {
				BadgerViewer.this.onServerChange(anwahl);
			}
		});
	}

	public static void main(String[] args) {
		Main.startMSTApp(thisClassName, new String[]{"DACHS Viewer"});
	}
	public BadgerViewer () {
		super();
	}
	public BadgerViewer(MstApp mstApp) {
		super(mstApp);
	}
	/**
	 * @param anwahl eines anderen Servers
	 */
	private void onServerChange(ServerAnwahl anwahl) {
		this.tabedPane.removeAll();
		final EClientConfig defindConfig = EClientConfig.getDefinedConfig(); 
		// terminate previous devives
		for (IDevice device : this.displayedDevices) {
			device.terminate();
		}
		this.displayedDevices.clear();
		
		this.tabedPane.removeAll();
		for (IDevice device: defindConfig.createDevices(anwahl)) {
			final DeviceDisplay display = new DeviceDisplay(device);
			this.displayedDevices.add(device);
			this.tabedPane.addTab(
				device.getDeviceName(), 
				display
			);
			final javax.swing.JComponent tabComponent = new javax.swing.JPanel();
			tabComponent.setOpaque(false);
			tabComponent.add(new javax.swing.JLabel(device.getDeviceName()));
			tabComponent.add(display.getTitleDisplay());
		}
	}
}