/*
 *
 * File: ClassVersion.java
 * Date: Oct 25, 2007; 1:05:25 PM
 */
package de.desy.mst.libs.accelerator;

/**
 * <p>This is the annotation for constructing the author, its e-mail address
 * and the version number and release type as its class version.</p>
 *
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: ClassVersion.java 12066 2008-05-29 08:35:57Z walla $
 */
public @interface ClassVersion
{
	/** Returns the author name, normally this is her or his user name,
	 * i.e. "walla". */
	String author();
	
	/** Returns the e-mail address of the developer, i.e. 
	 * "marcus.walla(at)desy.de". */
	String email();
	
	/** Returns the major version number. As a default this returns number 1. */
	int major() default 1;
	
	/** Returns the minor version number. As a default this returns number 0.*/
	int minor() default 0;
	
	/** Returns the release type. This is an enumeration which can have 
	 * different values: ALPHA, BEAT and PRODUCTION. By default this returns
	 * the ALPHA release type.*/
	EReleaseType release() default EReleaseType.ALPHA;
}
/* end of file */