/*
 *
 * File: ESeverity.java
 * Date: Aug 25, 2008; 6:20:32 PM
 */
package de.desy.mst.libs.accelerator;

/**
 * The severity enumerations which represents the severity of a component or
 * a value. This can be one of ...
 * 
 * <table cellspacing="2" cellpadding="4">
 * <tr><th>Enumeration</th><th>Description</th></tr>
 * <tr bgcolor="#A0A0A0"><td>{@link #NORMAL}</td><td>Normal severity without any special circumstances</td></tr>
 * <tr bgcolor="#E0E0E0"><td>{@link #WARN}</td><td>Warning severity with a warning circumstances, which possible can causes an output. But the user can deliver what to do next and the application will not finish in executing its task.</td></tr>
 * <tr bgcolor="#A0A0A0"><td>{@link #ERROR}</td><td>Error severity. This can (possibly) display an error message on screen before the application finishes. You can also open a dialog box with optional choices for the operator.</td></tr>
 * <tr bgcolor="#E0E0E0"><td>{@link #FATAL}</td><td>Fatal severity. Causes the application to exit immediately. You can also inform the operator about the fatal error and give a hint which person he should contact.</td></tr>
 * </table>
 *
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: ESeverity.java 32041 2010-01-07 13:18:25Z walla $
 */
public enum ESeverity
{
	NORMAL, WARN, ERROR, FATAL
}
/* end of file */