/*
 *
 * File: IEDataReadCompoundDataType.java
 * Date: Mar 5, 2009; 3:38:15 PM
 */
package de.desy.mst.libs.accelerator;

import de.desy.tine.types.TCompoundDataObject;

/**
 * Each data element can hold a list of compound data objects from TINE which
 * is delivered by the method of {@link #readCompoundDataObject()}.
 *
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: IEDataReadCompoundDataType.java 23042 2009-03-19 15:52:19Z walla $
 */
public interface IEDataReadCompoundDataType<T extends TCompoundDataObject>
{
	/**
	 * Reads the data object types which is mostly used for representing
	 * each data element with its TINE output values.
	 * 
	 * @return Returns the data object type array.
	 */
	public abstract T[] readCompoundDataObject();
}
/* end of file */