/*
 *
 * File: IEDataSendDataType.java
 * Date: Nov 28, 2008; 12:34:46 PM
 */
package de.desy.mst.libs.accelerator;

import de.desy.tine.dataUtils.TDataType;

/**
 * This interface encapsulates the sending TINE data type as an object and
 * receives it to the controlling monitor class which constructs the TINE
 * link. The send data type can be of any TINE data types included in
 * an array.
 *
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: IEDataSendDataType.java 19233 2008-11-28 15:25:37Z walla $
 */
public interface IEDataSendDataType
{
	/**
	 * Returns the sending data type.
	 *
	 * @return Returns the sending data type.
	 */
	public abstract TDataType sendDataType();
}
/* end of file */