/*
 *
 * File: AlreadyInMapException.java
 * Date: Feb 12, 2008; 1:57:37 PM
 */
package de.desy.mst.libs.accelerator.exception;

/**
 * The element already exists in the map.
 * 
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: AlreadyInMapException.java 12066 2008-05-29 08:35:57Z walla $
 */
public final class AlreadyInMapException extends RuntimeException
{
	/** Is the serial version UID to unify this class. */
	 final static long serialVersionUID = 1255900534690431643l;
	 
	/**
	 * The constructor of this exception.
	 */
	public AlreadyInMapException()
	{
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param message_ Gets a message as its description.
	 */
	public AlreadyInMapException(final String message_)
	{
		super(message_);
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public AlreadyInMapException(final Throwable cause_)
	{
		super(cause_);
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param message_ Gets a message as its description.
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public AlreadyInMapException(final String message_, final Throwable cause_)
	{
		super(message_, cause_);
	}

}
/* end of file */