/*
 *
 * File: IdleTimeExceededException.java
 * Date: Oct 11, 2007; 10:49:32 AM
 */
package de.desy.mst.libs.accelerator.exception;

/**
 * The idel time as exceeded its boundary and this will throw these exception.
 *
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: IdleTimeExceededException.java 12066 2008-05-29 08:35:57Z walla $
 */
public class IdleTimeExceededException extends RuntimeException
{
	/** Is the serial version UID to unify this class. */
	public static final long serialVersionUID = 1340703220618875795l;

	/**
	 * The idle time has reached its dead line. 
	 */
	public IdleTimeExceededException()
	{
		super();
	}

	/**
	 * The idle time has reached its dead line. 
	 * 
	 * @param message_ Is the message.
	 */
	public IdleTimeExceededException(String message_)
	{
		super(message_);
	}

	/**
	 * The idle time has reached its dead line. 
	 * 
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public IdleTimeExceededException(Throwable cause_)
	{
		super(cause_);
	}

	/**
	 * The idle time has reached its dead line. 
	 * 
	 * @param message_ Is the message.
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public IdleTimeExceededException(String message_, Throwable cause_)
	{
		super(message_, cause_);
	}

}
/* end of file */