/*
 *
 * File: InvalidListException.java
 * Date: Sep 28, 2006; 1:41:06 PM
 */
package de.desy.mst.libs.accelerator.exception;

/**
 * A list is not valid or has not the expected size. 
 * 
 * @author <a href="marcus.walla at desy.de">walla</a>
 * @version $Id: InvalidListException.java 12066 2008-05-29 08:35:57Z walla $
 */
public class InvalidListException extends RuntimeException
{
	/** Is the serial version UID to unify this class. */
	public static final long serialVersionUID = 4226095043051236075l;
	
	/**
	 * Creates this exception.
	 */
	public InvalidListException()
	{
	}

	/**
	 * Creates this exception.
	 * 
	 * @param message_ Is the message.
	 */
	public InvalidListException(String message_)
	{
		super(message_);
	}

	/**
	 * Creates this exception.
	 * 
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public InvalidListException(Throwable cause_)
	{
		super(cause_);
	}

	/**
	 * Creates this exception.
	 *
	 * @param message_ Is the message.
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public InvalidListException(String message_, Throwable cause_)
	{
		super(message_, cause_);
	}

}
/* end of file */