/*
 *
 * File: OperationNotAllowedException.java
 * Date: Mar 26, 2007; 4:27:47 PM
 */
package de.desy.mst.libs.accelerator.exception;

/**
 * This operation is currently not allowed on the calling method.
 * 
 * @author <a href="marcus.walla at desy.de">walla</a>
 * @version $Id: OperationNotAllowedException.java 34927 2010-04-11 11:45:16Z walla $
 */
public class OperationNotAllowedException extends RuntimeException
{
	// --- CLASS FIELDS --------------------------------------------------------
	
	/** Is the unique serial version UID needed for serialization of this class. */
	final static long serialVersionUID = 65294912939600632l;

	// --- CONSTRUCTOR ---------------------------------------------------------
	
	/**
	 * The constructor of this exception.
	 */
	public OperationNotAllowedException()
	{
		super("Operation is not allowed");
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param message_ Gets a message as its description.
	 */
	public OperationNotAllowedException(String message_)
	{
		super(message_);
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public OperationNotAllowedException(Throwable cause_)
	{
		super(cause_);
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param message_ Gets a message as its description.
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public OperationNotAllowedException(String message_, Throwable cause_)
	{
		super(message_, cause_);
	}

}
/* end of file */