/*
 *
 * File: TineLinkException.java
 * Date: Nov 24, 2006; 10:15:27 AM
 */
package de.desy.mst.libs.accelerator.exception;

/**
 * The link connection to the concrete device name does not exists or is not
 * implemented jet. If one gets such an exception you have to look at the
 * method and correct the code.
 * 
 * @author <a href="marcus.walla(at)desy.de">walla</a>
 * @version $Id: TineLinkException.java 12066 2008-05-29 08:35:57Z walla $
 */
public class TineLinkException extends TineException
{
	/** Is the serial version UID to unify this class. */
	public static final long serialVersionUID = 6399100205452236321l;

	/**
	 * The constructor of this exception.
	 * 
	 * @param error_ The error code value. This is in most cases the TINE error 
	 * 		code.
	 */
	public TineLinkException(final int error_)
	{
		super(error_);
	}

	/**
	 * The constructor of this exception.
	 *  
	 * @param error_ The error code value. This is in most cases the TINE error 
	 * 		code.
	 * @param message_ Gets a message as its description.
	 */
	public TineLinkException(final int error_, final String message_)
	{
		super(error_, message_);
	}

	/**
	 * The constructor of this exception.
	 *
	 * @param error_ The error code value. This is in most cases the TINE error 
	 * 		code.
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public TineLinkException(final int error_, final Throwable cause_)
	{
		super(error_, cause_);
	}

	/**
	 * The constructor of this exception.
	 *
	 * @param error_ The error code value. This is in most cases the TINE error 
	 * 		code.
	 * @param message_ Gets a message as its description.
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public TineLinkException(final int error_, final String message_, 
			final Throwable cause_)
	{
		super(error_, message_, cause_);
	}

}
/* end of file */