/*
 *
 * File: ValueNotFoundException.java
 * Date: Nov 2, 2006; 4:42:25 PM
 */
package de.desy.mst.libs.accelerator.exception;

/**
 * The value can not be found in in the list or collection or what so ever.
 *
 * @author <a href="marcus.walla at desy.de">walla</a>
 * @version $Id: ValueNotFoundException.java 12066 2008-05-29 08:35:57Z walla $
 */
public class ValueNotFoundException extends RuntimeException
{
	/** Is the unique serial version UID */
	final static long serialVersionUID = 1250940299534579824l;
	
	/**
	 * The constructor of this exception.
	 */
	public ValueNotFoundException()
	{	
		super();
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param message_ Gets a message as its description.
	 */
	public ValueNotFoundException(String message_)
	{
		super(message_);
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public ValueNotFoundException(Throwable cause_)
	{
		super(cause_);
	}

	/**
	 * The constructor of this exception.
	 * 
	 * @param message_ Gets a message as its description.
	 * @param cause_ Is the throwable cause of this exception.
	 */
	public ValueNotFoundException(String message_, Throwable cause_)
	{
		super(message_, cause_);
	}
}
/* end of file */