/*
 *
 * File: ArcSegment.java
 * Date: Nov 3, 2006; 4:32:01 PM
 */
package de.desy.mst.libs.accelerator.view;

import java.awt.Graphics2D;
import java.awt.Graphics;
import java.awt.Stroke;

/**
 * <p>This will draw an arc segement in a 2d graphic panel. To define an arc of 
 * a circle its middle point is charged, the radius of ellipse is overgiven as 
 * the integer values of r1 and r2 and the rotation is desired by the value of 
 * phi. The following picture shows the values and its valances:</p>
 * 
 * <p><img src="../../../../../../../resources/arcSegment.jpg" alt="" name=""/></p>
 * 
 * <p>The drawable arc should only be instanziated in the {@code paint} or 
 * {@code paintComponent} method of {@code Component} or {@code JComponent}.</p>
 * <p><b><u>Remember:</u></b> The angle can be given in radian measure, where 0 &lt;= 
 * &phi; &lt; 2 * &pi;, or in degree, where 0 &lt;= &rho; &lt; 360.</p>
 * 
 *
 * @author <a href="marcus.walla at desy.de">walla</a>
 * @version $Id: ArcSegment.java 32894 2010-02-08 12:53:07Z walla $
 */
@Deprecated
public class ArcSegment
{
	/** */
	private int _x;
	
	/** */
	private int _y;
	
	/** */
	private int _r1;
	
	/** */
	private int _r2;
	
	/** */
	private int _rho;
	
	/** */
	private int _steps;
	
	/** */
	private Stroke _stroke = null;
	
	/** */
    @Deprecated
	private final static TrigonometricalFunction _trigonomical = 
		TrigonometricalFunction.getInstance();; 
	
	/**
	 * Will draw a circle in the graphic object witch has its middle point
	 * at the postion x, y and the radius r.
	 * 
	 * @param x_ The x value of the middle point of the circle.
	 * @param y_ The x value of the middle point of the circle.
	 * @param r_ Is the length of radius of the circle.
	 */
	    @Deprecated
	public ArcSegment(int x_, int y_, int r_)
	{
		if (x_ < 0 || y_ < 0 || r_ < 0 )
			throw new IllegalArgumentException("One of the primitive variables" +
					" is not valid.");
		
		_x = x_;
		_y = y_;
		_r1 = r_;
		_r2 = r_;
		_rho = 0;
		_steps = 20;
		_stroke = null;

	}
	
	/**
	 * This is the constructor of an ellipse which has its middle point at x,y 
	 * and the radius of r1 and r2 where r1 is the radius allong the x axis and
	 * r2 is the radius allong the y axis. This ground figure is after all rotated
	 * by the angle of phi which is a radian measure. The steps subdivide the drawn
	 * figure element into sections. This should be in the range from 1 to 360.
	 * 
	 * @param x_ The x value of the middle point of the ellipse.
	 * @param y_ The x value of the middle point of the ellipse.
	 * @param r1_ Is the length of the x axis of the ellipse.
	 * @param r2_ Is the length of the y axis of the ellipse. 
	 * @param phi_ The rotation of the ground figure. This value is overgiven in
	 * 		radian measure.
	 * @param steps_ The angle which is draw as a figure on screen can be 
	 * 		subdivided in different parts. So the steps of this subdivision is 
	 * 		stored here. 
	 * @param stroke_ Is the stroke of the arc which should be drawn. This value
	 * 		can also be set to {@code null}.
	 */
	    @Deprecated
	public ArcSegment(int x_, int y_, int r1_, int r2_, float phi_, int steps_, 
			Stroke stroke_)
	{
		if (x_ < 0 || y_ < 0 || _rho < 0 || _rho > 2 * Math.PI || r1_ < 0 || r2_ < 0)
			throw new IllegalArgumentException("One of the primitive variables" +
					" is not valid.");
		if (steps_ < 1 || steps_ > 360)
			throw new IllegalArgumentException("The steps of the arc is not" +
					" valid (should be in the range from 1 to 360).");
		
		_x = x_;
		_y = y_;
		_r1 = r1_;
		_r2 = r2_;
		_rho = (int) Math.round(Math.PI * phi_ / 180.0);
		_steps = steps_;
		_stroke = stroke_;
	}
	
	/**
	 * This contructor does the same as the above except that it will get
	 * the rotation of the ground figure in degree (see the parameter {@code rho_}).
	 * 
	 * @param x_ The x value of the middle point of the ellipse.
	 * @param y_ The x value of the middle point of the ellipse.
	 * @param r1_ Is the length of the x axis of the ellipse.
	 * @param r2_ Is the length of the y axis of the ellipse. 
	 * @param rho_ The rotation of the ground figure. This value is overgiven in
	 * 		degree.
	 * @param steps_ The angle which is draw as a figure on screen can be 
	 * 		subdivided in different parts. So the steps of this subdivision is 
	 * 		stored here. 
	 * @param stroke_ Is the stroke of the arc which should be drawn. This value
	 * 		can also be set to {@code null}.
	 */
	    @Deprecated
	public ArcSegment(int x_, int y_, int r1_, int r2_, int rho_, int steps_, 
			Stroke stroke_)
	{
		if (x_ < 0 || y_ < 0 || _rho < 0 || _rho > 360 || r1_ < 0 || r2_ < 0)
			throw new IllegalArgumentException("One of the primitive variables" +
					" is not valid.");
		if (steps_ < 1 || steps_ > 360)
			throw new IllegalArgumentException("The steps of the arc is not" +
					" valid (should be in the range from 1 to 360).");
		
		_x = x_;
		_y = y_;
		_r1 = r1_;
		_r2 = r2_;
		_rho = rho_;
		_steps = steps_;
		_stroke = stroke_;
	}
	
	/**
	 * Draws the arc by overgiven the starting and ending point of the drawn
	 * ellipse. The angle is given in radian measure.
	 * 
	 * @param startPhi_ Is the starting angle of the arc which should be drawn.
	 * @param endPhi_ Is the ending angle of the arc which should be drawn.
	 * @param graphic_ Is the graphic object in which the arc figure should be 
	 * 		drawn.
	 */
	    @Deprecated
	public void drawArc(float startPhi_, float endPhi_, Graphics graphic_)
	{
		if (startPhi_ < 0 || startPhi_ >= Math.PI * 2 
				|| endPhi_ < 0 || endPhi_ >= Math.PI * 2)
			throw new IllegalArgumentException("The angle is not valid.");

		int startRho = (int) Math.round(Math.PI * startPhi_ / 180.0);
		int endRho = (int) Math.round(Math.PI * endPhi_ / 180.0);
		
		drawArc(startRho, endRho, graphic_);

//		float rhoSteps = (endRho - startRho) / _steps;
//		int currentRho = startRho + _rho;
//		endRho += _rho;
//		int x1 = (int) Math.round(_r1 * _trigonomical.cos(currentRho % 360)) + _x;
//		int y1 = (int) Math.round(_r2 * _trigonomical.sin(currentRho % 360)) + _y;
//		int x2, y2;
//		
//		Stroke stroke = null;
//		if (graphic_ instanceof Graphics2D || _stroke != null)
//		{
//			stroke = ((Graphics2D) graphic_).getStroke();
//			((Graphics2D) graphic_).setStroke(_stroke);
//		}
//
//		do
//		{
//			x2 = (int) Math.round(_r1 * _trigonomical.cos(currentRho % 360)) + _x;
//			y2 = (int) Math.round(_r2 * _trigonomical.sin(currentRho % 360)) + _y;
//			graphic_.drawLine(x1, y1, x2, y2);
//			x1 = x2;
//			y1 = y2;
//			currentRho += rhoSteps;
//		}
//		while(currentRho < endPhi_);
//		
//		if (graphic_ instanceof Graphics2D || stroke != null)
//			((Graphics2D) graphic_).setStroke(stroke);

	}
	
	/**
	 * Draws the arc by overgiven the starting and ending point of the drawn
	 * ellipse. The angle is given in degree.
	 * 
	 * @param startRho_ Is the starting angle of the arc which should be drawn.
	 * @param endRho_ Is the ending angle of the arc which should be drawn.
	 * @param graphic_ Is the graphic object in which the arc figure should be 
	 * 		drawn.
	 */
	    @Deprecated
	public void drawArc(int startRho_, int endRho_, Graphics graphic_)
	{
		if (startRho_ < 0 || startRho_ >= 360 
				|| endRho_ < 0 || endRho_ >= 360 )
			throw new IllegalArgumentException("The angle is not valid.");

		float rhoSteps = (endRho_ - startRho_) / _steps;
		int currentRho = startRho_ + _rho;
		endRho_ += _rho;
		int x1 = Math.round(_r1 * _trigonomical.cos(currentRho % 360)) + _x;
		int y1 = Math.round(_r2 * _trigonomical.sin(currentRho % 360)) + _y;
		int x2, y2;

		Stroke stroke = null;
		if (graphic_ instanceof Graphics2D || _stroke != null)
		{
			stroke = ((Graphics2D) graphic_).getStroke();
			((Graphics2D) graphic_).setStroke(_stroke);
		}

		do
		{
			currentRho += rhoSteps;
			x2 = Math.round(_r1 * _trigonomical.cos(currentRho % 360)) + _x;
			y2 = Math.round(_r2 * _trigonomical.sin(currentRho % 360)) + _y;
			graphic_.drawLine(x1, y1, x2, y2);
			x1 = x2;
			y1 = y2;
		}
		while(currentRho < endRho_);

		if (graphic_ instanceof Graphics2D || stroke != null)
			((Graphics2D) graphic_).setStroke(stroke);
	}
	
	/**
	 * Draws a complete ellipse.
	 * 
	 * @param graphic_ Is the 2D graphic object in which the ellipse should be 
	 * 		drawn.
	 */
	    @Deprecated
	public void drawArc(Graphics2D graphic_)
	{
		float rhoSteps = (float) (2.0f * Math.PI / _steps);
		float currentRho = _rho;
		int x1 = (int) Math.round(_r1 * Math.cos(currentRho) + _x);
		int y1 = (int) Math.round(_r2 * Math.sin(currentRho) + _y);
		int x2, y2;

		Stroke stroke = null;
		if (_stroke != null)
		{
			stroke = graphic_.getStroke();
			graphic_.setStroke(_stroke);
		}

		do
		{
			x2 = (int) Math.round(_r1 * Math.cos(currentRho) + _x);
			y2 = (int) Math.round(_r2 * Math.sin(currentRho) + _y);
			graphic_.drawLine(x1, y1, x2, y2);
			x1 = x2;
			y1 = y2;
			currentRho += rhoSteps;
		}
		while(currentRho <= 2 * Math.PI);

		if (stroke != null)
			graphic_.setStroke(stroke);
	}
	
}
/* end of file */