/**
 * File: IGenericSlider.java
 * Date: Dec 18, 2009
 */
package de.desy.mst.libs.accelerator.view;

import de.desy.mst.libs.accelerator.IEViewGeneric;
import de.desy.mst.libs.accelerator.exception.EnumerationNotUsedException;

/**
 * Interface for the GUI sliders functionality.
 *
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id$
 */
public interface IGenericSlider
{
	/**
	 * Sets the slider connection.
	 * 
	 * @param view_ Enumeration which specifies the slider.
	 * @throws EnumerationNotUsedException If the enumeration is not used but 
	 * 		exist in this method this exception is thrown.
	 */
	public abstract void setSliderConnection(final IEViewGeneric view) throws EnumerationNotUsedException;
}
/* end of file */