/*
 *
 * File: ViewConstant.java
 * Date: Nov 9, 2006; 10:15:03 AM
 */
package de.desy.mst.libs.accelerator.view;

import java.awt.Color;
import java.awt.Dimension;

/**
 * <p>Some constants static final fields which are declared and defined in this
 * class.</p>
 * <p>These static fields are mostly used for the never realized project
 * from Mr. Timmy Lensch (Hardware developer, Group MDI 1, Building 30).</p>
 *
 * @author <a href="marcus.walla(at)desy.de">walla</a>
 * @version $Id: ViewConstant.java 19706 2008-12-14 12:41:25Z walla $
 */
public final class ViewConstant
{

	// -------------------------------------------------------------------------
	// Accelerator specific variables
	/** The dimension of the accelerator. */
	public static final Dimension DIMENSION_ACCELERATOR =
		new Dimension(1000, 900);

	/** The rotation of the accelerator around its middle point in degree. */
	public final static int ROTATION_ACCELERATOR = 0;

	/** The color of the accelerator itself. */
	public final static Color COL_ACCELERATOR = new Color(0, 255, 0);

	/** The height of a hangar button. */
	public final static int HEIGHT_HANGAR_BUTTON = 40;

	/** The width of a hangar button. */
	public final static int WIDTH_HANGAR_BUTTON = 40;

	/** The color of the text hangar content. */
	public static final Color COL_HANGAR_TEXT = new Color(0.0f, 0.0f, 0.0f, 1.0f);

	/** The color of the active hangar button. */
	public static final Color COL_HANGAR_ACTIVE = new Color(255, 255, 0, 255);

	/** The color of the active border hangar button. */
	public static final Color COL_HANGAR_ACTIVE_BORDER = new Color(240, 100, 100, 255);

	/** The color of the inactive hangar button. */
	public static final Color COL_HANGAR_INACTIVE = new Color(160, 180, 215, 255);

	/** The color of the inactive hangar border button. */
	public static final Color COL_HANGAR_INACTIVE_BORDER = new Color(0.5f, 0.5f, 0.5f, 1.0f);

	/** The font size of the printed direction sign of the hangar. */
	public static final int FONT_HANGAR_SIZE = 32;

	// -------------------------------------------------------------------------

	/** The font family. */
	public static final String FONT = "Arial";

	/** The color of the text content. */
	public static final Color COL_TEXT = new Color(1.0f, 1.0f, 1.0f, 1.0f);

	/** The color of the active button. */
	public static final Color COL_ACTIVE = new Color(1.0f, 1.0f, 0.0f, 0.5f);

	/** The color of the active border button. */
	public static final Color COL_ACTIVE_BORDER = new Color(0.7f, 0.7f, 0.1f, 0.5f);

	/** The color of the inactive button. */
	public static final Color COL_INACTIVE = new Color(0.0f, 0.0f, 0.0f, 0.0f);

	/** The color of the inactive border button. */
	public static final Color COL_INACTIVE_BORDER = new Color(0.0f, 0.0f, 0.0f, 0.0f);


}
/* end of file */