/*
 *
 * File: RFEmptyPanel.java
 * Date: Aug 18, 2008; 4:29:41 PM
 */
package de.desy.mst.libs.accelerator.view.container;

import java.awt.Dimension;

import javax.swing.JComponent;

import de.desy.mst.libs.accelerator.EViewElement;
import de.desy.mst.libs.accelerator.IEData;
import de.desy.mst.libs.accelerator.IEValue;
import de.desy.mst.libs.accelerator.view.IViewComponent;
import de.desy.mst.libs.accelerator.view.IViewContainer;
import de.desy.mst.libs.accelerator.view.generic.RFPanel;

/**
 * Draws an empty panel.
 *
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: RFEmptyPanel.java 20008 2009-01-05 12:21:06Z walla $
 */
public final class RFEmptyPanel extends RFPanel implements IViewContainer
{
	/** This is the current unique serial version UID. It helps the application
	 * to control serialization compatibility between versions. */
	public static final long serialVersionUID = 3156520345665302193l;

	/**
	 * Draws a container with an empty panel.
	 */
	public RFEmptyPanel()
	{
		super();
	}

	/**
	 * Draws a container with an empty panel of the commited dimension.
	 *
	 * @param dim_ Dimension of the empty panel.
	 */
	public RFEmptyPanel(final Dimension dim_)
	{
		super(dim_);
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.accelerator.view.IViewContainer#getBoolean(de.desy.mst.libs.accelerator.IEValue, de.desy.mst.libs.accelerator.EViewElement)
	 */
	public boolean getBoolean(final IEValue container_,
			final EViewElement element_)
	{
		return false;
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.accelerator.view.IViewContainer#getComponent(de.desy.mst.libs.accelerator.IEValue, de.desy.mst.libs.accelerator.IEData)
	 */
	public IViewComponent getComponent(final IEValue container_,
			final IEData data_)
	{
		return this;
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.accelerator.view.IViewContainer#getPanel()
	 */
	public JComponent getPanel()
	{
		return this;
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.accelerator.view.IViewContainer#getValue(de.desy.mst.libs.accelerator.IEValue)
	 */
	public Number getValue(final IEValue container_)
	{
		throw new RuntimeException("This method is not implemented!");
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.accelerator.view.IViewContainer#reset(de.desy.mst.libs.accelerator.IEValue)
	 */
	public void reset(final IEValue container_)
	{
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.accelerator.view.IViewContainer#setBoolean(de.desy.mst.libs.accelerator.IEValue, de.desy.mst.libs.accelerator.EViewElement, boolean)
	 */
	public void setBoolean(final IEValue container_,
			final EViewElement element_, final boolean value_)
	{
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.libs.accelerator.view.IViewContainer#setValue(de.desy.mst.libs.accelerator.IEValue, java.lang.Number)
	 */
	public void setValue(final IEValue element_, final Number value_)
	{
	}
}
/* end of file */