/*
 * 	Oct 16, 2006 - Oct 16, 2006	ws:	removed Guilleaumes (-> Markus Walla)
 * 	Dec 13, 2006 - Dec 13, 2006	ws: afterFrameCreated package private -> protected
 * 	Nov 27, 2007 - Nov 27, 2007	ws: Server haben als Default keinen CrashFrame
 *	Feb 15, 2008 - Feb 15, 2008 ws: added "@Override"es
 * 	Oct 30, 2008 - Oct 30, 2008	ws:	addToCAM macht nichts da Server nicht unter CAM
 * 	Dec 18, 2008 - Dec 18, 2008	ws:	addToCAM returns now void, msg formatiert
 * 	Jun  8, 2009 - Jun  8, 2009	ws:	getJList... private -> package private (so i can test for MaWe Problem)
 * 	Jan 28, 2013 - Jan 28, 2013:	added in initialize() Main.registerForOnExit(this);
 */
package de.desy.mst.libs.framework.mstapp;

import java.awt.Container;
import java.util.Date;

import de.desy.mst.libs.framework.mstapp.MstApp.Typ;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.logging.gui.SwingLoggerManager;
import de.desy.mst.libs.framework.mstapp.mode.OpMode;
import de.desy.mst.libs.framework.mstapp.mode.OpModeListe;
import de.desy.mst.libs.framework.mstapp.mode.ServerAnwahlListe;
import de.desy.mst.libs.framework.mstapp.preferences.IPreferences;
import de.desy.mst.libs.framework.mstapp.preferences.implementation.optionPanels.PrefPositionServer;
import de.desy.mst.libs.framework.mstapp.server.ServerIcon;
import de.desy.mst.libs.framework.mstapp.server.ServerState;
import de.desy.mst.libs.framework.mstapp.util.MstDateFormat;

import javax.swing.JPanel;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.JLabel;
import javax.swing.SwingUtilities;

import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.Rectangle;

/**
 *
 * Basisklasse fuer alle Mst Standard Server Applikationen.
 * Dies ist der Haupt JFrame (in VB Sprache Hauptform).
 * Ableitungen (extends) hiervon werden mit Main "class name" gestartet
 *
 * @author hinsch
 *
 */
@SuppressWarnings({"rawtypes"})
public class MstServerFrameMain extends MstFrameMain implements IOnExit{
	public static final int MAX_SERVER_NO = 35;
	private static final long serialVersionUID = 1L;	//guter Java Stil, da Serializable
	private static final ServerAnwahlListe implementierteServerAnwahlen = ServerAnwahlListe.D_;  //  @jve:decl-index=0:
	private static final OpModeListe implementierteOpModes = OpModeListe.BBE;  //  @jve:decl-index=0:
	private SwingLoggerManager swingLoggerManagerKommandos = null;  //  @jve:decl-index=0:
	private SwingLoggerManager swingLoggerManagerEreignisse = null;
	public  int		serverPosition;			//pseudoFinal wird genau einmal vom user gesetzt
	public  int		xtraServiceWidth  = 0;	    //>0 extra Breite im service Mode
	public  int		xtraServiceHeight = 0;	    //>0 extra Hhe   im service Mode
	public  ServerState serverState;
	private String title;
	private String lastCommand;
//	private int updateInterval = 1000;	//mS onUpdate Intervall
	private String deviceBus = "nicht initialisiert";  //  @jve:decl-index=0:
	private boolean iconized = true;
	private boolean frameCreationReady = false;
	private Date startTime = null;
	private Date endTime = null;  //  @jve:decl-index=0:
//	private long timeBeforeOperation = 0;
//	private long timeAfterOperation = 0;
//	private CLUpdate updateTimer = null;  //  @jve:decl-index=0:
	private JPanel jPanelHauptLayoutServer = null;
	private JPanel jPanelGemeinsamerBereich = null;
	private JPanel jPanelServiceBereich = null;
	private JPanel jPanelKommandos = null;
	private JPanel jPanelEreignisse = null;
	private JScrollPane jScrollPaneKommandos = null;
	private JScrollPane jScrollPaneEreignisse = null;
	private JList jListKommandos = null;
	private JList jListEreignisse = null;
	private JLabel jLabelMaschine = null;
	private JLabel jLabelImage = null;
	private JPanel jPanelNotizen = null;
	private JLabel jLabelStart = null;
	private JLabel jLabelBus = null;
	private JLabel jLabelLetzteAktion = null;
	private JLabel jLabelLetztesUpdate = null;
	private JLabel jLabelAktion = null;
	private JLabel jLabelLabelStartValue = null;
	private JLabel jLabelBusValue = null;
	private JLabel jLabelLetztesUpdateValue = null;
	private JLabel jLabelLetzteAktionValue = null;
	public MstServerFrameMain(final MstApp mstApp) {
		super(mstApp);
		mstApp.setTyp(Typ.SERVER);
		initialize();
	}
	public MstServerFrameMain(){
        initialize();
	}
	/**
	 * Ueberschreiben fuer Aufraeumarbeiten
	 * , zum beenden {@link System#exit(int)} verwenden
	 */
	@Override public void onExit(){

	}

	@Override protected void onTimer() {
		super.onTimer();
		SwingUtilities.invokeLater(new Runnable(){	//Damit im es im EDT (Event Dispatch Thread) ausgefhrt wird
			@Override public void run() {
				if (MstServerFrameMain.this.frameCreationReady == true && MstServerFrameMain.this.isInsideVisualEditor == false){
					if (MstServerFrameMain.this.iconized == true){
						MstServerFrameMain.this.setTitle(MstDateFormat.KURZ.format(new Date()));
					}
				}
			}
		});
	}
	@Override public void onOpModeChange(final OpMode opMode) {
		super.onOpModeChange(opMode);
		if(opMode == OpMode.EXPERT){
			setBounds(Screen.SERVER.calcServiceRectangle(getXtraServiceWidth(), getXtraServiceHeight()));
		}else{
			if(this.iconized == false){ 
				setBounds(Screen.SERVER.calcNormalRectangle());
			}else{
				setBounds(Screen.SERVER.calcIconRectangle(getServerPosition()));
			}
		}
	}
//	=============================================================================

	private void initialize() {
		UncaughtExceptionHandler.setShowMsgBox(false);
		setSize(new java.awt.Dimension(Screen.SERVER.NORMAL_WIDTH,Screen.SERVER.SERVICE_HEIGHT));
		setPreferredSize(new java.awt.Dimension(Screen.SERVER.NORMAL_WIDTH,Screen.SERVER.SERVICE_HEIGHT));
		setContentPane(getJPanelHauptLayoutServer());
		setTitle("Server Framework");
//		setJMenuMaschineVisible(false);	//Sollte automatisch via nur eine Maschine gehen
		this.title = getMstApp().getMaschineMgr().getMaschine().getLangenNamen() + " " + getMstApp().getStartParameter().appName;
		this.jLabelMaschine.setText(this.title);
		getMstApp().setImplServerAnwahlen(implementierteServerAnwahlen);
		getMstApp().setImplOpModes(implementierteOpModes);
//		if(isInsideVisualEditor == false){setVisible(true);}
		this.addWindowListener(new java.awt.event.WindowAdapter() {
			@Override public void windowDeiconified(final java.awt.event.WindowEvent e) {
				//Der Frame wird wieder ist wieder "NORMAL".
				setBounds(Screen.SERVER.calcIconRectangle(getServerPosition()));
				MstServerFrameMain.this.iconized = true;
			}
			@Override public void windowIconified(final java.awt.event.WindowEvent e) {
				//Der Minimized-Button wurde geklickt.
				MstServerFrameMain.this.setExtendedState(NORMAL);
				getMstApp().setOpMode(OpMode.BETRACHTEN);
			}
		});
		this.addComponentListener(new java.awt.event.ComponentAdapter() {
			@Override public void componentResized(final java.awt.event.ComponentEvent e) {
				if(MstServerFrameMain.this.getExtendedState() == MAXIMIZED_BOTH){
					//MAXIMIZED auf NORMAL setzen
					//aus dem "Icon" wird der grere Frame.
//					MstServerFrameMain.this.setVisible(false);
					MstServerFrameMain.this.setExtendedState(NORMAL);
					MstServerFrameMain.this.setBounds(Screen.SERVER.calcNormalRectangle());
					MstServerFrameMain.this.iconized = false;
					MstServerFrameMain.this.setTitle(MstServerFrameMain.this.title);
					getMstApp().setOpMode(OpMode.BETRACHTEN);
				}
//				MstServerFrameMain.this.setVisible(true);
			}
		});
		
		Main.registerForOnExit(this);
	}
	/**
	 * This method initializes jPanelNotizen
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanelNotizen() {
		if (this.jPanelNotizen == null) {
			this.jLabelLetzteAktionValue = new JLabel();
			this.jLabelLetzteAktionValue.setBounds(new java.awt.Rectangle(116,90,125,18));
			this.jLabelLetzteAktionValue.setText("---");
			this.jLabelLetztesUpdateValue = new JLabel();
			this.jLabelLetztesUpdateValue.setBounds(new Rectangle(116, 65, 179, 18));
			this.jLabelLetztesUpdateValue.setText("---");
			this.jLabelBusValue = new JLabel();
			this.jLabelBusValue.setBounds(new java.awt.Rectangle(116,43,125,18));
			this.jLabelBusValue.setText("---");
			this.jLabelLabelStartValue = new JLabel();
			this.jLabelLabelStartValue.setBounds(new java.awt.Rectangle(116,21,125,18));
			this.jLabelLabelStartValue.setText("---");
			this.jLabelLetztesUpdate = new JLabel();
			this.jLabelLetztesUpdate.setBounds(new java.awt.Rectangle(8,65,94,18));
			this.jLabelLetztesUpdate.setText("Letztes Update:");
			this.jLabelLetzteAktion = new JLabel();
			this.jLabelLetzteAktion.setBounds(new java.awt.Rectangle(9,90,88,18));
			this.jLabelLetzteAktion.setText("Letzte Aktion:");
			this.jLabelBus = new JLabel();
			this.jLabelBus.setBounds(new java.awt.Rectangle(8,43,76,18));
			this.jLabelBus.setText("Gertebus:");
			this.jLabelStart = new JLabel();
			this.jLabelStart.setBounds(new java.awt.Rectangle(8,21,55,18));
			this.jLabelStart.setText("Start:");
			this.jPanelNotizen = new JPanel();
			this.jPanelNotizen.setLayout(null);
			this.jPanelNotizen.setBounds(new java.awt.Rectangle(201,8,420,114));
			this.jPanelNotizen.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Status:", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", java.awt.Font.BOLD, 12), null));
			this.jPanelNotizen.add(this.jLabelStart, null);
			this.jPanelNotizen.add(this.jLabelBus, null);
			this.jPanelNotizen.add(this.jLabelLetzteAktion, null);
			this.jPanelNotizen.add(this.jLabelLetztesUpdate, null);
			this.jPanelNotizen.add(this.jLabelLabelStartValue, null);
			this.jPanelNotizen.add(this.jLabelBusValue, null);
			this.jPanelNotizen.add(this.jLabelLetztesUpdateValue, null);
			this.jPanelNotizen.add(this.jLabelLetzteAktionValue, null);
		}
		return this.jPanelNotizen;
	}
	/**
	 * @param args
	 * @author K. Hinsch -mst1-
	 * @task
	 */
	/*
	 * Vers		Date				Description
	 *  01	Jul 14, 2006	Methode erstellt
	 */
//	public static void main(String[] args) {
//		Main.startMSTApp(MstServerFrameMain.class.getName(), "Server Template", "MST");
//	}
	/**
	 * This method initializes jContentPane
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanelHauptLayoutServer() {
		if (this.jPanelHauptLayoutServer == null) {
			this.jPanelHauptLayoutServer = new JPanel();
			this.jPanelHauptLayoutServer.setLayout(new BorderLayout());
			this.jPanelHauptLayoutServer.setPreferredSize(new java.awt.Dimension(Screen.SERVER.NORMAL_WIDTH,Screen.SERVER.SERVICE_HEIGHT));
			this.jPanelHauptLayoutServer.add(getJPanelGemeinsamerBereich(), java.awt.BorderLayout.NORTH);
			this.jPanelHauptLayoutServer.add(getJPanelServiceBereich(), java.awt.BorderLayout.CENTER);
		}
		return this.jPanelHauptLayoutServer;
	}
	/**
	 * This method initializes jPanelGemeinsamerBereich
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanelGemeinsamerBereich() {
		if (this.jPanelGemeinsamerBereich == null) {
			this.jLabelAktion = new JLabel();
			this.jLabelAktion.setBounds(new java.awt.Rectangle(0, 108, Screen.SERVER.ICON_SIZE,17));
			this.jLabelAktion.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			this.jLabelAktion.setText("Server State");
			this.jLabelImage = new JLabel();
			this.jLabelImage.setBounds(new java.awt.Rectangle((Screen.SERVER.ICON_SIZE - 80) / 2, 26, 80,80));
			this.jLabelImage.setOpaque(true);
			this.jLabelImage.setBackground(java.awt.Color.white);
			this.jLabelImage.setIconTextGap(0);
			this.jLabelImage.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			this.jLabelMaschine = new JLabel();
			this.jLabelMaschine.setBounds(new java.awt.Rectangle(0,2,Screen.SERVER.ICON_SIZE,22));
			this.jLabelMaschine.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
			this.jLabelMaschine.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			this.jLabelMaschine.setText("Server Aufgabe");
			this.jPanelGemeinsamerBereich = new JPanel();
			this.jPanelGemeinsamerBereich.setLayout(null);
			this.jPanelGemeinsamerBereich.setPreferredSize(new java.awt.Dimension(534,454));
			this.jPanelGemeinsamerBereich.add(getJPanelKommandos(), null);
			this.jPanelGemeinsamerBereich.add(getJPanelEreignisse(), null);
			this.jPanelGemeinsamerBereich.add(this.jLabelMaschine, null);
			this.jPanelGemeinsamerBereich.add(this.jLabelImage, null);
			this.jPanelGemeinsamerBereich.add(getJPanelNotizen(), null);
			this.jPanelGemeinsamerBereich.add(this.jLabelAktion, null);
		}
		return this.jPanelGemeinsamerBereich;
	}
	/**
	 * This method initializes jPanelServiceBereich
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanelServiceBereich() {
		if (this.jPanelServiceBereich == null) {
			this.jPanelServiceBereich = new JPanel();
			this.jPanelServiceBereich.setLayout(null);
			this.jPanelServiceBereich.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Expert:", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", java.awt.Font.BOLD, 12), null));
			this.jPanelServiceBereich.setPreferredSize(new java.awt.Dimension(236,236));
			this.jPanelServiceBereich.setOpaque(false);
		}
		return this.jPanelServiceBereich;
	}
	/**
	 * This method initializes jPanelKommandos
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanelKommandos() {
		if (this.jPanelKommandos == null) {
			this.jPanelKommandos = new JPanel();
			this.jPanelKommandos.setLayout(null);
			this.jPanelKommandos.setBounds(new Rectangle(9, 128, 612, 161));
			this.jPanelKommandos.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Kommandos:", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", java.awt.Font.BOLD, 12), null));
			this.jPanelKommandos.add(getJScrollPaneKommandos(), null);
		}
		return this.jPanelKommandos;
	}
	/**
	 * This method initializes jPanelEreignisse
	 *
	 * @return javax.swing.JPanel
	 */
	private JPanel getJPanelEreignisse() {
		if (this.jPanelEreignisse == null) {
			this.jPanelEreignisse = new JPanel();
			this.jPanelEreignisse.setLayout(null);
			this.jPanelEreignisse.setBounds(new java.awt.Rectangle(9,294,612,161));
			this.jPanelEreignisse.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Ereignisse:", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", java.awt.Font.BOLD, 12), null));
			this.jPanelEreignisse.add(getJScrollPaneEreignisse(), null);
		}
		return this.jPanelEreignisse;
	}
	/**
	 * This method initializes jScrollPaneKommandos
	 *
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPaneKommandos() {
		if (this.jScrollPaneKommandos == null) {
			this.jScrollPaneKommandos = new JScrollPane();
			this.jScrollPaneKommandos.setBounds(new java.awt.Rectangle(8,19,595,131));
			this.jScrollPaneKommandos.setViewportView(getJListKommandos());
		}
		return this.jScrollPaneKommandos;
	}
	/**
	 * This method initializes jScrollPaneEreignisse
	 *
	 * @return javax.swing.JScrollPane
	 */
	private JScrollPane getJScrollPaneEreignisse() {
		if (this.jScrollPaneEreignisse == null) {
			this.jScrollPaneEreignisse = new JScrollPane();
			this.jScrollPaneEreignisse.setBounds(new java.awt.Rectangle(8,19,595,131));
			this.jScrollPaneEreignisse.setViewportView(getJListEreignisse());
		}
		return this.jScrollPaneEreignisse;
	}
	/**
	 * This method initializes jListKommandos
	 *
	 * @return javax.swing.JList
	 */
	JList getJListKommandos() {
		if (this.jListKommandos == null) {
			this.jListKommandos = new JList();
			this.jListKommandos.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
			this.jListKommandos.setName("Liste der Kommandos");
	        getSwingLoggerManagerKommandos().register(this.jListKommandos);
	        Main.registerForOnExit( new IOnExit(){
	        	@Override public void onExit() {getSwingLoggerManagerKommandos().deregister(MstServerFrameMain.this.jListKommandos);}
	        });

		}
		return this.jListKommandos;
	}
	/**
	 * This method initializes jListEreignisse
	 *
	 * @return javax.swing.JList
	 */
	JList getJListEreignisse() {
		if (this.jListEreignisse == null) {
			this.jListEreignisse = new JList();
			this.jListEreignisse.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
			this.jListEreignisse.setName("Liste der Ereignisse");
	        getSwingLoggerManagerEreignisse().register(this.jListEreignisse);
	        Main.registerForOnExit( new IOnExit(){
	        	@Override public void onExit() {getSwingLoggerManagerEreignisse().deregister(MstServerFrameMain.this.jListEreignisse);}
	        });

		}
		return this.jListEreignisse;
	}
	public final ServerState getServerState() {
		return this.serverState;
	}
	public final void setServerState(final ServerState serverState) {
		this.serverState = serverState;
		this.jLabelAktion.setText(serverState.getLangenNamen());
		this.jLabelAktion.setForeground(serverState.getForeColor());
	}
	/** >=0 Position des IkonFrames*/
	public int  getServerPosition() {return this.serverPosition;}
	/**zwischen 1 und MAX_SERVER_NO*/
	public void setServerPosition(int serverNo){
		if(serverNo < 1){
			serverNo = 1;
			Logger.SWFW.warn("Die erste erlaubte ServerNo ist 1. Die serverNo auf 1 gesetzt.");
		}
		else if(serverNo > MAX_SERVER_NO){
			serverNo = MAX_SERVER_NO;
			Logger.SWFW.warn("Die hchste erlaubte ServerNo ist 35. Die serverNo auf 35 gesetzt.");
		}
		this.serverPosition = serverNo;
		if(this.iconized == true || this.frameCreationReady == false){
			setBounds(Screen.SERVER.calcIconRectangle(this.serverPosition));
		}
	}
	public String getDeviceBus() {
		return this.deviceBus;
	}
	public void setDeviceBus(final String deviceBus) {
		this.deviceBus = deviceBus;
	}
	public int getXtraServiceHeight() {
		return this.xtraServiceHeight;
	}
	private void setXtraServiceHeight(final int xtraServiceHeight) {
		if(xtraServiceHeight >0 )
			this.xtraServiceHeight = xtraServiceHeight;
	}
	public int getXtraServiceWidth() {
		return this.xtraServiceWidth;
	}
	private void setXtraServiceWidth(final int xtraServiceWidth) {
		if(xtraServiceWidth >0 )
			this.xtraServiceWidth = xtraServiceWidth;
	}
	public void afterUpdate(final Date endTime){
		this.endTime = endTime;
		final String updateDuration = MstDateFormat.KURZ.format(endTime) + ", " + (this.endTime.getTime() - this.startTime.getTime()) + " ms";
		this.jLabelLetztesUpdateValue.setText(updateDuration);
//		if(updateDuration > this.getUpdateInterval()){
//			Logger.SWFW.error("Update > " + String.valueOf(this.getUpdateInterval()));
//		}
		setServerState(ServerState.IDL);
	}
	public void beforeUpdate(final Date startTime){
		this.startTime = startTime;
		setServerState(ServerState.UPDATE);
	}
//	public void onUpdate(){}
//	public void afterOperation(){
//		timeAfterOperation = System.currentTimeMillis();
//		float operatingDuration = (float)(timeAfterOperation - timeBeforeOperation);
//		jLabelLetzteAktionValue.setText(getLastCommand() + ", " + String.valueOf(operatingDuration / 1000) + " Sek.");
//		if(updateTimer.isInterrupted() == true){
//			updateTimer.run();
//		}
//		setServerState(ServerState.IDL);
//	}
//	public void beforeOperation(String kommando, String absender, boolean stopUpdate){
//		setServerState(ServerState.OPERATING);
//		if(stopUpdate == true){
//			updateTimer.interrupt();
//		}
//		setLastCommand(kommando);
//		Logger.AUFTRAG.info(kommando + "  " + absender);
//		timeBeforeOperation = System.currentTimeMillis();
//	}
	@Override protected void afterFrameCreated() {
		setXtraServiceHeight(getHeight() - Screen.SERVER.SERVICE_HEIGHT);//ndererungen gegenber der festgelegten ServiceHeight ermitteln.
		if(Math.abs(getXtraServiceHeight()) < 10){setXtraServiceHeight(0);}//kleine, unbeabsichtigte nderungen zurcksetzen.
		setXtraServiceWidth(getWidth() - Screen.SERVER.SERVICE_WIDTH);//ndererungen gegenber der festgelegten ServiceWidth ermitteln.
		if(Math.abs(getXtraServiceWidth()) < 10){setXtraServiceWidth(0);}//kleine, unbeabsichtigte nderungen zurcksetzen.
		this.jLabelBusValue.setText(getDeviceBus());//Devicebus in den Label eintragen.
		this.jLabelLabelStartValue.setText(MstDateFormat.KURZ.format(new Date()));//Startzeit eintragen.
		super.afterFrameCreated();//setvisible(true) des Frameworks.
		if(this.serverPosition == 0){
			this.serverPosition = 1;
		}
		setBounds(Screen.SERVER.calcIconRectangle(this.serverPosition));//Als Icon starten.
		setServerState(ServerState.IDL);//Server bereit.
//		updateTimer = new CLUpdate(this.updateInterval);
//		updateTimer.start() ;
		this.jLabelImage.setIcon(new ServerIcon(MstServerFrameMain.this.getIconImage(), this.jLabelImage.getWidth(), this.jLabelImage.getHeight()));
		this.frameCreationReady = true;//alles fertig.
	}

	@Override void addToCAM(final Frame frame) {
		Logger.SWFW.info( CAMFRAME_CONTROL_MSG_PREFIX
						+ "MstServerFrameMain.addToCAM(...) tut rein gar"
						+ " nichts, da Server nicht von CAM kontrolliert "
						+ "werden sollen (KH 2008-10-30).");
	}
	@Override
	public void setContentPane(final Container contentPane) {
//		super.setContentPane(contentPane);
		if((this.jPanelHauptLayoutServer == null)||(this.jPanelHauptLayoutServer == contentPane)){
			super.setContentPane(contentPane);
		}else{
			this.jPanelHauptLayoutServer.add(contentPane, java.awt.BorderLayout.CENTER);
		}
	}
	@Override
	public void setContentPaneMST(final JPanel contentPane) {
		super.setContentPaneMST(contentPane);
		this.jPanelServiceBereich.setPreferredSize(new java.awt.Dimension(236,236));
		this.jPanelServiceBereich = contentPane;
	}
//	public int getUpdateInterval() {
//		return updateInterval;
//	}
//	public void setUpdateInterval(int updateInterval) {
//		this.updateInterval = updateInterval;
//	}
	public SwingLoggerManager getSwingLoggerManagerKommandos(){
	    if(this.swingLoggerManagerKommandos == null){
	    	final int CAPACITY = 100;
	    	final Logger kategorie = Logger.AUFTRAG;
	        this.swingLoggerManagerKommandos = new SwingLoggerManager(getMstApp(), CAPACITY, kategorie);
	        this.swingLoggerManagerKommandos.setEnsureLastElementIsVisible(true);
	    }
	    return this.swingLoggerManagerKommandos;
	}
	public SwingLoggerManager getSwingLoggerManagerEreignisse(){
	    if(this.swingLoggerManagerEreignisse == null){
	    	final int CAPACITY = 100;
	    	final Logger kategorie = Logger.SWApp;
	        this.swingLoggerManagerEreignisse = new SwingLoggerManager(getMstApp(), CAPACITY, kategorie);
	        this.swingLoggerManagerEreignisse.setEnsureLastElementIsVisible(true);
	    }
	    return this.swingLoggerManagerEreignisse;
	}
	public String getLastCommand() {
		return this.lastCommand;
	}
//	private void setLastCommand(String lastCommand) {
//		this.lastCommand = lastCommand;
//	}
	@Override
	protected IPreferences createPrefPosition() {
		return new PrefPositionServer(this);
	}


}  //  @jve:decl-index=0:visual-constraint="10,10"
