/**
 * 	Feb 1, 2012 - Feb 2, 2012	ws:	created from scratch
 */
package de.desy.mst.libs.framework.mstapp;

import java.awt.Dimension;
import java.awt.Toolkit;

/**
 * Here is the referenceScreenSize for the {@link Screen} class defined.
 * <br> It has only an effect if called before {@link Screen} is used.
 * 		A good plase is the entry function main(args)
 * <br> Default is the true screen size of the current monitor.
 * <br> If you use absolute layout you might want to use 
 *      {@link ScreenIni#BKR_SCREENSIZE} by calling <b>very early</b>:
 *      {@link ScreenIni#setReferenceScreenSizeToBKRScreenSize()} 
 * <br> If you use relative layout you might want to use 
 *      {@link ScreenIni#BKR_SCREENSIZE} by calling <b>very early</b>:
 *      {@link ScreenIni#setReferenceScreenSizeToTrueScreenSize()} 
 *      
 * @author ws
 */
public class ScreenIni {
	private static volatile Dimension referenceScreenSize;
	static{setReferenceScreenSizeToBKRScreenSize();}
	//-------------------------------------------------------------------------
	public static Dimension getReferenceScreenSize() {return ScreenIni.referenceScreenSize;}
	
	public static void setReferenceScreenSizeToBKRScreenSize(){
		setReferenceScreenSize(new Dimension(1280, 1024));
	}
	public static void setReferenceScreenSizeToTrueScreenSize(){
		setReferenceScreenSize(Toolkit.getDefaultToolkit().getScreenSize());
	}
	public static void setReferenceScreenSize(final Dimension referenceScreenSize) {
		if(referenceScreenSize == null)
			throw new NullPointerException();
		ScreenIni.referenceScreenSize = referenceScreenSize;
	}
}
