/**
 * 
 * Last changed: $Date$
 * By: $Author$
 * URL: $HeadURL$
 * $Revision$ 
 *	Aug 19, 2001 - Aug 19, 2001	ws	changed: getMain() ... auskommentiert nach  
 *									AnLa abspr., da noch nicht implementiert
 */
package de.desy.mst.libs.framework.mstapp.appinf;




/**
 * Definiert, welche Informationen ueber die Applikation vorhanden ist.
 * Dieses Interface befindet sich noch in der Entwicklung.
 * Ggf. werden weitere Methoden fuer weitere Informnationen hinzugefuegt.
 * Jede Methode kann als Ergebniss null liefern, wenn die Information nicht definiert ist 
 * oder eine Exception gefangen wurde.
 * @author labudda
 *
 */
public interface IApp {
	/**
	 * @return Titel der Applikation, wie er auch in den Shortcuts erzeugt wird
	 */
	String getTitle();
	/**
	 * @return Name der Applikation inklusive Pfad ohne host
	 */
	String getName();
	/**
	 * @return Versionsnummer der Applikation
	 */
	String getVersion();
	/**
	 * @return Auflistung aller benutzten jar resourcen
	 */
	java.util.Collection<ILib> getJars();
	/**
	 * @return Name der Hilfeseite
	 */
	String getHelp();
	
	/**
	 * @return Vollstaendiger Pfad zur Hilfeseite
	 */
	String getHelpUrl();
	
	/**
	 * @return url zur Hilfeseite ohne die Hilefeseite selbst
	 */
	String getHelpBase();
	
	String getDescription();
	/**
	 * @return Information to contact applications developer
	 */
	IContactInformation getContact();
	
	/**
	 * @return the applikations icon or null
	 */
	javax.swing.ImageIcon getIcon();
	/**
	 * @return Beschreibung, warum eine neue Version erzeugt wurde 
	 */
	String getReleaseReason();
	/**
	 * @return Zeitpunkt des releases.
	 * Der Release Zeitpunkt ist im Allgemeinen definiert durch die letzte Aenderung in der Datei buildNumber 
	 * in dem Element des Build Paths, das die zu startende Main routine enthaelt.
	 */
	String getReleaseTimestamp();
	/**
	 * @return Zeitstempel der 'ausfuehrbaren' Datei
	 */
	String getFileTimestamp();
//	/**
//	 * @return name of main class to startup
//	 */
//	String getMain();
	/**
	 * @return true, if at least the name is defined
	 */
	public boolean isInformationValid();

}
