/**
 * 
 * Last changed: $Date$
 * By: $Author$
 * URL: $HeadURL$
 * $Revision$ 
 *
 */
package de.desy.mst.libs.framework.mstapp.appinf;

/**
 * @author labudda
 * Information ueber eine benutzte Bibliothek der Applikation
 */
public interface ILib {

	/**
	 * @return Name der Bibliothek inkllusive Pfad ohne host
	 */
	String getName();
	/**
	 * @return Build Date
	 */
	String getDate();
	/**
	 * @return Major version number 
	 * modified by developer in build.number 
	 */
	int getMajor();
	/**
	 * @return Minor version number
	 * modified by developer in build.number 
	 */
	int getMinor();
	/**
	 * @return Revision number.
	 * Modified in build.number
	 * incremented on every release by build and deply
	 * might be modified by developer
	 */
	int getRevision();
	/**
	 * @return build.number
	 * Modified in build.number
	 * incremented on every build by build and deploy
	 * should not be modified by developer
	 */
	int getBuild();
}
