/**
 * 
 * Last changed: $Date$
 * By: $Author$
 * URL: $HeadURL$
 * $Revision$ 
 *
 */
package de.desy.mst.libs.framework.mstapp.appinf.client;

import de.desy.mst.libs.framework.mstapp.appinf.AApp;
import de.desy.mst.libs.framework.mstapp.appinf.ContactInformation;
import de.desy.mst.libs.framework.mstapp.appinf.IContactInformation;
import de.desy.mst.libs.framework.mstapp.appinf.ILib;
import de.desy.mst.libs.framework.mstapp.appinf.Lib;



/**
 * @author labudda
 *
 */
class ClientApp extends  AApp {
	private final IJNLPClassLoader cl;
	public ClientApp() {
		this.cl = new JNLPClassLoaderDelegated();
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.auxiliary.devl.versions.information.IApp#getHelp()
	 */
	@Override public String getHelp() {
		return this.cl.getLaunchDesc().getInformation().getHome().toExternalForm();
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.auxiliary.devl.versions.information.IApp#getJars()
	 */
	@Override public java.util.Collection<ILib> getJars() {
		try {
			final IJARDesc[] jds = this.cl.getLaunchDesc().getResources().getLocalJarDescs();
			final java.util.ArrayList<ILib> libs = new java.util.ArrayList<ILib>(jds.length);
			for (final IJARDesc jd :jds) {
				final java.util.jar.JarFile jar = this.cl.getJarFile(jd.getLocation());
				libs.add(new Lib(jar, jd.getLocation().toExternalForm()));
			}
			return libs;
		} catch (final Exception e) {
			// The application shall not fail if display is not accessible
			System.err.print("Catched exception at '" + this.getClass().getSimpleName() + "': " + e.getMessage());
			System.err.flush();
			// nach Ruecksprache mit Winfried wird null von der aufrufenden Methode richtig weiterverarbeitet.
			// Alternative waere eine leere Collection
			return null;
		}
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.auxiliary.devl.versions.information.IApp#getName()
	 */
	@Override public String getName() {
		// FIXME: see name vs. title
		return this.cl.getLaunchDesc().getAppInfo().getTitle();
	}

	/* (non-Javadoc)
	 * @see de.desy.mst.auxiliary.devl.versions.information.IApp#getVersion()
	 */
	@Override public String getVersion() {
		return this.cl.getLaunchDesc().getVersion();
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.auxiliary.devl.versions.information.IApp#getDescription()
	 */
	@Override public String getDescription() {
		return this.cl.getLaunchDesc().getInformation().getDescription();
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.IApp#getContact()
	 */
	@Override public IContactInformation getContact() {
		return new ContactInformation(this.cl.getLaunchDesc().getInformation().getVendor());
	} 
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.IApp#getIcon()
	 */
	@Override public javax.swing.ImageIcon getIcon() {
		final java.net.URL path = this.cl.getLaunchDesc().getInformation().getIcons()[0].getLocation();
		return new javax.swing.ImageIcon(path);
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.IApp#getTitle()
	 */
	@Override public String getTitle() {
		return this.cl.getLaunchDesc().getAppInfo().getTitle();
	}

}
