/*
 * Created on
 * Feb 2-9, 2005, Jun 30 2005
 * Jan  5, 2007 - ...		ws: exit jetzt mit Main.exit(0) statt Main Objekt
 * Aug 21, 2007 - Aug 24, 2007	ws:	add threadsafety, EDT Thread Stuff
 * 									add reserveFlashScreen support
 * Feb 28, 2008 - Mar  3, 2008	ws:	AL weist darauf hin dass Fenster entfernen
 * 									mstApp nicht stop: undecorate Fenster (no x)
 * 									add actionListener to Windows closing
 * 									(unresponsive), New Border
 * 								ws:	add IconImage
 * May 29, 2008 - May 29, 2008	ws: add IconImage via MstImage(name)
 * Nov 30, 2007 - Nov 30, 2007	ws:	field title
 */

package de.desy.mst.libs.framework.mstapp.flash;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.HeadlessException;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.lang.reflect.InvocationTargetException;

import javax.swing.BorderFactory;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.SwingUtilities;

import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.util.gui.MstImage;
import de.desy.mst.libs.framework.mstapp.Main;

/**
 * @author kh, ws
 */
public class MstFrameFlash extends JFrame implements IProgress{
	private static final long serialVersionUID = 1L;
	private static final Dimension dimension = Toolkit.getDefaultToolkit()
													  .getScreenSize();

	private final String name;
	private final String title;
	private int nReservations;	//@synchronized on this
	private JPanel jContentPane = null;
	private JLabel  jLabel1  = null;
	private JLabel  jLabel2 = null;
	private JButton jButton = null;
	private JProgressBar jProgressBar = null;
//=============================================================================
	public MstFrameFlash(final String appName, final String title) throws HeadlessException {
		super();
		this.name = appName;
		this.title = title;
		this.nReservations = 1;
		initialize();
	}
//=============================================================================
	/* (non-Javadoc)
	 * @see de.desy.mst.mstapp.IFlash#onProgress(de.desy.mst.mstapp.Progress)
	 */
	@Override public void onProgress(final Progress progress) {
		final JProgressBar progressBar = getJProgressBar();
		final JLabel       jlLabel2    = this.jLabel2;
		if(SwingUtilities.isEventDispatchThread()){
			onProgress_Work(progress, progressBar, jlLabel2);
			/**Problem wird erst zu spaet bearbeitet*/
			final String msg = "Progress Bar Update aus dem EDT aufgerufen."
							 + " Der Wunsch kommt an das EDT "
							 + " Ereignisschlangeende und damit wohl zu spt.";
			Logger.SWFW.warn(msg);
		}else{
			try {
				SwingUtilities.invokeAndWait(
					new Runnable(){
						@Override public void run() {
							onProgress_Work(progress, progressBar, jlLabel2);
						}//END run
								  }//END new Runnable()
										  );//END invokeAndWait(..)
			} catch (final InterruptedException e) {/**ignore*/
			} catch (final InvocationTargetException e) {
				Logger.SWFW.warn("UNEXPECTED EXCEPTION.", e);
			}
		}
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.flash.IProgress#reserveFlashScreen(boolean)
	 */
	@Override public synchronized int reserveFlashScreen(final boolean b) {
		if(b)	{this.nReservations++;}
		else	{this.nReservations--;}
//		final String msg = "MstFrameFlash.reserveFlashScreen"
//						 + " end nReservations " + nReservations;
//		Logger.SWFW.info(msg);
		return this.nReservations;
	}
//=============================================================================
	/**Thread Unabhaengige onProgress Arbeit*/
	private void onProgress_Work(final Progress progress
							   , final JProgressBar progressBar
							   , final JLabel jLabel2
							   ) {
		progressBar.setValue(progress.getProzentFertig());
		jLabel2.setText(progress.getName());
		progressBar.repaint();
		jLabel2.repaint();
	}

	private void initialize() {
        //this.setBackground(java.awt.Color.orange);
        this.setContentPane(getJContentPane());
        this.setSize(460, 160);
        this.setBounds((dimension.width-460)/2, (dimension.height-160)/2, 460, 160 );
      //this.setTitle("Flash Frame");
        this.setTitle(this.title);
        this.addWindowStateListener(new WindowAdapter(){
        	//!!!!!Vorsicht scheinen nie gerufen zu werden!!!!!!!!!!!!!!!!!!!!!
			@Override public void windowClosing(final WindowEvent e) {
				Logger.SWFW.info("Abort program via FlashFrame Close.");
				resetReservations();
				Main.exit(0);
			}
			//@Override public void windowStateChanged(WindowEvent e) {
			//	Logger.SWFW.fatal(">>>>>" + e.toString());
			//}

        });
		final MstImage mstImage = new MstImage(this.name, getClass());
		this.setIconImage(mstImage.createImage());

		this.setUndecorated(true);
        this.setVisible(true);
	}
	private JPanel getJContentPane() {
		if (this.jContentPane == null) {
			this.jLabel1 = new JLabel();
			this.jLabel1.setBounds(new java.awt.Rectangle(12,10,427,36));
			this.jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			this.jLabel1.setFont(new java.awt.Font("Dialog", java.awt.Font.BOLD, 14));
			this.jLabel1.setForeground(java.awt.Color.blue);
			this.jLabel1.setText(this.title);

			this.jLabel2 = new JLabel();
			this.jLabel2.setBounds(new java.awt.Rectangle(12,36,427,36));
			this.jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
			this.jLabel2.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 14));
			this.jLabel2.setForeground(java.awt.Color.black);
			this.jLabel2.setText("");

			this.jContentPane = new JPanel();
			this.jContentPane.setLayout(null);
			this.jContentPane.add(getJProgressBar(), null);
			this.jContentPane.add(this.jLabel1, null);
			this.jContentPane.add(this.jLabel2, null);
			this.jContentPane.add(getJButton(), null);
			final int nPixel = 2;
			this.jContentPane.setBorder(
						BorderFactory.createLineBorder(Color.DARK_GRAY, nPixel)
								  );
		}
		return this.jContentPane;
	}
	/**
	 * This method initializes jProgressBar
	 *
	 * @return javax.swing.JProgressBar
	 */
	private JProgressBar getJProgressBar() {
		if (this.jProgressBar == null) {
			this.jProgressBar = new JProgressBar();
			this.jProgressBar.setValue(0);
			this.jProgressBar.setBounds(new java.awt.Rectangle(114,72,212,25));
		}
		return this.jProgressBar;
	}
	/**
	 * This method initializes jButton
	 *
	 * @return javax.swing.JButton
	 */
	private JButton getJButton() {
		if (this.jButton == null) {
			this.jButton = new JButton();
			this.jButton.setBounds(new java.awt.Rectangle(151,99,148,18));
			this.jButton.setText("Programm beenden");
			this.jButton.addActionListener(new java.awt.event.ActionListener() {
				@Override public void actionPerformed(final java.awt.event.ActionEvent e) {
					Logger.SWFW.info("Abort program via FlashFrame Cancel.");
					resetReservations();
					Main.exit(0);
				}
			});
		}
		return this.jButton; 
	}
	private synchronized void resetReservations() {this.nReservations = 0;}
}  //  @jve:decl-index=0:visual-constraint="10,10"
