/**
 *  Created on Aug 15, 2005 - Aug 16, 2005
 *  ws: Jul  4, 2007 - Jul  4, 2007 update XTor
 *	Aug 29, 2007 - Aug 29, 2007 ws: String appName -> ApplicationInfo appInfo	
 *	Feb 15, 2008 - Feb 15, 2008 ws: added "@Override"es
 */
package de.desy.mst.libs.framework.mstapp.ini;

import de.desy.mst.libs.framework.mstapp.ApplicationInfo;

/**
 * Root Base Data for the MstIni Initialilsations
 * All those use MstIni as Root Container
 * @author ws
 * @version 1.0.0
 */
public abstract class ABaseDataOfMstIni extends ABaseData<MstIni> {
	public ABaseDataOfMstIni(final String name, final ApplicationInfo appInfo) {
		super(name, appInfo);
        setFileRoot(new MstIni(this));   
	}

//=============================================================================
	
	/**
	 * package private  
	 * @return s the application part of the standard ini object tree 
	 */
	final Object getContentRoot() {
		return getFileRoot().getContentRoot();
	}

//=============================================================================
	
	/* (non-Javadoc)
	 * @see de.desy.mst.mstapp.ini.IIniFileObserver#getDefaultIniBaumRoot()
	 */
	@Override public Object getDefaultIniBaumRoot() {
		return getFileRoot().getDefaultIniBaumRoot();
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.mstapp.ini.IIniFileObserver#onNewIniAvailable(java.lang.Object)
	 */
	@Override public void onNewIniAvailable(Object iniBaumRoot) {
		getFileRoot().onNewIniAvailable(iniBaumRoot);
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.mstapp.ini.IIniFileObserver#onPrepareForExport()
	 */
	@Override public Object onPrepareForExport() {
		return getFileRoot().onPrepareForExport();
	}
}
