/**
 * 	Jun 10, 2015 - Jun 10, 2015	ws:	created from scratch
 */
package de.desy.mst.libs.framework.mstapp.ini;

import java.util.List;
import java.util.concurrent.CopyOnWriteArrayList;

import de.desy.mst.libs.framework.mstapp.Main;
import de.desy.mst.libs.framework.mstapp.logging.Logger;

/**
 * Tracks the legacy SQL Server Web accesses.
 * <p>Should only modify via add
 * @author ws
 */
public class AccessedWebAdresses extends CopyOnWriteArrayList<String> {
	private static final long serialVersionUID = 1L;
	private static final List<AccessedWebAdresses> instances = 
												new CopyOnWriteArrayList<AccessedWebAdresses>();
	//---------------------------------------------------------------------------------------------
	public static final  String   totalToString() {
		String toString = "AccessedWebAdresses.totalToString() with " + totalSize() + " totalSize.";
		for (final AccessedWebAdresses instance : instances) 
			toString += "\n" + instance.toString();
		return toString + "\n";
	}
	public static final boolean hasAnyWebAccess() { return totalSize() > 0;}
	public static final     int       totalSize() {
		int totalSize = 0;
		for (final AccessedWebAdresses instance : instances) 
			totalSize += instance.size();
		return totalSize;
	}
	//=============================================================================================
	public final String ofClass;
	//---------------------------------------------------------------------------------------------
	public AccessedWebAdresses(final String ofClass) {this.ofClass = ofClass; instances.add(this);}
	//---------------------------------------------------------------------------------------------
	@Override public boolean add(final String webAddress) {
		final String msg = this.getClass().getSimpleName() 
				         + ".add(\"" + webAddress + "\") was called from " + this.ofClass + ".";
		final boolean expectToBeHere = Main.mstwebUsageSettings.isUse_mstweb4ini();
		if(expectToBeHere)
			Logger.SWFW.info(msg);
		else
			Logger.SWFW.error(msg);
		return super.add(webAddress);
	}
	@Override public String toString() {
		return "AccessedWebAdresses [ofClass=" + this.ofClass + "] " + size() + " number of times:"
			 + "\n" + super.toString()
			 + "\n"
			 ;
	}
}
