/*
 * May 26, 2005 - Jun 16, 2005		Created on 	
 * Aug. 15 2005 - ... 				derive from ABaseDataOfMstIni		
 * May 07, 2007 - ...			ws: added default XTOR  		
 * Jul 04, 2007 - ...			ws: update XTor, Name		
 * Aug 29, 2007 - Sep 13, 2007 	ws: String appName -> ApplicationInfo appInfo	
 * Dec 10, 2008 - Dec 10, 2008	ws:	MstSecurityMgr -> MstSecurity
 */
package de.desy.mst.libs.framework.mstapp.ini;

import de.desy.mst.libs.framework.mstapp.ApplicationInfo;
import de.desy.mst.libs.framework.mstapp.security.MstSecurity;

/**
 * User Files Have no Web Address
 * @author ws
 * @version 1.0.0
 */
/**
 * @author ws
 * @version 1.0.0
 */
class BaseDataForTheUser extends ABaseDataOfMstIni {
    public static final String FILETYP = "Benutzer Einstellungen";
    public static final String SHORTDESCRIPTION = FILETYP;
    public static final String NAME = "Benutzer";
    
    BaseDataForTheUser(ApplicationInfo appInfo)	{super(NAME, appInfo);}
//    BaseDataForTheUser() 				{this(Main.getAppName());}
//=============================================================================
    /* (non-Javadoc)
     * @see de.desy.mst.libs.framework.mstapp.ini.ABaseData#calcFileName(java.lang.String)
     */
    @Override protected String calcFileName(String appName) {
    	final PfadeIni pfadeIni = createPfadeIni();
    	return pfadeIni.getCacheDateiPfad();
        //return LocalHome.calcLocalUserPath(SRV_NAME, cleanAppname(appName), FILE_SUFFIX);
    }
    /* (non-Javadoc)
     * @see de.desy.mst.libs.framework.mstapp.ini.ABaseData#calcWebAddress()
     */
    @Override protected String calcWebAddress() {return "";}
    /* (non-Javadoc)
     * @see de.desy.mst.libs.framework.mstapp.ini.ABaseData#calcFileTyp()
     */
    @Override protected String calcFileTyp() {return FILETYP;}
    /* (non-Javadoc)
     * @see de.desy.mst.libs.framework.mstapp.ini.ABaseData#getShortDescription()
     */
    @Override public String getShortDescription() {return SHORTDESCRIPTION;}
//=============================================================================
	private PfadeIni createPfadeIni() {
		final String fileName = MstSecurity.get().getUser() + FILE_SUFFIX;
		return new PfadeIni(getApplicationInfo(), fileName);
	}
}
