/**
 * 	Jun 22, 2015 - Jun 22, 2015	ws:	created from scratch
 */
package de.desy.mst.libs.framework.mstapp.ini;

import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.OPModeACLEntry;
import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.OPModeACLEntryFactory;

/**
 * reading from Filesystem of for caching with tabellen mechanism
 * @author ws
 */
public class OPModeACLEntryFactory_FileSystem extends OPModeACLEntryFactory {

	@Override public OPModeACLEntry getOPModeACLEntry(final String pcUser
			                                        , final String pcName
			                                        , final String appName) {
		final String     simpleClassName = OPModeACLEntry.class.getSimpleName();
		final String nakedSimpleFileName = OPModeACLEntry.calcFileName(pcUser, pcName, appName);
		final String fileName = _BaseDataFor_FileOnlyObjects
										.calcFileName(simpleClassName, nakedSimpleFileName); 
		try {
			return OPModeACLEntry.deSerialize(ABaseData.readFileAsString(fileName));
		} catch (final Exception ex) {
			Logger.SWFW.warn(this.getClass().getSimpleName() + ".getOPModeACLEntry(...) " 
					       + "can not retrieve file " + fileName +", due to " + ex);
		}
		return null;
	}
	@Override public boolean usesOldSQLWay() {return false;}
	
	/**writes entry to the file cache*/
	public OPModeACLEntry set(final OPModeACLEntry entry) {
		final String sEntry = OPModeACLEntry.serialize(entry);
		final _BaseDataFor_FileOnlyObjects bd = new _BaseDataFor_FileOnlyObjects(entry);
		try {
			bd.writeFileAsString(sEntry);
		} catch (final Exception ex) {
			final String msg = this.getClass().getSimpleName() + ".set(" + sEntry + ") "
					         + "ignored, since exception = " + ex;
			Logger.SWFW.warn(msg);
		}
		return entry;
	}
	/**pp for testing*/ OPModeACLEntry get(final OPModeACLEntry entry) {
		return getOPModeACLEntry(entry.pcUser, entry.pcName, entry.appName);
	}
	/**pp for testing*/ boolean delete(final OPModeACLEntry entry) {
		return new _BaseDataFor_FileOnlyObjects(entry).delete(entry); 
	}
}
