/*
 * Created on Jun 11, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 *	Feb 15, 2008 - Feb 15, 2008 ws: added "@Override"es
 */
package de.desy.mst.libs.framework.mstapp.io;
 
import java.awt.*;
import java.awt.print.*;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;

import javax.print.Doc;
import javax.print.DocFlavor;
import javax.print.DocPrintJob;
import javax.print.PrintException;
import javax.print.SimpleDoc;
import javax.swing.JList;
import javax.swing.JMenuItem;

import de.desy.mst.libs.framework.mstapp.appinf.ApplikationKind;
import de.desy.mst.libs.framework.mstapp.appinf.IApp;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.mode.Maschine;
import de.desy.mst.libs.framework.mstapp.mode.MaschineMgr;
import de.desy.mst.libs.framework.mstapp.util.Convert;

/**
 * @author K. Hinsch -mst1-
 * &task Printing text
 *
 */
@SuppressWarnings({"rawtypes"})
public class MstPrintText extends MstPrintAll
{

	//---Membervariablen---------------------------------
	private        String[]             buffer = null;
	private        String 			    headLine = null;
	private        String           	pageLine = null;
	private        String               fontName = "Tahoma";
	private        int              	headerFontSize = 10;
	private        int                  textFontSize = 10;
	private        Maschine             maschine = null;
	private        String               printer = null;
	private        boolean              logbookFlag = false;
	private        int                  lineCounter= 0;
	private        String               line = null;
	private static JMenuItem            jMenuItemListeDrucken = null;
	
	//---Konstruktoren-----------------------------------
	public MstPrintText(){
		this.pjob  = PrinterJob.getPrinterJob();
	}

	public void printToLogbookWithoutDialog(
			final String[] Buffer,
			final String HeadLine,
			final String PageLine,
			final int HeaderFontSize,
			final int TextFontSize,
			final String FontName,
			final Maschine maschine,
			final boolean LogbookFlag){
		this.headLine = HeadLine;
		this.headerFontSize = HeaderFontSize;
		this.textFontSize = TextFontSize;
		this.fontName = FontName;
		this.pageLine = PageLine;
		this.buffer = Buffer;
		this.maschine =  maschine;
		this.logbookFlag = LogbookFlag;
		try {
			printText();
			
		} catch (final PrinterException e1) {
			Logger.SWFW.warn("Kann nicht drucken.", e1);
		} catch (final IOException e1) {
			Logger.SWFW.warn("Kann nicht drucken.", e1);
		}
	}
	public void printToLogbookWithoutDialog(final String[] Buffer,final String headLine,final String printer){
		this.headLine = headLine;
		this.printer = printer;
		this.buffer = Buffer;
		this.logbookFlag = true;
		try {
			printText();
			
		} catch (final PrinterException e1) {
			Logger.SWFW.warn("Kann nicht drucken.", e1);
		} catch (final IOException e1) {
			Logger.SWFW.warn("Kann nicht drucken.", e1);
		}
	}
	public void printToLogbookWithoutDialog(final String[] Buffer,final String printer){
		this.printer = printer;
		this.buffer = Buffer;
		this.logbookFlag = true;
		try {
			printText();
			
		} catch (final PrinterException e1) {
			Logger.SWFW.warn("Kann nicht drucken.", e1);
		} catch (final IOException e1) {
			Logger.SWFW.warn("Kann nicht drucken.", e1);
		}
	}
	public void printToLogbookWithoutDialog(final String[] Buffer,final String headLine,final Maschine maschine){
		this.headLine = headLine;
		this.maschine = maschine;
		this.buffer = Buffer;
		this.logbookFlag = true;
		try {
			printText();
			
		} catch (final PrinterException e1) {
			Logger.SWFW.warn("Kann nicht drucken.", e1);
		} catch (final IOException e1) {
			Logger.SWFW.warn("Kann nicht drucken.", e1);
		}
	}
	public void printToLogbookWithoutDialog(final String[] Buffer,final Maschine maschine){
		this.maschine = maschine;
		this.buffer = Buffer;
		this.logbookFlag = true;
		try {
			printText();
			
		} catch (final PrinterException e1) {
			Logger.SWFW.warn("Kann nicht drucken.", e1);
		} catch (final IOException e1) {
			Logger.SWFW.warn("Kann nicht drucken.", e1);
		}
	}
    private void printLogbook(final String text, final String title, final String author, final String kennung, final boolean logbook) throws FileNotFoundException{
    	//try to find out on whis os the program is running
    	final String os = System.getProperty("os.name");
    	Logger.SWApp.info("Betriebssystem: " + os);
    	//set variable
    	boolean systemIsWindows = false;
    	if(os.toLowerCase().contains("windows")){
    		systemIsWindows = true;
    	}
    	//logbook
    	if(logbook){
	    	final String xmlEncoded = "ISO-8859-1";
            //data to print
	    	final String xmlText =
				"<?xml version=\"1.0\" encoding=\"" + xmlEncoded + "\"?>"+
				"\n<entry>" +
	    			"\n<author>" + author + "</author>" +
	    			"\n<title>" + title + "</title>" +
	    			"\n<text>" + text + "</text>" +
	    			"\n<severity>" + kennung + "</severity>" +
	    			"\n<keywords>Dokumentation</keywords>"+
				"\n</entry>";
	    	try{
				//decode Text to bytes
				final byte[] bytes = xmlText.getBytes(xmlEncoded);
		    	//get "Maschine" and find the logbook 
		    	final LogbookFinder logbookFinder = LogbookFinder.getLogbook(this.maschine);
				if(systemIsWindows){//wenn das Programm unter Windows luft
					//Data format
		    	    final DocFlavor flavor = DocFlavor.BYTE_ARRAY.AUTOSENSE;
			    	final Doc doc = new SimpleDoc(bytes, flavor, null);
			    	try {
				    	//create printjob
						Logger.SWFW.info("Logbook-Queue: " + logbookFinder.getService().getName());
				    	final DocPrintJob pj = logbookFinder.getService().createPrintJob();
				    	//print
						pj.print(doc, null);
						Logger.SWFW.info("Print job succeeded");
					} catch (final PrintException e) {//error on printing
						Logger.SWFW.warn("Can't print.", e);
					} catch (final NullPointerException e1){
						Logger.SWFW.warn("Can't print.Logbookprinter installed?", e1);
					}
				}else{
			        try{
			        	//store data in a file
//			        	File tmpFile = new File("tmpFileForMstAppPrinting.txt");
			        	final File tmpFile = File.createTempFile("tmpFileForMstAppPrinting", ".txt");
			        	tmpFile.deleteOnExit();
			        	Logger.SWApp.info(tmpFile.getPath());
			        	final FileOutputStream fos = new FileOutputStream(tmpFile);
			        	fos.write(bytes);
			        	fos.close();
			        	//read the file and print it
			            final Runtime rt = Runtime.getRuntime();
			            final String[] callArgs = {"lpr","-l","-P",logbookFinder.getService().getName(), tmpFile.getPath()};
			            final Process proc = rt.exec(callArgs);
			            proc.waitFor();
			            //control the data by reading them
			            final BufferedReader pout = new BufferedReader(new InputStreamReader(proc.getInputStream()));
			            final String rcode = pout.readLine();
			            //print a message
			            if (rcode == null) {// data reread succsessfull
			            	Logger.SWFW.info("Print job succeeded");
			            }else {//no data
			            	 Logger.SWFW.warn("Can't print: " + rcode);
			            }
			          }catch(final Exception e){//error on printing
			        	  Logger.SWFW.warn("Can't print.", e);
			          }
			          
					}
			    }catch (final UnsupportedEncodingException e1) {// error on encoding
					Logger.SWFW.warn("Can't print, error encoding.", e1);
				}
    	}
    }
	private void printLogbook(){
		FileOutputStream fos = null;
		try {
			if(this.maschine != null){
				fos = new FileOutputStream(this.maschine.getLogBuchNameText());
			}else{
				fos = new FileOutputStream(this.printer);
			}
		} catch (final FileNotFoundException e) {
			e.printStackTrace();
		}
		final PrintWriter pw = new PrintWriter(fos);
		if(this.headLine != null){pw.println(this.headLine);}
		pw.println("");
		if(this.buffer != null){
			for (int i = 0; i < this.buffer.length; i++) {
				pw.println(this.buffer[i]);
			}
		}
		pw.close();
	}
	void printText() throws PrinterException, IOException {
		this.fph = new FilePrintHelper();
		if (this.logbookFlag == false){
			this.pjob.print();
		}else{
			printLogbook();
		}
	}
	void printText(
		final String[] Buffer,
		final String HeadLine,
		final String PageLine,
		final int HeaderFontSize,
		final int TextFontSize,
		final String FontName,
		final Maschine maschine,
		final boolean LogbookFlag) throws PrinterException, IOException {
		this.headLine = HeadLine;
		this.headerFontSize = HeaderFontSize;
		this.textFontSize = TextFontSize;
		this.fontName = FontName;
		this.pageLine = PageLine;
		this.buffer = Buffer;
		this.maschine =  maschine;
		this.logbookFlag = LogbookFlag;
		this.fph = new FilePrintHelper();
		if (this.logbookFlag == false){
			this.pjob.print();
		}else{
			printLogbook();
		}
	}
	 void printText(final Maschine maschine, final boolean logbookFlag, final String text, final String title, final String author, final String kennung,final boolean logbook) throws PrinterException, IOException {
		this.maschine = maschine;
		this.logbookFlag = logbookFlag;
		this.fph = new FilePrintHelper();
		if (this.logbookFlag == false){
			this.pjob.print();
		}else{
			printLogbook(text, title, author, kennung, logbook);
		}
	}
	 public void printText(final Maschine maschine, final boolean logbookFlag, final String text, final String title, final String author, final String kennung,final boolean logbook, final boolean mail, final String mailempfaenger) throws PrinterException, IOException {
		this.maschine = maschine;
		this.logbookFlag = logbookFlag;
		this.fph = new FilePrintHelper();
		if (this.logbookFlag == false){
			this.pjob.print();
		}else{
			printLogbook(text, title, author, kennung, logbook);
		}
    	if(mail){
    		String[] to = null;
    		if(mailempfaenger != null){
    			to = new String[1];
    			to[0] = mailempfaenger;
    		}
    		final String TextForMail = getTextForMail(text, kennung);
    		new Mail().sendMail(title, TextForMail, author, to, null);
    	}
	}
    private String getTextForMail(final String text, final String kennung){
    	final IApp app = ApplikationKind.Automatic.getApplicationInformation();
    	return kennung + "\r\n\r\n"
    	    + "Title: " + app.getTitle() + "\r\n"
    	    + "Version: " + app.getVersion() + "\r\n"
    	    + "File Timestamp: " + app.getFileTimestamp() + "\r\n"
    	    + "Release TimeStamp: " + app.getReleaseTimestamp() + "\r\n\r\n"
    	    + text;
    } 
//---Implementierung von Printable-------------------
@Override public int print(final Graphics g, final PageFormat pf, final int page)throws PrinterException
{
int ret = PAGE_EXISTS;
boolean IncreaseCounter;

try {
	if (this.fph.knownPage(page)) {
		//long k = fph.getFileOffset(page);
		if (this.lineCounter<this.buffer.length){
		   this.line = this.buffer[this.lineCounter];
		}
		IncreaseCounter = true;//jetzt wird es ernst
    } 
    else {
         long offset = 0;
         String LineForLength;
		 for(int j = this.lineCounter; j < this.buffer.length; j++){
			LineForLength = this.buffer[j];
			offset = offset + LineForLength.length();
		 }
         if (this.lineCounter < this.buffer.length){
			this.line = this.buffer[this.lineCounter];
			this.fph.createPage(page);
			this.fph.setFileOffset(page, offset);
         } else {
			ret = NO_SUCH_PAGE;	
         }
         IncreaseCounter = false; //nur Probelauf wird gestartet
    }
    if (ret == PAGE_EXISTS) {
         //Seite ausgeben, Grafikkontext vorbereiten
		Graphics2D g2 = (Graphics2D)g; 
		g2.scale(1.0 / RESMUL, 1.0 / RESMUL);
		int ypos = Convert.toInt(pf.getImageableY()) * RESMUL;
		int xpos = (Convert.toInt(pf.getImageableX()) + 2) * RESMUL;
		final int yd = 12 * RESMUL;
		final int ymax = ypos + Convert.toInt(pf.getImageableHeight()) * RESMUL - yd;
		final int xmax = xpos + Convert.toInt(pf.getImageableWidth()) * RESMUL;
		 ypos += yd;
		 g.drawImage(this.logo,xpos,ypos,this.imo);
		 g.drawImage(this.logo,xmax-this.logo.getWidth(this.imo)- 2*RESMUL ,ypos,this.imo);
		 xpos = (this.logo.getWidth(this.imo) + 2) * RESMUL;
		 ypos = (this.logo.getHeight(this.imo)+ 2) * RESMUL;
         g2.setColor(Color.black);
         g2.setFont(new Font(this.fontName, Font.PLAIN, 10 * RESMUL));
         if(this.pageLine != null){
         	g.drawString(this.pageLine, xpos, ypos);
         }
		 g.drawString("Seite " + (page + 1), xmax - (((( page / 10)) + 7) * yd), ypos);
		 xpos = (Convert.toInt(pf.getImageableX()) + 2) * RESMUL;
         g.drawLine(
           xpos,
           ypos + 6 * RESMUL,
           xpos + Convert.toInt(pf.getImageableWidth()) * RESMUL,
           ypos + 6 * RESMUL
         );
         ypos += 2 * yd;
         //berchrift ausgeben wenn der String gefllt ist auf der ersten Seite
         if (page == 0) {
	         if(this.headLine != null){
			 	g2.setColor(Color.black);
			 	g2.setFont(new Font(this.fontName, Font.BOLD, this.headerFontSize * RESMUL));
			 	g.drawString(this.headLine, xpos, ypos);
				ypos += 2 * yd;
	         }
         }
         //Zeilen ausgeben
         g2.setColor(new Color(0, 0, 127)); 
         g2.setFont(new Font(this.fontName, Font.PLAIN, this.textFontSize * RESMUL));
		 while (this.lineCounter < this.buffer.length) {
		   if (IncreaseCounter == true) {
			this.lineCounter++;	
		   }
           if (this.line != null) {
	           g.drawString(this.line, xpos, ypos);
	           ypos += yd;
           }
           if (ypos >= ymax) {
             break;
           }
           if (this.lineCounter < this.buffer.length) {
			this.line = this.buffer[this.lineCounter];
           }
         }
		g2.dispose();
		g2 = null;
       }
     } catch (final Exception e) {
       throw new PrinterException(e.toString());
     }
     return ret;
   }
	public static JMenuItem getJMenuItemListeDrucken(final JList jList, final MaschineMgr mgr, final String title) {
//		if (jMenuItemListeDrucken == null) {
			jMenuItemListeDrucken = new JMenuItem();
			jMenuItemListeDrucken.setText("Inhalt der Liste drucken");
			jMenuItemListeDrucken.addActionListener(new java.awt.event.ActionListener() {
				@Override public void actionPerformed(final java.awt.event.ActionEvent e) {
					final PrintDialogText myPrinter = new PrintDialogText();
					final String[] text = new String[jList.getModel().getSize()];
					for(int i = 0; i < jList.getModel().getSize(); i++){
						text[i] = jList.getModel().getElementAt(i).toString();
					}
					myPrinter.setText(text);
					myPrinter.setHeadLine(jList.getName());
					myPrinter.setPageLine(mgr.getMaschine().getLangenNamen() + " " + title);
					myPrinter.setHeaderFontSize(14);
					myPrinter.setTextFontSize(10);
					myPrinter.setFontName("Monospaced");
					myPrinter.setDefaultMaschine(mgr.getMaschine()); 
					myPrinter.showdialog();
				}
			});
//		}
		return jMenuItemListeDrucken;
	}
 }
