/**
 *  Oct 24, 2005 - Oct 24, 2005	ws: creation from scratch
 *  Feb 01, 2006 - Feb 06, 2006	ws: filter unterstuetzen, XMLBeschreibung unterstuetzen
 *  Jul 25, 2006 - ...			ws: ILogAppenderKern rausfaktoriert
 * 	Oct 14, 2008 - Oct 27, 2008	ws:	added: registerPreference(...), getName()
 */
package de.desy.mst.libs.framework.mstapp.logging.appender;


import de.desy.mst.libs.framework.mstapp.logging.filter.StdLogFilter;
import de.desy.mst.libs.framework.mstapp.preferences.IPrefManager;
import de.desy.mst.libs.framework.mstapp.preferences.IPreferences;
import de.desy.mst.libs.framework.mstapp.util.xml.IXmlBeschreibung;

/**
 * Interface fuer Mst Logging Appender (Senken).
 * @author ws
 * @version 1.0.0
 */
public interface ILogAppender extends ILogAppenderKern, IXmlBeschreibung {
	/**never null<br>Dieser Filter filtert alles was mindestens ein Unterfilter filtert<br>(getBypassFilter.pass ist staerker)*/
	public StdLogFilter	getFilter();
	/**never null<br>Dieser Filter laesst alles passieren, was mindestens ein Unterfilter passieren laesst<br>(getFilter.pass ist staerker)*/
	public StdLogFilter getBypassFilter();
	public boolean  isBypassFilterEnabled();
	public void    setBypassFilterEnabled(final boolean enabled);

	/**
	 *	Optionale SelbstRegistrierung einer Preference
	 * @param prefMgr	not null, hier registrieren
	 * @param parent	might be null, optionler parent dieser Preference
	 * @param appenderName Name des Appenders (Explizit um die diversen std Datei appender in einem Namen zu haben
	 */
	public void registerPreference(final IPrefManager prefMgr, final IPreferences parent, final String appenderName);
	/**kurzer Name fuer guten GUI Output, Eindeutig wegen safestring business*/
	public String getName();
}
