/**
 * Oct 9, 2008 - Oct 15, 2008	ws:	Creation from scratch
 */
package de.desy.mst.libs.framework.mstapp.logging.appender;

import java.util.Enumeration;

import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeNode;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;

import de.desy.mst.libs.framework.mstapp.logging.Logger;

/**
 * Einen mit MstLogging gefuellter JTree,
 * der einem genau eine Kategorie waehlen laesst.
 * @author ws
 * @version 1.0.0
 */
class JTreeLogKat extends JTree {
	private static final long serialVersionUID = 1L;
	//============================================================================
	public JTreeLogKat(final Logger aktuelleKategorie) {
		super(new DefaultTreeModel(MyNode.getRootNode()));
//		this.addTreeSelectionListener(new TreeSelectionListener(){
//			public void valueChanged(final TreeSelectionEvent evt) {
//				Logger.SWFW.info("JTreeLogKat new selection: " + getSelection());
//			}
//		});
		this.getSelectionModel()
			.setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
		this.setSelection(aktuelleKategorie);
	}
//============================================================================
	/* (non-Javadoc)
	 * @see javax.swing.JTree#getModel()
	 */
	@Override public DefaultTreeModel getModel() {
		return (DefaultTreeModel) super.getModel();
	}
	//-------------------------------------------------------------------------
	public void setSelection(final Logger kategorie) {
		final MyNode node = MyNode.getNode(kategorie);
		if(node == null)
			return;

		final TreeNode[] pathToRoot = getModel().getPathToRoot(node);
		final TreePath treePath = new TreePath(pathToRoot);
		this.setSelectionPath(treePath);
	}
	public Logger getSelection(){
		final MyNode node = (MyNode)getSelectionPath().getLastPathComponent();
		final Logger selectedKategorie = (node==null)?null:node.getUserObject();
		return selectedKategorie;
	}
	public void expandAll(){expandAll(MyNode.getRootNode());}
	//-------------------------------------------------------------------------
	@SuppressWarnings("rawtypes")
	private void expandAll(final MyNode node) {
		this.expandPath(new TreePath(getModel().getPathToRoot(node)));
		for(final Enumeration children = node.children(); children.hasMoreElements();)
			expandAll((MyNode)children.nextElement());
	}

//============================================================================
//============================================================================
//============================================================================
	/**Hauptsaeschlich um casts zu reduzieren*/
	private static class MyNode extends DefaultMutableTreeNode {
//============================================================================
		private static final long serialVersionUID = 1L;
		private static final MyNode rootNode = createAndFill(Logger.Any);
		//-------------------------------------------------------------------------
		public static MyNode getRootNode(){return rootNode;}
		public static MyNode getNode(final Logger kategorie) {
			return getRootNode().search(kategorie);
		}
	//-------------------------------------------------------------------------
		private MyNode(final Logger kategorie) {
			super(kategorie);
		}
	//-------------------------------------------------------------------------
		/* (non-Javadoc)
		 * @see javax.swing.tree.DefaultMutableTreeNode#getUserObject()
		 */
		@Override
		public Logger getUserObject() {return (Logger) super.getUserObject();}
	//-------------------------------------------------------------------------
		@SuppressWarnings("rawtypes")
		private MyNode search(final Logger kategorie) {
			if(kategorie == null)
				return null;
			if(kategorie.equals(this.getUserObject()))
				return this;

			for(final Enumeration children = this.children(); children.hasMoreElements();){
				final MyNode child = (MyNode)children.nextElement();
				final MyNode node  = child.search(kategorie);
				if(node != null)
					return node;
			}
			return null;
		}
	//-------------------------------------------------------------------------
		private static MyNode createAndFill(final Logger parent) {
			final MyNode rootNode = new MyNode(parent);
			for (final Logger value : Logger.values())
				if(parent.isTrueDirectChild(value))
					rootNode.add(createAndFill(value));
			return rootNode;
		}
	}//END CLASS: MyNode
}
