/**
 * Oct 23, 2008 - Oct 28, 2008	ws:	Creation from PrefLogging
 */
package de.desy.mst.libs.framework.mstapp.logging.appender;

import de.desy.mst.libs.framework.mstapp.ini.PrefStorage;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.preferences.IPrefContainer;
import de.desy.mst.libs.framework.mstapp.preferences.IPreferences;
import de.desy.mst.libs.framework.mstapp.preferences.helper.APrefClientPanel;
import de.desy.mst.libs.framework.mstapp.preferences.helper.APreferences;

/**
 * Preferences fuer das MstLogging Appender Buffer(package private)
 * @author ws
 * @version 1.0.0
 */
class PrefLoggingAppenderBuffer extends APreferences {
	/**pp*/ static final String KEY_SYSTEM_LOG_CAPACITY = "System Log Capacity ";
	private static final String   TITLE    = "System Log Konfiguration";
	private static final String[] KEYWORDS = new String[]
                    {"Logging", "Protokoll", "System", "Memory", "Appender", "Buffer"};
	//-------------------------------------------------------------------------
	private final LogAppenderBuffer buffer;
//=============================================================================
	/**
	 * @param  buffer not null
	 * @param  parent
	 * @throws NullPointerException falls appender oder PrefManager null ist
	 */
	public PrefLoggingAppenderBuffer(final LogAppenderBuffer buffer, final IPreferences parent) {
		super(TITLE, parent, KEYWORDS);
		this.buffer  = buffer;
	}
//=============================================================================
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.preferences.helper.APreferences#createPrefClientPanel(de.desy.mst.libs.framework.mstapp.preferences.IPrefContainer)
	 */
	@Override public APrefClientPanel createPrefClientPanel(final IPrefContainer prefContainer) {
		return new PrefLoggingPanelAppenderBuffer(prefContainer, this.buffer);
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.preferences.helper.APreferences#onNewSaveString(java.lang.String)
	 */
	@Override public void onNewSaveString(final String saveString) {
		if(saveString == null || saveString.isEmpty())
			return;
		handleCapacityFromSaveString(saveString);
	}
//=============================================================================
	private void handleCapacityFromSaveString(final String saveString) {
		final String value = PrefStorage.extract(saveString, KEY_SYSTEM_LOG_CAPACITY);
		if(value == null)
			return;
		try {
			final int capacity = Integer.parseInt(value);
			this.buffer.setCapacity(capacity);
			Logger.SWFW.info("PrefLoggingAppenderBuffer.onNewSaveString(" + saveString + ") Kapzitt auf '" + value + "' gesetzt.");
		} catch (final Exception ex) {
			Logger.SWFW.warn("PrefLoggingAppenderBuffer.onNewSaveString(" + saveString + ") unerwartete Exception.", ex);
		}
	}
}
 
