/**
 * Jun 18, 2009 - Jun 19, 2009	ws:	Creation from scratch
 */
package de.desy.mst.libs.framework.mstapp.logging.appender.file;

import java.util.Date;

import de.desy.mst.libs.framework.mstapp.util.MstDateFormat;

/**
 * eine Datei pro ApplikationsRun wird erzeugt
 * <br> Name ist sortierbare, Menschen lesbare Kurzform des Datums
 * @author ws
 * @version 1.0.0
 */
class __FTOncePerAppRun implements IFileTargetsByDate {
	private final MstDateFormat dateFormat = new MstDateFormat("yyMMdd_HHmmss");
	private final String baseName;	//Basename Datum als sortierbare Zahl
//-----------------------------------------------------------------------------
	__FTOncePerAppRun(final long timeInMillis){this.baseName = asString(timeInMillis);}
//-----------------------------------------------------------------------------
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.logging.appender.file.IFileTargetsByDate#getBaseName()
	 */
	@Override public String getBaseName() {return this.baseName;}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.logging.appender.file.IFileTargetsByDate#getName()
	 */
	@Override public String getName() {return getBaseName();}	//nie alt
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.logging.appender.file.IFileTargetsByDate#istAlt(java.util.Date)
	 */
	@Override public boolean istAlt(final Date dateiDate) 		{return false;}	//nie alt
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.logging.appender.file.IFileTargetsByDate#needNewOutput(java.util.Date)
	 */
	@Override public boolean needNewOutput(final Date msgDate)	{return false;}	//nie alt
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.logging.appender.file.IFileTargetsByDate#setDate(java.util.Date)
	 */
	@Override public boolean setDate(final Date msgDate) 		{return false;}	//nie alt
//-----------------------------------------------------------------------------
	private final MstDateFormat getDateFormat() {return this.dateFormat;}
	private final String asString(final long timeInMillis) {
		return getDateFormat().format(new Date(timeInMillis));
	}
}
