/**
 *  Created on	Jan 12, 2006 - Feb 02, 2006
 */
package de.desy.mst.libs.framework.mstapp.logging.filter;

import de.desy.mst.libs.framework.mstapp.logging.LogMsg;
import de.desy.mst.libs.framework.mstapp.util.xml.IXmlBeschreibung;

/**
 * Basis Interface um Logging Messages auszufiltern.<br>
 * Es soll immer gelten: pass(logMsg) == not filter(logMsg)
 * @author ws
 * @version 1.0.0
 */
public interface ILogFilter extends IXmlBeschreibung{
	/**true, falls logMsg nicht ausgefiltert wird*/
	public boolean pass  (final LogMsg logMsg);
	/**true, falls logMsg ausgefiltert wird*/
	public boolean filter(final LogMsg logMsg);
	
	/**never null, @see de.desy.mst.mstapp.logging.filter.FilterModus*/
	public FilterModus getModus();
	/**never null, @see de.desy.mst.mstapp.logging.filter.FilterModus*/
	public void setModus(final FilterModus modus);
}
