/**
 *  Created on	Jan 12, 2006 - Jan 30, 2006
 */
package de.desy.mst.libs.framework.mstapp.logging.filter;

import java.util.List;

import de.desy.mst.libs.framework.mstapp.logging.LogMsg;

/**
 * <b>Composite Filter fuer andere Filter.</b><br>
 * pass == true, falls mindestens einer seiner Subfilter bei pass ein true ergibt.
 * Keine Subfilter => false
 * (Logisches oder bei pass auf die SubFilter)
 * <br>
 * 
 * @author ws
 * @version 1.0.0
 */
public class OderLogFilter<T extends ILogFilter> extends ALogCollectionFilter<T>{
	public OderLogFilter() {super("OderFilter");}
	
//=============================================================================
	
	/* (non-Javadoc)
	 * @see de.desy.mst.mstapp.logging.filter.ALogCollectionFilter#pass(de.desy.mst.mstapp.logging.LogMsg, java.util.List)
	 */
	@Override
	protected boolean passOnStandardModus(final LogMsg logMsg, final List<T> dieFilter) {
		for (final T filter : dieFilter) {
			if(filter.pass(logMsg)) {return true;}
		}
		return false;
	}
	/* (non-Javadoc)
	 * @see de.desy.mst.mstapp.logging.filter.ALogFilter#getName()
	 */
	@Override protected String getName() {return this.NAME;}
} 