/**
 * 	Feb 13, 2008 - Feb 27, 2008	ws: Creation from scratch/LogMst
 * 	Mar 27, 2008 - Mar 27, 2008	ws:	add asString(E e)
 * 	Mar 31, 2008 - Apr 17, 2008	ws:	FieldFilter hierhin, da hier auch Fields
 * 	May  6, 2008 - Jun  9, 2008	ws: MstModel Tine Fit, AField<E> to TopLevel
 * 	Jul  2, 2008 - Jul  2, 2008	ws:	added filterNotSelect support
 * 	Jul 16, 2008 - Jul 18, 2008	ws: added:	 getAppColor() concrete Default
 * 									changed: "AField<?, L>" -> "? extends AField<?, L>"
 * 									added: equals, hashCode
 *	Jul 29, 2008 - Jul 29, 2008	ws: added: equalsInStructure(...)
 *	Aug 14, 2008 - Aug 14, 2008	ws:	added: serialize(), serialize(...)
 * 	Aug 28, 2008 - Aug 29, 2008	ws: color coding nicht nur Message sondern auch
 * 							feldspezifisch (Kommentare Anzeige unterdruecken)
 *	Feb 15, 2009 - Feb 15, 2009 ws: serializable
 *	Feb 26, 2009 - Feb 26, 2009	ws:	mightNeedCellEditor for throwable
 * 	Jul 14, 2009 - Jul 14, 2009	ws:	fixed some Eclipse 3.5 warnings
 */
package de.desy.mst.libs.framework.mstapp.logging.gui;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;

import de.desy.mst.libs.framework.mstapp.logging.LogLvl;
import de.desy.mst.libs.framework.mstapp.logging.LogMsg;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.logging.gui.KategorieTreeModel.Kategorie;
import de.desy.mst.libs.framework.mstapp.util.gui.AppColor;

/**
 * 	Adapter fuer JTable zu MstLog Objekte und Metainformation. Ausserdem extra
 * 	JTable Column Infos.<br>
 * 	L ist der Typ der Log Message<br>
 *	To used in EDT Thread Only
 * @author ws
 * @version 1.0.0
 */
@SuppressWarnings({"rawtypes", "unchecked"})
abstract class AMsgModel<L> {
	/**pp*/ static final Throwable NULL_THROWABLE = new Throwable(""){
								private static final long serialVersionUID = 1L;
								@SuppressWarnings("unused")	//nur fuer Debug
								public final String ichBin = "NULL_THROWABLE";
								@Override public String toString() {return "";}
	};
	/**pp*/ static final UUID NULL_RUNID = UUID.fromString("00000000-0000-0000-0000-000000000000");
//=============================================================================
	static <L> void createFieldMap_AddField(final Map<String, AField<?, L>> map
									  	  , final AField<?, L> field) {
		map.put(field.getName(), field);
	}

//=============================================================================
	private final Map<String, ? extends AField<?, L>> fields; // mit ori. Reihenfolge
//=============================================================================
	AMsgModel(final Map<String, ? extends AField<?, L>> fields) {
		super();
		this.fields = fields;
	}
//=============================================================================
	@Override public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((this.fields == null) ? 0 : this.fields.hashCode());
		return result;
	}
	@Override public boolean equals(final Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final AMsgModel other = (AMsgModel) obj;
		if (this.fields == null) {
			if (other.fields != null)
				return false;
		} else if (!this.fields.equals(other.fields))
			return false;
		return true;
	}
//=============================================================================
	final public Collection<AField<?, L>> getDiscreteFields(){
		final Collection<? extends AField<?, L>> felder = getFields().values();
		final ArrayList<AField<?, L>> list = new ArrayList<AField<?, L>>(felder.size());
		for (final AField<?, L> field : felder) {
			if(field.isDiscrete())
				list.add(field);
		}
		return list;
	}
//=============================================================================
	public int getSize() 							{return getFields().size();}
	public AField<?, L> getField(final String name)	{return getFields().get(name);}
	public AField<?, L> getField(final int index) {
		final Collection<? extends AField<?, L>> values = getFields().values();
		for (final AField<?, L> field : values) {
			if(field.getIndex() == index)
				return field;
		}
		return null;
	}
	public List<AField<Date, L>> getDateFields(){
		final List<AField<Date, L>> dateFieldList =
											new ArrayList<AField<Date, L>>();
		final Class<Date> dateClass = Date.class;
		final Collection<? extends AField<?, L>> values = getFields().values();
		for (final AField<?, L> value : values) {
			final Class<?> elementClass = value.getClazz();
			if(dateClass.equals(elementClass)){
				dateFieldList.add((AField<Date, L>)value);
			}
		}
		return dateFieldList;
	}
	abstract public AField<Date, L> getDateField();
	/**Typisch Message Feld: Damit nicht alle Spalten unterdrueckt werden*/
	abstract public AField<?, L> 	getCoreInfoField();
//=============================================================================
	public Map<String, ? extends AField<?, L>> getFields() {return this.fields;}
	/**Typisch Message Feld: Damit nicht alle Spalten unterdrueckt werden*/
	public <E extends Serializable> boolean isCoreInfoField(final AField<E, L> field){
		return getCoreInfoField().equals(field); 
	}
	public AppColor getAppColor(final L message, final int spalte)	{
		return AppColor._Info;
	}
	public boolean equalsInStructure(final AMsgModel newMsgModel) {
		return newMsgModel != null && this.getClass() == newMsgModel.getClass();
	}
	public boolean isComment(final L message) {return false;}
	public String getComment(final L message) {return "";}
	public List<String> getFieldNames(){
		final int n = getSize();
		final ArrayList<String> list = new ArrayList<String>(n);
		for (int i = 0; i < n; i++)
			list.add(getField(i).getName());
		return list;

	}
//=============================================================================
}

//=============================================================================
//=============================================================================
//=============================================================================

class MsgModel_MstLog extends AMsgModel<LogMsg>{
	static final String NR_NAME 		= "Nr";
	static final String LEVEL_NAME 		= "Grad";
	static final String KATEGORIE_NAME 	= "Kategorie";
	static final String MSG_NAME 		= "Eintrag";
	static final String THROWABLE_NAME 	= "Throwable";
	static final String APP_NAME_NAME 	= "Applikation";
	static final String PC_NAME_NAME 	= "PC Name";
	static final String RUN_ID_NAME 	= "Lauf Id";
	static final String DATE_NAME    	= "Date";

	private static final int      MSG_LEN	= 30;
	private static final int APP_NAME_LEN 	= 12;
	private static final int  PC_NAME_LEN 	= "MstXpWs2".length();
	//-------------------------------------------------------------------------
	private static final MsgModel_MstLog instance = new MsgModel_MstLog();
	//-------------------------------------------------------------------------
	public  static /*Final*/MsgModel_MstLog getInstance() {return instance;}
	//-------------------------------------------------------------------------
	/**pseudo private!!!*/MsgModel_MstLog() {super(createFieldMap());}
//=============================================================================
	@SuppressWarnings("unchecked") public AField<Long, LogMsg> getNrField() {
		return (AField<Long, LogMsg>) getField(NR_NAME);
	}
	@SuppressWarnings("unchecked") public AField<LogLvl, LogMsg> getLevelField() {
		return (AField<LogLvl, LogMsg>) getField(LEVEL_NAME);
	}
	@SuppressWarnings("unchecked") public AField<Logger, LogMsg> getKategorieField() {
		final Object object = getField(KATEGORIE_NAME);
		return (AField<Logger, LogMsg>) object;
	}
	@SuppressWarnings("unchecked")
	@Override public AField<Date, LogMsg> getDateField() {
		return (AField<Date, LogMsg>) getField(DATE_NAME);
	}
	@SuppressWarnings("unchecked") public AField<String, LogMsg> getMsgField() {
		return (AField<String, LogMsg>) getField(MSG_NAME);
	}
	@Override public AField<?, LogMsg> getCoreInfoField(){return getMsgField();}
	@SuppressWarnings("unchecked") public AField<Throwable, LogMsg> getThrowableField() {
		return (AField<Throwable, LogMsg>) getField(THROWABLE_NAME);
	}
	@SuppressWarnings("unchecked") public AField<String, LogMsg> getApplicationField() {
		return (AField<String, LogMsg>) getField(APP_NAME_NAME);
	}
	@SuppressWarnings("unchecked") public AField<UUID, LogMsg> getRunIDField() {
		return (AField<UUID, LogMsg>) getField(RUN_ID_NAME);
	}
	@SuppressWarnings("unchecked") public AField<String, LogMsg> getPCNameField() {
		return (AField<String, LogMsg>) getField(PC_NAME_NAME);
	}

	@Override public AppColor getAppColor(final LogMsg message, final int spalte) {
		return message.getLevel().getAppColor();
	}

//=============================================================================
	/**for XTor only*/
	private static Map<String, AField<?, LogMsg>> createFieldMap() {
		final Map<String, AField<?, LogMsg>> map = new LinkedHashMap<String, AField<?, LogMsg>>(9);
		int ind = 0;
		createFieldMap_AddField(map, createField_Nr		(ind++)	);
		createFieldMap_AddField(map, createField_Level	(ind++)	);
		createFieldMap_AddField(map, createField_Date	(ind++)	);
		createFieldMap_AddField(map, createField_Kat	(ind++)	);
		createFieldMap_AddField(map, createField_Msg	(ind++)	);
		createFieldMap_AddField(map, createField_Throw	(ind++)	);
		createFieldMap_AddField(map, createField_AppName(ind++)	);
		createFieldMap_AddField(map, createField_RunId	(ind++)	);
		createFieldMap_AddField(map, createField_PCName	(ind++)	);
		return Collections.unmodifiableMap(map);
	}

	private static AField<Long, LogMsg> createField_Nr (final int index) {
		final AFieldFilterGUIFactory<Long, LogMsg, MsgModel_MstLog> fieldFilterFactory =
			new AFieldFilterGUIFactory.AsJTextArea<Long, LogMsg, MsgModel_MstLog>
										   ("Erlaubte Nummern"
										  , "Z.B.: \"5, 7, 11, 25 - 33\""
										  , false);
		final AField<Long, LogMsg> field =
			new AField<Long, LogMsg>(index, NR_NAME, "Aufsteigende fortlaufende Nummer pro Applikationslauf.", Long.class, 100L, fieldFilterFactory) {
			private static final long serialVersionUID = 1L;
			private static final String RANGE_TOKEN = "-";
			@Override Long get(final LogMsg logMsg) {return logMsg.getNr();}
			@Override public String getEntrySeparatorOutput() {return ", ";}
			@Override public boolean lhsIsSmaller(final Long lhs, final Long rhs) {
				return lhs < rhs;
			}
			@Override public String getRangeToken() {return RANGE_TOKEN;}
			@Override public Long asValue(final String numInput) {
				final String trim = numInput.trim();
				return trim.isEmpty()? null : Long.valueOf(trim);
			}
			@Override public Long getDefaultVon() {return 0L;}
			@Override public Long getDefaultBis() {return Long.MAX_VALUE;}
		};
		return field;
	}
	/**pp*/
	@SuppressWarnings("unchecked")
	private static AField<LogLvl, LogMsg> createField_Level	(final int index) {
		final AFieldFilterGUIFactory<LogLvl, LogMsg, MsgModel_MstLog> fieldFilterFactory =
			new AFieldFilterGUIFactory.ForFixedValues<LogLvl, LogMsg, MsgModel_MstLog>("Erlaubte Grade.  ", "Wie ernst ist dieser Eintrag?", LogLvl.values());
		final String description = "Schweregrad (Level) des Eintrags (Debug, Info, Warn, Error, Fatal)";
		final AField<LogLvl, LogMsg> field = new AField<LogLvl, LogMsg>(index, LEVEL_NAME, description, LogLvl.class, LogLvl.debug, fieldFilterFactory) {
			private static final long serialVersionUID = 1L;
			@Override LogLvl get(final LogMsg logMsg) {
				return logMsg.getLevel();
			}
			@Override public boolean lhsIsSmaller(final LogLvl lhs, final LogLvl rhs) {
				return !lhs.istErnsterAls(rhs);
			}
			@Override public FieldFilterSized createFieldFilter(final LoggingTable<?, ?> table) {
				return new FieldFilterSized((LoggingTable<LogMsg, ?>)table, LogLvl.values().length);
			}
			@Override public boolean isDiscrete() {return true;}
		};
		return field;
	}
	private static AField<Date,   LogMsg>   createField_Date(final int index) {
		return new AField.ADateField<LogMsg, MsgModel_MstLog>(index, DATE_NAME, "Erlaubte Zeiten."){
			private static final long serialVersionUID = 1L;
			@Override Date get(final LogMsg logMsg) {
				return new ISODate(logMsg.getDate().getTime());
			}
		};
	}
	private static AField<Logger, LogMsg> createField_Kat 	(final int index) {
		final AFieldFilterGUIFactory<Logger, LogMsg, MsgModel_MstLog> fieldFilterFactory =
			new AFieldFilterGUIFactory.ForMstKat("Erlaubte Kategorie", "Kategorien beinhalten Unterkategorien");
		final AField<Logger, LogMsg> field = new AField<Logger, LogMsg>(index, KATEGORIE_NAME, "Kategorie des Eintrags (Hierarchisch geordnet)", Logger.class, Logger.Netzwerk, fieldFilterFactory) {
			private static final long serialVersionUID = 1L;
			@Override public Logger get(final LogMsg logMsg) {
				return logMsg.getKategorie();
			}
			@Override public boolean isDiscrete() {return true;}
			@Override public boolean supportsInverted() {return false;}
			@Override public Logger asValue(final String katAsString) {
				if(katAsString == null || katAsString.isEmpty())
					return null;
				final String marker = FFEKategorie.INFIX;
				if(katAsString.startsWith(marker))
					return asValue(katAsString.substring(marker.length()));
				return Logger.valueOf(katAsString);
			}
			@Override public final AFFE<Logger, LogMsg> fromString (final String entry) throws IllegalArgumentException {
				if(entry.startsWith(AFFE.INVERTED_TOKEN))
					throw new IllegalArgumentException("Kategorie unterstuetzt nicht inverted");
				try {
					return new FFEKategorie(asValue(entry));
				} catch (final Exception e) {
					throw new IllegalArgumentException(e.getMessage());
				}
			}
			@SuppressWarnings("unchecked")
			@Override
			public FieldFilter createFieldFilter(final LoggingTable<?, ?> table) {
				return new FieldFilter((LoggingTable<LogMsg, ?>)table){
					private static final long serialVersionUID = 1L;
					private KategorieTreeModel kategorieTreeModel;
					@Override public boolean filtert(){
						final int size = getFFEs().size();
						return 0 < size && !passes(getRoot());
					}
					private boolean passes(final Kategorie kategorie) {
						if(passes(kategorie.kat))
							return true;
						if(kategorie.anzahl > 0)
							return false;
						for (final Kategorie child : kategorie.children) {
							if(!passes(child))
								return false;
						}
						return true;
					}
					private Kategorie getRoot() {
						return getKategorieTreeModel(getField()).getRoot();
					}
					private KategorieTreeModel getKategorieTreeModel(final AField<Logger, LogMsg> field){
						if(this.kategorieTreeModel == null){
							final LoggingTableModel<LogMsg, MsgModel_MstLog> model =
								 (LoggingTableModel<LogMsg, MsgModel_MstLog>)
														getTable().getModel();
							this.kategorieTreeModel =
								new KategorieTreeModel(model.getLogSource()
															.getAuswertung()
															.getFieldInfo(field)
								);
						}
						return this.kategorieTreeModel;
					}
					@Override public boolean remove(final AFFE<Logger, LogMsg> ffe) {
						if(getFFEs().contains(ffe))
							return super.remove(ffe);
						if(ffe instanceof FFEValueEquality)
							return removeKatFFE(new FFEKategorie((FFEValueEquality<Logger, LogMsg>) ffe));
						return super.remove(ffe);
					}
					private boolean removeKatFFE( final FFEKategorie ffe) {
						final Logger refValue = ffe.getRefValue();
						if(getFFEs().contains(ffe)
						|| !this.passes(refValue))
							return super.remove(ffe);

						final FFEValueEquality<Logger, LogMsg> parentFFE =
							new FFEValueEquality<Logger, LogMsg>(ffe.getField(), refValue.parent, false);
						return removeKatFFE(new FFEKategorie(parentFFE));
					}
					@Override public boolean add(final AFFE<Logger, LogMsg> ffe) {
						if(ffe instanceof FFEValueEquality) {
							return addKat((FFEValueEquality<Logger, LogMsg>) ffe);
						}
						return super.add(ffe);
					}
					private boolean addKat(final FFEValueEquality<Logger, LogMsg> ffe) {
						return (this.passes(ffe.getRefValue())) ?
								  false
								: super.add(new FFEKategorie(ffe));
					}
				};
			}

		};

		return field;
	}
	private static AField<String, LogMsg> createField_Msg	(final int index) {
		return new AField.AStringField<LogMsg, AMsgModel<LogMsg>>(
				  index
				, MSG_NAME								//name
				, "Eintrag (Message) selbst."			//description
				, !AField.IS_DISCRETE
				, MSG_LEN
				, "Erlaubte Eintrge."					//editorText
				, "Z.B.: (genauer Text der Meldung) \"dies ist die Meldung\" oder (regulrer Ausdruck) \"a.*\" (.* ist eine beliebige Zeichenfolge). Es reicht dass ein Ausdruck in einer Zeile muss passt."
				, AField.IS_WIDE_EDITOR
		){
			private static final long serialVersionUID = 1L;
			@Override String get(final LogMsg logMsg) {return logMsg.getMessage();}
		};
	}
	private static AField<Throwable, LogMsg> createField_Throw(final int index) {
		final AFieldFilterGUIFactory<Throwable, LogMsg, MsgModel_MstLog> fieldFilterFactory =
			new AFieldFilterGUIFactory.AsJList<Throwable, LogMsg, MsgModel_MstLog>("Erlaubte Software Fehler", ""){
				private static final long serialVersionUID = 1L;
				@Override public boolean isWideEditor() {return true;}
			};
		final AField<Throwable, LogMsg> field = new AField<Throwable, LogMsg>(index, THROWABLE_NAME, "Ein geworfener Fehler (Throwable). Nur Software intern und nur im System Log selbst.", Throwable.class, NULL_THROWABLE, fieldFilterFactory) {
			private static final long serialVersionUID = 1L;
			@Override Throwable get(final LogMsg logMsg) {
				final Throwable throwable = logMsg.getThrowable();
				return (throwable == null) ? NULL_THROWABLE
										   : throwable;
			}
			@Override public boolean isDiscrete() 		{return true;}
			@Override public boolean mightBeMultiline() {return true;}
			@Override public boolean mightBeMultiline(final Throwable value) {
				return value != null && value != AMsgModel.NULL_THROWABLE;
			}
		};
		return field;
	}
	private static AField<String, LogMsg> createField_AppName(final int index) {
		return new AField.AStringField<LogMsg, AMsgModel<LogMsg>>(
				  index
				, APP_NAME_NAME								//name
				, "Der Name der Applikation des Eintrags."	//description
				, AField.IS_DISCRETE
				, APP_NAME_LEN
				, "Erlaubte Applikationen."					//editorText
				, "Name der Applikation die diese Message erzeugt hat."
				, !AField.IS_WIDE_EDITOR
		){
			private static final long serialVersionUID = 1L;
			@Override String get(final LogMsg logMsg) {return logMsg.getApplikation();}
		};
	}
	private static AField<UUID,   LogMsg> createField_RunId	(final int index) {
		final AFieldFilterGUIFactory<UUID, LogMsg, MsgModel_MstLog> fieldFilterFactory =
			new AFieldFilterGUIFactory.AsJList<UUID, LogMsg, MsgModel_MstLog>(
				  "Erlaubte Applikations Lufe"
				, "Jeder einzelne Programmlauf hat eine einzigartige LaufId, die leider nicht besonders gut fr Menschen zu lesen ist.");
		final AField<UUID, LogMsg> field = new AField<UUID, LogMsg>(index, RUN_ID_NAME, "Jeder Lauf jeder Applikation hat eine eindeutige Lauf Id (RunId) im UUID Format.", UUID.class, LogMsg.THIS_RUN_RUNID, fieldFilterFactory) {
			private static final long serialVersionUID = 1L;
			@Override UUID get(final LogMsg logMsg) {
				final UUID runId = logMsg.getRunId();
				return (runId == null) ? NULL_RUNID : runId;
			}
			@Override public boolean isDiscrete() 	{return true;}
		};
		return field;
	}
	private static AField<String, LogMsg> createField_PCName(final int index) {
		return new AField.AStringField<LogMsg, AMsgModel<LogMsg>>(
				  index
				, PC_NAME_NAME										//name
				, "Name des Computers auf dem diese Message erzeugt wurde."//des
				, AField.IS_DISCRETE
				, PC_NAME_LEN
				, "Erlaubte PC Namen."								//editorText
				, ""
				, !AField.IS_WIDE_EDITOR
		){
			private static final long serialVersionUID = 1L;
			@Override String get(final LogMsg logMsg) {return logMsg.getPcName();}
		};
	}
}
