/**  
 *	Jan 31, 2008 - Feb  6, 2008	ws:	Creation from scratch/LoggingSelectionPanel
 *	Feb 15, 2008 - Feb 15, 2008 ws: added "@Override"es
 *	Apr 23, 2008 - Apr 23, 2008 ws: added Support for Tine ALogSource, ...
 *	May  5, 2008 - May  5, 2008	ws:	remove unneccesary file != null Abfrage
 *	May 19, 2008 - Jun  4, 2008	ws:	add genericity
 *	Jun 24, 2008 - Jun 24, 2008	ws:	add in Provider seitTagen
 *	Jul 14, 2008 - Jul 15, 2008	ws: add support for Protokoll Menu, home
 * 	Jul 17, 2008 - Aug  8, 2008	ws:	Unterstuetzung von CSV Dateien
 *	Aug 26, 2008 - Aug 26, 2008	ws: publish SystemProvider
 *	Sep  3, 2008 - Sep  5, 2008	ws: publish ini Dateien im Menue
 *									added: isXMLFile(File)
 *	Sep  9, 2008 - Sep  9, 2008	ws: fix bug with no LocalHome
 *	Dec 10, 2008 - Dec 10, 2008	ws:	MstSecurityMgr -> MstSecurity
 *	Jan 14, 2008 - Jan 14, 2008 ws: replace \\ by File.separator
 *	Jul  2, 2009 - Jul 13, 2009 ws: support von MstLog -> Tine Server Display
 * 	Jul 14, 2009 - Jul 14, 2009	ws:	fixed some Eclipse 3.5 warnings
 * 	Jul 17, 2009 - Jul 20, 2009	ws:	add GUIFactory.runInExtraThread_showingBusyDialog(...)	
 *	Jul 24, 2009 - Jul 30, 2009	ws:	show MstLog in Tine Server in MstLog format move LS creation to TineProviderSpezifikation 
 *	Aug  4, 2009 - Aug  4, 2009	ws:	added: createSystemLS mit weiteren Parametern wegen accessory
 * 	Aug  6, 2009 - Aug  6, 2009	ws:	Eclipse asked for removing unnessary casts, so I did
 *	Aug  3, 2009 - Sep 18, 2009	ws:	added: support getAccessory() in some LogSources
 */
package de.desy.mst.libs.framework.mstapp.logging.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;
import java.util.UUID;
import java.util.concurrent.ExecutionException;

import javax.swing.AbstractButton;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.SwingUtilities;
import javax.swing.SwingWorker;
import javax.swing.border.TitledBorder;
import javax.swing.event.MenuEvent;
import javax.swing.event.MenuListener;
import javax.swing.filechooser.FileFilter;

import de.desy.mst.libs.framework.mstapp.ApplicationInfo;
import de.desy.mst.libs.framework.mstapp.Main;
import de.desy.mst.libs.framework.mstapp.ini.ABaseDataOfMstIni;
import de.desy.mst.libs.framework.mstapp.ini.LocalHome;
import de.desy.mst.libs.framework.mstapp.ini.PfadeIni;
import de.desy.mst.libs.framework.mstapp.ini.TextInputStreamUtility;
import de.desy.mst.libs.framework.mstapp.ini.WebHome;
import de.desy.mst.libs.framework.mstapp.logging.LMTag;
import de.desy.mst.libs.framework.mstapp.logging.LogMsg;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.logging.LoggerManager;
import de.desy.mst.libs.framework.mstapp.logging.appender.file.LogAppenderFile;
import de.desy.mst.libs.framework.mstapp.logging.appender.file.PfadeProtokoll;
import de.desy.mst.libs.framework.mstapp.logging.filter.ALogTaggedFilter.TagState;
import de.desy.mst.libs.framework.mstapp.logging.map_tinelogsrv.MstLog4TineLog_Facade;
import de.desy.mst.libs.framework.mstapp.security.MstSecurity;
import de.desy.mst.libs.framework.mstapp.util.MstDateFormat;
import de.desy.mst.libs.framework.mstapp.util.gui.AppColor;
import de.desy.mst.libs.framework.mstapp.util.gui.GUIFactory;

/**
 * Auswahl einer Logging Quelle.<br>
 * Benutzung: nur XTor und Komponente in Container Einbinden<br>
 * Kommunikation: via GUI und ALogSource<br>
 * Basis der Implementation ist JFileChooser. Details durch eine
 * "Accessory Component".
 * @author ws
 * @version 1.0.0
 */
class LoggingJFileChooser extends JFileChooser {
	private enum FileTyp {
			LogFile("Protokoll", "Statisches Protokoll von Datei")
			{
				@Override boolean isType(final File file){
					final String name = file.getPath().toLowerCase();
					return name.endsWith(PfadeProtokoll.FILE_SUFFIX)
						|| name.endsWith(".log");
				}
			}
		, 	CSVFile("CSV Datei", "CSV Datei")
				{
				@Override boolean isType(final File file){
					final String name = file.getPath().toLowerCase();
					return name.endsWith(".csv") || name.endsWith(".bak")
												 || name.endsWith(".log")
												 || name.endsWith(".0")
												 || name.endsWith(".txt")
												 || name.endsWith(".dat")
												 ;
				}
			}
		, 	XMLFile("XML Datei", "CSV Datei")
			{
				@Override boolean isType(final File file){
					final String name = file.getPath().toLowerCase();
					return name.endsWith(".xml");
				}
				@Override void readAndShowTheFile(final File file, final LoggingJFileChooser loggingJFileChooser, final String title, final String tip) throws IOException {
					loggingJFileChooser.fireNewXMLFile(file, title, tip);
				}
			}
		;
		//---------------------------------------------------------------------
		/**true if true for any type, false if false for all types*/
		static   boolean isType(final File file, final FileTyp ...fileTypen){
			for (final FileTyp typ : fileTypen) {
				if(typ.isType(file))
					return true;
			}
			return false;
		}
		static void fireNewFile(final File file, final LoggingJFileChooser loggingJFileChooser) {
			if(file == null){
				Logger.SWFW.warn("LoggingSelectionPanel: keine Datei ausgewaehlt.");
				return;
			}
			if(file.isDirectory()){
				final String msg = "LoggingSelectionPanel:"
								 + " ausgewaehlte Datei ist Verzeichnis.";
				Logger.SWFW.warn(msg);
				return;
			}
			final FileTyp typ = calcFileTyp(file);
			if(typ == null){
				Logger.SWFW.warn( "Kann den Dateityp nicht bestimmen: '"
								+ file.getAbsolutePath() +           "'.");
				return;
			}
			typ.readAndShowTheFile(file, loggingJFileChooser);
		}
		private static FileTyp calcFileTyp(final File file) {
			final FileTyp[] values = FileTyp.values();
			for (final FileTyp typ : values) {
				if(typ.isType(file))
					return typ;
			}
			return null;
		}
		//---------------------------------------------------------------------
		final String titlePrefix;
		final String toolTipPrefix;
		private FileTyp(final String titlePrefix, final String toolTipPrefix) {
			this.titlePrefix 	= titlePrefix;
			this.toolTipPrefix	= toolTipPrefix;
		}
		abstract boolean isType			(final File file);
		//---------------------------------------------------------------------
		void readAndShowTheFile(final File file, final LoggingJFileChooser loggingJFileChooser) {
			final String fileName = file.getAbsolutePath();
			final String title = this.titlePrefix   + ": "  + fileName;
			final String tip   = this.toolTipPrefix + ": '" + fileName + "'.";
			try {
				readAndShowTheFile(file, loggingJFileChooser, title, tip);
			} catch (final Exception e) {
				Logger.SWFW.warn("Kann die Datei nicht nutzen " + file, e);
			}
		}
		void readAndShowTheFile(final File file, final LoggingJFileChooser loggingJFileChooser, final String title, final String tip) throws IOException {
			loggingJFileChooser.fireNewLogSource(File_LogSourceFactory.createBestLogSource(file), title, tip);
		}
	}
	private static class ProviderSpezifikation{
		final int    mnemonic;
		final String TITLE;
		final String BUTTON;
		final String TOOLTIP;
		private ProviderSpezifikation(final int mnemonic, final String title, final String button, final String tooltip) {
			this.mnemonic = mnemonic;
			this.TITLE = title;
			this.BUTTON = button;
			this.TOOLTIP = tooltip;
		}
	}
	private static class TineProviderSpezifikation extends ProviderSpezifikation{
		final String logger;
		final String tag;
		final String context;
		final int    seitTagen;
		private TineProviderSpezifikation(final int mnemonic, final String title, final String button, final String tooltip, final int seitTagen, final String logger, final String tag, final String context) {
			super(mnemonic, title, button, tooltip);
			this.seitTagen = seitTagen;

			this.logger  = logger;
			this.tag 	 = tag;
			this.context = context;
		}
		public ALogSource<?,?> createLogSource(final ILogSourceListener lsListener){
			return new LogSource_Clog(this.seitTagen, this.logger, this.tag, this.context);
		}
	}
//-----------------------------------------------------------------------------
	private static final long serialVersionUID = 1L;
	private static final String THIS_APP_NAME  = Main.getAppName();
	private static final UUID   THIS_RUN_RUNID = LogMsg.THIS_RUN_RUNID;
	private static final String OTHER_PROVIDER_TITLE	= "System und Tine Logging/Protokolle";
//-----------------------------------------------------------------------------
	/**pp*/ static final ProviderSpezifikation SYSTEM_PROVIDER =
		new ProviderSpezifikation(
				  KeyEvent.VK_S
				, "Log dieser Applikation"
				, "System Log Anzeigen"
				, "Lebendes System Protokoll wird in einem neuen Tab angezeigt."
				+ " Und dieser Tab angewhlt.");
	private static final ProviderSpezifikation DATEI_PROVIDER =
		new ProviderSpezifikation(
				KeyEvent.VK_D
				, "Ausgewhlte Datei"
				, "Datei Anzeigen"
				, " Datei wird in einem neuen Tab angezeigt."
				+ " Und dieser Tab angewhlt.");

	private static final TineProviderSpezifikation TINE_PROVIDER =
		new TineProviderSpezifikation(
				  KeyEvent.VK_T
				, "Tine Log Server"
				, "Tine Log Anzeigen"
				, "Tine Loggings werden in einem neuen Tab angezeigt."
				+ " Und dieser Tab angewhlt."
				, 0			//0 Tage ... Heute
				, null		//logger
				, null		//tag
				, null		//context
				);
	private static final TineProviderSpezifikation TINE_PROVIDER_WATCHDOG =
		new TineProviderSpezifikation(
				  KeyEvent.VK_W
				, "Watchdog (Tine Log Server)"
				, "Tine Watchdog Log Anzeigen"
				, "Tine Watchdog Loggings werden in einem neuen Tab angezeigt."
				+ " Und dieser Tab angewhlt."
				, 7				//7 Tage ... eine Woche
				, "watchdog"	//logger
				, null		//tag
				, null		//context
				);
	private static final TineProviderSpezifikation TINE_PROVIDER_THISAPPRUN =
		new TineProviderSpezifikation(
				  KeyEvent.VK_H
				, THIS_APP_NAME + " " + THIS_RUN_RUNID + " (Tine Log Server)"
				, "Tine Run Log Anzeigen"
				, "Tine Applikations Run Loggings " + THIS_RUN_RUNID
				+ " werden in einem neuen Tab angezeigt. Und dieser Tab angewhlt."
				, 7			//1 Woche
				, MstLog4TineLog_Facade.getInstance().runId2Logger(THIS_RUN_RUNID)
				, null		//tag
				, null		//context
		){
			@Override public ALogSource<?,?> createLogSource(final ILogSourceListener lsListener){
				return __LSMstLogInTineSrv.createRunLS(this.seitTagen, THIS_APP_NAME, this.logger, lsListener, null);
			}
	};
	private static final TineProviderSpezifikation TINE_PROVIDER_THESE_APPS =
		new TineProviderSpezifikation(
				  KeyEvent.VK_A
				, THIS_APP_NAME + " (Tine Log Server)"
				, "Tine App Log Anzeigen"
				, "Tine Applikations Loggings aller Applikationen '"
				 + THIS_APP_NAME + " 'werden in einem neuen Tab angezeigt."
				 + " Und dieser Tab angewhlt."
				, 1					//1 Tag ... heute und etwas gestern
				, null				//logger
				, THIS_APP_NAME		//tag
				, null				//context
		){
			@Override public ALogSource<?,?> createLogSource(final ILogSourceListener lsListener){
				return __LSMstLogInTineSrv.createApplicationLS(this.seitTagen, THIS_APP_NAME, lsListener, null);
			}
	};
	private static final TineProviderSpezifikation TINE_PROVIDER_MstLog_System =
		new TineProviderSpezifikation(
				  KeyEvent.VK_H
				, "Alle MstApp Heartbeat Logs (Tine Log Server)"
				, "Tine MstApp HB Logs Anzeigen"
				, "Tine Applikations System Log Eintrge werden in einem neuen"
				+ " Tab angezeigt. Und dieser Tab angewhlt."
				, 7		//7 Tage ... eine Woche
				, null	//logger
				, null	//tag
				, MstLog4TineLog_Facade.getInstance().getSystemContext()
		){
		@Override public ALogSource<?,?> createLogSource(final ILogSourceListener lsListener){
			return __LSMstLogInTineSrv.createSystemLS(this.seitTagen, lsListener); 
		}
	};


//-----------------------------------------------------------------------------

	public static String getSystemProviderTitle(){return SYSTEM_PROVIDER.TITLE;}

//=============================================================================
	private final ILogSourceListener listener;
	private final File  home;
	private final JMenu menuLog;
	private final MenuCSVManager menuCSVMgr;

	//accessory components
	private final AbstractButton accCompApprove;	//approve Button
	private final JLabel[][]       accCompInfos;	//[EInfoTyp] [EInfoComp]

//=============================================================================
	public LoggingJFileChooser(final ApplicationInfo appInfo, final ILogSourceListener listener){
		super();
		this.listener = (listener == null) ?
						new NullLogSourceListener() :
						listener;

		this.home			= createHome(appInfo);
        this.menuLog		= createMenuLog(appInfo);
        this.menuCSVMgr		= new MenuCSVManager(createMenuCSV(appInfo));
		this.accCompApprove = createAccCompApprove();
		this.accCompInfos   = createAccCompInfos();
		initialize();
	}
//=============================================================================
	/**@return JMenu zur Protokollauswahl*/
	JMenu getJMenuLog() {return this.menuLog;}
	/**@return JMenu zur Protokollauswahl*/
	JMenu getJMenuCSV() {return getMenuCSVMgr().getJMenuCSV();}
	MenuCSVManager getMenuCSVMgr() {return this.menuCSVMgr;}

//=============================================================================
	private JMenu createMenuLog(final ApplicationInfo appInfo) {
		final JMenu menu = new JMenu("Loggings & Protokolle");
		menu.setMnemonic(KeyEvent.VK_P);
		menu.addMenuListener(new MenuListener() {
			@Override public void menuCanceled(final MenuEvent evt) {}
			@Override public void menuDeselected(final MenuEvent evt) {}
			@Override public void menuSelected(final MenuEvent evt) {
				menu.removeAll();
				createMenuLog(appInfo, menu);
			}
		});
		return menu;
	}
	/**late creation due to "Logger._hasTineLogAppender()" late knowledge*/
	private void createMenuLog(final ApplicationInfo appInfo, final JMenu menu) {
		menu.add(createMenuItemSystem(SYSTEM_PROVIDER));
		menu.addSeparator();
		menu.add(createMenuDatei	 (DATEI_PROVIDER, appInfo));
		menu.add(createMenuDateiTemp ("", LoggerManager.getTempDateiAppender()));
		menu.addSeparator();
		menu.add(createMenuItemTine	 (TINE_PROVIDER));
		menu.add(createMenuItemTine	 (TINE_PROVIDER_WATCHDOG));
		menu.add(createMenuLogMstLogInTineServer());
	}

	private JMenu createMenuCSV(final ApplicationInfo appInfo) {
		final JMenu menu = new JMenu("CSV und andere Dateien");
		menu.setMnemonic(KeyEvent.VK_C);
		menu.setVisible(true);
		final String hostname = MstSecurity.get().getHostName();
		menu.add(createMenuItemDatei("Dieser PC", hostname, createTineVerzRootFile(hostname)));
		menu.add(createMenuItemDatei("Dieser PC Ini Cache", hostname, createLocalCacheFile(ABaseDataOfMstIni.SRV_NAME)));
		menu.add(createMenuItemDatei("Web Ini Dateien",     hostname, createWebCacheFile  (ABaseDataOfMstIni.SRV_NAME)));
		return menu;
	}
	private JMenuItem createMenuItemDatei(final String titel, final String hostName, final File root){
		final JMenu menu = new JMenu(titel);
		menu.setEnabled(root != null);
		menu.setToolTipText(titel + " " + hostName);
		final MenuDateiFactoryCSV menuDateiFactory = new MenuDateiFactoryCSV();
		menu.addMenuListener(new MenuListener() {
			@Override public void menuCanceled(final MenuEvent evt) {}
			@Override public void menuDeselected(final MenuEvent evt) {}
			@Override public void menuSelected(final MenuEvent evt) {
				menu.removeAll();
				menuDateiFactory.populate(menu, root);
			}
		});
		return menu;
	}
	private File createLocalCacheFile(final String srvName) {
		return LocalHome.noLocalHomeWanted() ? null
						: new File(LocalHome.calcLocalDirectory(srvName, null));
	}
	private File createWebCacheFile(final String srvName) {
		final String webAddress = PfadeIni.ROOT;
		final String fileName = WebHome.calcFullFileNameInsideWebServer(webAddress);
		final File file = new File(fileName);
		return file.exists() ? file : null;
	}
	private File createTineVerzRootFile(final String hostName) {
		final String spec = "file://///" + hostName + "/controls/";
		try {
			final URI uri = new URI(spec);
			return new File(uri);
		} catch (final URISyntaxException e) {
			Logger.SWFW.warn("Kann die URI '" + spec
						   + "' fr den nicht erzeugen.");
			return null;
		}
	}
	private JMenuItem createMenuItemSystem(final ProviderSpezifikation provider) {
		final JMenuItem item = new JMenuItem(provider.BUTTON);
		item.setMnemonic(provider.mnemonic);
		item.setToolTipText(provider.TOOLTIP);
		item.addActionListener(new java.awt.event.ActionListener() {
			@Override public void actionPerformed(final java.awt.event.ActionEvent e) {
				fireNewLogSource_System();
			}
		});
		return item;
	}
	private JMenu createMenuDatei(final ProviderSpezifikation provider
								, final ApplicationInfo appInfo) {
		final JMenu menu = new JMenu("Datei aus dem Protokollcache");
		menu.setMnemonic(provider.mnemonic);
		menu.setToolTipText(provider.TOOLTIP);
		final PfadeProtokoll pfade = new PfadeProtokoll(appInfo);
		final File root = LocalHome.noLocalHomeWanted() ? null
									   : new File(pfade.getSystemRoot_Datei());
		menu.setEnabled(root != null && root.exists());
		final MenuDateiFactoryMstLog menuDateiFactory = new MenuDateiFactoryMstLog(this.home);
		menu.addMenuListener(new MenuListener() {
			@Override public void menuCanceled(final MenuEvent evt) {}
			@Override public void menuDeselected(final MenuEvent evt) {}
			@Override public void menuSelected(final MenuEvent evt) {
				menu.removeAll();
				menuDateiFactory.populate(menu, root);
			}
		});
		return menu;
	}
	private JMenuItem createMenuDateiTemp(final String titel, final List<LogAppenderFile> tempDateiAppender) {
		final JMenu menu = new JMenu("Datei aus einem Temporren Verzeichnis");
		menu.setMnemonic(KeyEvent.VK_O);
		menu.setToolTipText("Fr Windows gibt es optionale Scratch Dateien.");
		for (final LogAppenderFile logAppenderFile : tempDateiAppender)
			menu.add(createMenuDatei(logAppenderFile));
		return menu;
	}
	private JMenuItem createMenuDatei(final LogAppenderFile logAppenderFile) {
		final File path = logAppenderFile.getFile();
		final LMTag tag = logAppenderFile.getFilter().getTag(TagState.ON);
		final File root = (path == null) ? null : calcRoot(path, tag.getName());
		final JMenu menu = new JMenu(tag.getName());
		menu.setEnabled(root != null && root.exists());
		final MenuDateiFactoryMstLog menuDateiFactory = new MenuDateiFactoryMstLog(path);
		menu.addMenuListener(new MenuListener() {
			@Override public void menuCanceled(final MenuEvent evt) {}
			@Override public void menuDeselected(final MenuEvent evt) {}
			@Override public void menuSelected(final MenuEvent evt) {
				menu.removeAll();
				menuDateiFactory.populate(menu, root);
			}
		});
		return menu;
	}
	private File calcRoot(final File path, final String tagName) {
		final File parentFile = path.getParentFile();
		final boolean parentFileIsCandidate = parentFile.getAbsolutePath().contains(tagName);
		return parentFileIsCandidate ? calcRoot(parentFile, tagName) : path;

	}

	private JMenu createMenuLogMstLogInTineServer() {
		final boolean enabled = Logger._hasTineLogAppender();

		final JMenu menu = new JMenu("MstLog im TineServer");
		menu.setMnemonic(KeyEvent.VK_S);
		menu.add(createMenuItemTine(TINE_PROVIDER_MstLog_System));
		menu.add(createMenuItemTine(TINE_PROVIDER_THESE_APPS, enabled));
		menu.add(createMenuItemTine(TINE_PROVIDER_THISAPPRUN, enabled));
		return menu;
	}

	private JMenuItem createMenuItemTine(final TineProviderSpezifikation provider){
		return createMenuItemTine(provider, true);
	}
	private JMenuItem createMenuItemTine(final TineProviderSpezifikation provider, final boolean enabled) {
		final JMenuItem item = new JMenuItem(provider.TITLE);
		item.setEnabled(enabled);
		item.setMnemonic(provider.mnemonic);
		item.setToolTipText(provider.TOOLTIP);
		item.addActionListener(new java.awt.event.ActionListener() {
			@Override public void actionPerformed(final java.awt.event.ActionEvent e) {
				try {
					fireNewLogSource_Tine(provider);
					final JMenu refMenu = new JMenu();
					item.setForeground(refMenu.getForeground());
					item.setBackground(refMenu.getBackground());
					item.setToolTipText(provider.TOOLTIP);
				} catch (final IOException ex) {
					final String msg = "Kann den Tine Provider nicht erzeugen.";
					Logger.SWFW.warn(msg, ex);
					AppColor._FEHLER.set(item);
					item.setToolTipText(msg + " '" + ex.getMessage() +"'");
				}
			}
		});
		return item;
	}
	private void initialize() {
		this.setMultiSelectionEnabled(false);
		/*vor dem ActionListener*/
		this.setSelectedFile(getHome());

		this.addActionListener			(createActionListener());
		this.addChoosableFileFilter		(createFileFilter());
		this.addPropertyChangeListener	(createPropertyChangeListener());
		this.setAccessory(createAccessory());

		initializeOriginalControlButtons();
		onNewFile();
	}

	private File createHome(final ApplicationInfo appInfo) {
		final PfadeProtokoll pfadeProtokoll = (appInfo == null)?
					new PfadeProtokoll(ApplicationInfo._UNKNOWN_APP_INFO) :
					new PfadeProtokoll(appInfo);
		if(!pfadeProtokoll.isCachable())
			return null;

		if(isGeneralViewer(appInfo))	//ein tiefer als System Root:
			return neuestSubfile(new File(pfadeProtokoll.getSystemRoot_Datei()));

		final String protPfad = pfadeProtokoll.getCacheDateiPfad();
		final File file = new File(protPfad).getParentFile();
		if(file == null)
			return null;

		if(file.exists())
			return neuestSubfile(file);
		return existingParenDir(file);
	}
	/**MstLogViewer in Root starten, sonst (+WS debug) im aktuellen AppVerz*/
	private boolean isGeneralViewer(final ApplicationInfo appInfo) {
		final String frameName = appInfo.getFrameName();
		final String logViewerName = "de.desy.mst.common.info.mstlogviewer.MstLogViewer";
		return logViewerName.equals(frameName)
			&& !MstSecurity.get().getHostName().equalsIgnoreCase("MstXpWs2");
	}
	private File existingParenDir(final File file) {
		final File parentFile = file.getParentFile();
		if(parentFile == null)
			return file;
		if(parentFile.exists()){
			return parentFile;
		}
		return existingParenDir(parentFile);
	}
	private File neuestSubfile(final File file) {
		final File[] list = file.listFiles();
		if(list == null || list.length == 0)
			return file;

		File result = list[0];
		for (int i = 1; i < list.length; i++) {
			if(list[i].lastModified() > result.lastModified())
				result = list[i];
		}
		return result;
	}

	private ActionListener createActionListener() {
		return new ActionListener(){
			@Override public void actionPerformed(final ActionEvent e) {
				final String actionCommand = e.getActionCommand();
				if(JFileChooser.APPROVE_SELECTION.equals(actionCommand)){
					onApproveSelection();
				}else if(JFileChooser.CANCEL_SELECTION.equals(actionCommand)){
					onCancelSelection();
				}else{
					onOtherAction(e);
				}
			}
			private void onOtherAction(final ActionEvent e) {
				final String msg = "LoggingSelectionPanel:"
					+ " Encountered unexpected"
					+ " actionCommand in JFileChooser: "
					+ e;
				Logger.SWFW.warn(msg);
			}
		};
	}
	private void onApproveSelection() {
		final File file = this.getSelectedFile();
		if(isValidFile(file))
			fireNewLogSource_File(file);
	}
	private void onCancelSelection() {this.setSelectedFile(getHome());}
	private FileFilter createFileFilter() {
		return new FileFilter(){
			@Override public boolean accept(final File f) {
				return FileTyp.isType(f, FileTyp.LogFile, FileTyp.CSVFile)
					|| f.isDirectory();
			}
			@Override public String getDescription() {
				return "Mst Logger und Protokoll Dateien ("
					 + PfadeProtokoll.FILE_SUFFIX + ")"
					 + ", CSV Dateien (*.csv) ...";
			}
		};
	}
	private PropertyChangeListener createPropertyChangeListener() {
		return new PropertyChangeListener(){
			@Override public void propertyChange(final PropertyChangeEvent evt) {
				final String prop = evt.getPropertyName();
				if(JFileChooser.DIRECTORY_CHANGED_PROPERTY.equals(prop)) {
					onNewDir();
				}else if(JFileChooser.SELECTED_FILE_CHANGED_PROPERTY.equals(prop)) {
					onNewFile();
				}else{
					onOtherPropertyChange(prop);
				}
			}
			private void onOtherPropertyChange(final String prop) {
				//System.out.println("Other Propchange: " + prop);
			}
		};
	}
	private void onNewFile() {
		final File file = this.getSelectedFile();
		updateAccComp(file);
	}
	private void onNewDir() {
		final File dir = this.getCurrentDirectory();
		updateAccCompInfo(dir);
	}

	private void initializeOriginalControlButtons() {
		this.setControlButtonsAreShown(false);	//eigene, Rest fr exotiC GUIs
		this.setApproveButtonText(DATEI_PROVIDER.BUTTON);
		final String toolTipText = DATEI_PROVIDER.TOOLTIP;
		this.setApproveButtonToolTipText(toolTipText);
	}
//-----------------------------------------------------------------------------
	private JComponent createAccessory() {
		final JPanel accessory = new JPanel();
		accessory.setLayout(new BorderLayout());
		accessory.add(createAccessory_SystemLogging(), BorderLayout.NORTH);
		accessory.add(createAccessory_DateiInfos(),    BorderLayout.CENTER);
		accessory.add(createAccessory_DateiControls(), BorderLayout.SOUTH);

		return accessory;
	}
	private JComponent createAccessory_SystemLogging() {
		final JPanel panel = new JPanel();
		panel.setBorder(createTitledBorder(OTHER_PROVIDER_TITLE));
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
		panel.add(createAccessory_SystemLogging_Button());
		panel.add(Box.createVerticalStrut(15));
		panel.add(createAccessory_TineLogging_Button(TINE_PROVIDER));
		panel.add(Box.createVerticalStrut(15));
		panel.add(createAccessory_TineLogging_Button(TINE_PROVIDER_WATCHDOG));
//		if(Logger._hasTineLogAppender() || THIS_APP_NAME.contains("LogViewer")){
//			panel.add(Box.createVerticalStrut(15));
//			panel.add(createAccessory_TineLogging_Button(TINE_PROVIDER_THISAPPRUN));
//			panel.add(Box.createVerticalStrut(15));
//			panel.add(createAccessory_TineLogging_Button(TINE_PROVIDER_THESE_APPS));
//			panel.add(Box.createVerticalStrut(15));
//			panel.add(createAccessory_TineLogging_Button(TINE_PROVIDER_MstLog_System));
//		}
		return panel;
	}
	private TitledBorder createTitledBorder(final String text) {
		return BorderFactory.createTitledBorder(
				  null
				, text
				, TitledBorder.DEFAULT_JUSTIFICATION
				, TitledBorder.DEFAULT_POSITION
				, new Font("Dialog", Font.BOLD, 12)
				, new Color(51, 51, 51)
												);
	}
	private JButton createAccessory_SystemLogging_Button() {
		final JButton button = new JButton(SYSTEM_PROVIDER.BUTTON);
		button.setToolTipText(SYSTEM_PROVIDER.TOOLTIP);
		button.addActionListener(new java.awt.event.ActionListener() {
			@Override public void actionPerformed(final java.awt.event.ActionEvent e) {
				fireNewLogSource_System();
			}
		});
		return button;
	}
	private JButton createAccessory_TineLogging_Button(final TineProviderSpezifikation providerSp) {
		final JButton button = new JButton(providerSp.BUTTON);
		button.setToolTipText(providerSp.TOOLTIP);
		button.addActionListener(new java.awt.event.ActionListener() {
			@Override public void actionPerformed(final java.awt.event.ActionEvent e) {
				try {
					fireNewLogSource_Tine(providerSp);
					final JButton refButton = new JButton();
					button.setForeground(refButton.getForeground());
					button.setBackground(refButton.getBackground());
					button.setToolTipText(providerSp.TOOLTIP);
				} catch (final IOException ex) {
					final String msg = "Kann den Tine Provider nicht erzeugen.";
					Logger.SWFW.warn(msg, ex);
					AppColor._FEHLER.set(button);
					button.setToolTipText(msg + " '" + ex.getMessage() +"'");
				}
			}
		});
		return button;
	}

	private Component createAccessory_DateiInfos() {
		final JPanel panelOuter = new JPanel(new BorderLayout());
		final JPanel panelInner = new JPanel(new BorderLayout());
				final JPanel[] panels  = {new JPanel(), new JPanel()};
				final int[]    nBlanks = {10,           60};
				for (int i = 0; i < panels.length; i++) {
					final JPanel panel = panels[i];
					panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
					panel.add(new JLabel(createNBlanks(nBlanks[i])));
//					final String title = EInfoTyp.values()[i].name();
//					panel.setBorder(createTitledBorder(title));
				}

				final int iTitel = EInfoTyp.Titel.ordinal();
				final int iText  = EInfoTyp.Text. ordinal();
				final EInfoComp[] values = EInfoComp.values();
				for (final EInfoComp infoComp : values) {
					panels[iTitel].add(getAccCompInfo(EInfoTyp.Titel, infoComp));
					panels[iText] .add(getAccCompInfo(EInfoTyp.Text,  infoComp));
				}
				panels[iTitel].add(new JLabel(" "));

			panelInner.add(panels[iTitel], BorderLayout.WEST);
			panelInner.add(panels[iText ], BorderLayout.CENTER);
		panelOuter.add(panelInner, BorderLayout.SOUTH);
		return panelOuter;
	}

	private String createNBlanks(int i) {
		final StringBuffer sb = new StringBuffer(i);
		while(i-- > 0){
			sb.append(" ");
		}
		return sb.toString();
	}
	private Component createAccessory_DateiControls() {
		final JPanel panel = new JPanel();
		panel.setBorder(createTitledBorder(DATEI_PROVIDER.TITLE));
		panel.setLayout(new FlowLayout(FlowLayout.RIGHT));
		panel.add(getAccCompApprove());
		return panel;
	}
	private AbstractButton createAccCompApprove() {
		final JButton button = new JButton();
		button.addActionListener(new java.awt.event.ActionListener() {
			@Override public void actionPerformed(final java.awt.event.ActionEvent e) {
				onApproveSelection();
			}
		});
		return button;
	}
	private JLabel[][] createAccCompInfos() {
		final EInfoComp[] comps = EInfoComp.values();
		final int n = comps.length;
		final JLabel[][] infos = new JLabel[EInfoTyp.values().length][n];
		for (int i = 0; i < n; i++) {
			final EInfoComp comp = comps[i];
			infos[EInfoTyp.Titel.ordinal()][i] = new JLabel( comp.name()
														   + ":    "	);
			final JLabel textLabel = new JLabel("");
			textLabel.addMouseListener(new MouseAdapter(){
				@Override public void mouseClicked(final MouseEvent e) {
					final String path = textLabel.getToolTipText();
					final File file = new File(path);
					setCurrentDirectory(file);
					super.mouseClicked(e);
				}
			});
			infos[EInfoTyp.Text .ordinal()][i] = textLabel;

		}
		return infos;
	}
//-----------------------------------------------------------------------------
	private ILogSourceListener getLogSourceListener(){return this.listener;}
	private File getHome()	{return this.home;}
	private AbstractButton getAccCompApprove() 	{return this.accCompApprove;}
	private JLabel getAccCompInfo(final EInfoTyp  infoTyp
								, final EInfoComp infoComp){
		return this.accCompInfos[infoTyp.ordinal()][infoComp.ordinal()];
	}

	private void updateAccComp(final File file) {
		updateAccCompApprove(file);
		if(file != null && file.exists())
			updateAccCompInfo(file);
	}
	private void updateAccCompApprove(final File file) {
		final AbstractButton compApprove = getAccCompApprove();
		final boolean validFile = isValidFile(file);
		compApprove.setEnabled(validFile);

		final String textSuffix = (validFile)? " (" + file.getName() + ")" : "";
		compApprove.setText(DATEI_PROVIDER.BUTTON + textSuffix);

		final String ttPrefix = (validFile)? file.getAbsolutePath() : "";
		compApprove.setToolTipText(ttPrefix + DATEI_PROVIDER.TOOLTIP);
	}
	private void updateAccCompInfo(final File file) {
		final FileComp fc = new FileComp(file);
		final EInfoComp[] comps = EInfoComp.values();
		for (final EInfoComp infoComp : comps) {
			final JLabel label = getAccCompInfo(EInfoTyp.Text, infoComp);
			final String text = fc.getText(infoComp);
			label.setText(text);
			label.setToolTipText(fc.getTextLong(infoComp));
		}
	}

	private void fireNewXMLFile(final File file, final String title, final String tip) {
		final Runnable runnable = new Runnable() {
			@Override public void run() {fireNewXMLFile_(file, title, tip);}
		};
		GUIFactory.runInExtraThread_showingBusyDialog(runnable, LoggingJFileChooser.this, title, true);
	}
	private void fireNewXMLFile_(final File file, final String title, final String tip) {
		try {
			final FileInputStream fis = new FileInputStream(file);
			final TextInputStreamUtility tisu = new TextInputStreamUtility(fis);
			final String contents = tisu.getContentsAsString();
			final String textType = "text/xml";
			getLogSourceListener().onNewDisplayText(contents, textType, title, tip);
		} catch (final IOException ex) {
			Logger.SWFW.warn("Kann die Datei nicht nutzen " + file, ex);
		}
	}

	private void fireNewLogSource(final ALogSource<?,?> logSource
								, final String title
								, final String tip) {
		getLogSourceListener().onNewLogSource(logSource, title, tip);
	}
	private void fireNewLogSource_Tine(final TineProviderSpezifikation provider) throws IOException {
		final Runnable runnable = new Runnable() {
			@Override public void run() {fireNewLogSource_Tine_(provider);}
		};
		GUIFactory.runInExtraThread_showingBusyDialog(runnable, LoggingJFileChooser.this, provider.BUTTON, true);
	}
	private void fireNewLogSource_Tine_(final TineProviderSpezifikation provider) {
		final ALogSource<?, ?> logSource = provider.createLogSource(getLogSourceListener());
		SwingUtilities.invokeLater(new Runnable() {
			@Override public void run() {
				fireNewLogSource(logSource
							   , provider.TITLE
							   , provider.TOOLTIP
								);
			}
		});
	}

	private void fireNewLogSource_System() {
		fireNewLogSource(__LSSystem.getInstance()
					   , SYSTEM_PROVIDER.TITLE
					   , SYSTEM_PROVIDER.TOOLTIP
						);
	}
	private void fireNewLogSource_File(final File file){
		FileTyp.fireNewFile(file, this);
	}

	private static boolean isValidFile(final File file) {
		return (file != null)
			&& (file.exists())
			&& (!file.isDirectory())
			;
	}

//=============================================================================
	private enum EInfoTyp{Titel, Text;}
	enum EInfoComp{Facility, Subsystem, Applikation, Datei;}
//-----------------------------------------------------------------------------
	private static abstract class MenuDateiFactory{
		private static final String IGNORE_DIR_PREFIX = "___";	//do not show dirs that start like this
		private static final MstDateFormat fileDateFormat = new MstDateFormat("yyyy.MM.dd HH:mm:ss");;
		//---------------------------------------------------------------------
		private final java.io.FileFilter  dirFilter;
		//---------------------------------------------------------------------
		public MenuDateiFactory() {
			super();
			this.dirFilter = new java.io.FileFilter(){
				@Override public boolean accept(final File file){return file.isDirectory();}
			};
		}
		//---------------------------------------------------------------------
		abstract java.io.FileFilter getLogFileFilter();
		abstract ActionListener createActionListenerNewFile(final File file);
		//---------------------------------------------------------------------
		void handleHomePath(final File dir, final JMenuItem item){/**ignore*/;}
		void populate(final JMenu menu, final File  dir) {
			final File[] directories = dir.listFiles(this.dirFilter);
			if(directories == null)
				return;
			if(directories.length > 1)
				Arrays.sort(directories);
			for (final File subDir : directories) {
				if(!subDir.getName().startsWith(IGNORE_DIR_PREFIX))
					menu.add(createDirMenu(subDir));
			}

			final File[] logFiles = dir.listFiles(getLogFileFilter());
			if(logFiles.length > 1)
				Arrays.sort(logFiles);
			for (final File file : logFiles) {
				menu.add(createMenuItemFile(file));
			}
			if(logFiles.length == 0 && directories.length == 0)
				handleDirIsEmpty(menu);
		}
		void markForHomePath(final JComponent cmp) {
			cmp.setBackground(Color.white);
			cmp.setBorder(BorderFactory.createLineBorder(Color.DARK_GRAY, 1));
		}
		//---------------------------------------------------------------------
		private JMenu createDirMenu(final File dir){
			final JMenu menu = new JMenu(dir.getName());
			handleHomePath(dir, menu);
			menu.setToolTipText(dir.getAbsolutePath());
			menu.addMenuListener(new MenuListener() {
				@Override public void menuCanceled(final MenuEvent evt) {}
				@Override public void menuDeselected(final MenuEvent evt) {}
				@Override public void menuSelected(final MenuEvent evt) {
					menu.removeMenuListener(this);	//nur einmal hinzufuegen
					populate(menu, dir);
				}
			});
			return menu;
		}
		private JMenuItem createMenuItemFile(final File file) {
			final String text = "(" + calcDateString(file.lastModified()) 
									+ "):    " + file.getName();
			final JMenuItem item = new JMenuItem(text);
			handleHomePath(file, item);
			item.addActionListener(createActionListenerNewFile(file));
			return item;
		}
		private String calcDateString(final long lastModified) {
			return MenuDateiFactory.fileDateFormat.format(new Date(lastModified));
		}
		private void handleDirIsEmpty(final JMenu menu) {
			menu.setEnabled(false);
			handleParentOfDisabledMenu(menu);
		}
		private void handleParentOfDisabledMenu(final JComponent menu) {
			final Container parent = moveUp(menu);
			if(parent == null)
				return;
			final Component[] children = parent.getComponents();
			for (final Component component : children)
				if(component.isEnabled())
					return;
			parent.setEnabled(false);
			handleParentOfDisabledMenu((JComponent) parent);
		}
		private Container moveUp(final JComponent menu) {
			if(menu instanceof JPopupMenu){
				final Component invoker = ((JPopupMenu)menu).getInvoker();
				if( invoker != null
				&& (invoker instanceof JPopupMenu || invoker instanceof JMenu))
					return (JComponent) invoker;
			}

			if(menu.getParent() == null
			   || !(menu.getParent() instanceof JPopupMenu || menu.getParent() instanceof JMenu ) )
				return null;
			return menu.getParent();
		}
	}//END class MenuDateiFactory
	private class MenuDateiFactoryMstLog extends MenuDateiFactory{
		private final java.io.FileFilter logFileFilter =
			new java.io.FileFilter(){
			@Override public boolean accept(final File file){
				return FileTyp.isType(file, FileTyp.LogFile);
			}
		};
		private final File home;
		//---------------------------------------------------------------------
		public MenuDateiFactoryMstLog(final File home) {
			super();
			this.home = home;
		}
		//---------------------------------------------------------------------
		@Override java.io.FileFilter getLogFileFilter() {
			return this.logFileFilter;
		}
		@Override void handleHomePath(final File dir, final JMenuItem item) {
			if(this.home.getAbsolutePath().startsWith(dir.getAbsolutePath()))
				markForHomePath(item);
		}
		@Override ActionListener createActionListenerNewFile(final File file) {
			return new ActionListener(){
				@Override public void actionPerformed(final ActionEvent evt) {
					fireNewLogSource_File(file);
				}
			};
		}
		//---------------------------------------------------------------------
	}//END class MenuDateiFactoryMstLog
	class MenuDateiFactoryCSV extends MenuDateiFactory{
		private final java.io.FileFilter logFileFilter =
			new java.io.FileFilter(){
			@Override public boolean accept(final File file){
				return FileTyp.isType(file, FileTyp.CSVFile, FileTyp.XMLFile);
			}
		};
		//---------------------------------------------------------------------
		@Override java.io.FileFilter getLogFileFilter() {
			return this.logFileFilter;
		}
		@Override ActionListener createActionListenerNewFile(final File file) {
			return new ActionListener(){
				@Override public void actionPerformed(final ActionEvent evt) {
					fireNewLogSource_File(file);
				}
			};
		}
		//---------------------------------------------------------------------
	}//END class MenuDateiFactoryCSV
	class MenuCSVManager{
		private final String[] SHARE_KANDIDATEN = {"Database", "Log", "History", "controls"};
		private final JMenu menuCSV;
		private final List<String> names = new LinkedList<String>();
		//---------------------------------------------------------------------
		public MenuCSVManager(final JMenu menuCSV) {
			super();
			this.menuCSV = menuCSV;
		}
		//---------------------------------------------------------------------
		JMenu getJMenuCSV() {return this.menuCSV;}
		public void fireNewFec(final String link){
			processNewPCName(pcName(link));
		}
		//---------------------------------------------------------------------
		private void processNewPCName(final String pcName) {
			if(this.names.contains(pcName))
				return;	//nothing to do
			this.names.add(pcName);
			final JMenu menu = new JMenu(pcName);
			menu.setEnabled(false);
			getJMenuCSV().add(menu);
			for (final String shareKandidat : this.SHARE_KANDIDATEN) {
				processShareKandidat(pcName, menu, shareKandidat);
			}
		}
		private void processShareKandidat(final String pcName, final JMenu menu, final String shareKandidat) {
			final String name = File.separator + File.separator + pcName
							  + File.separator + shareKandidat;
			final File file = new File(name);
			final SwingWorker<Boolean, Void> swingWorker =
				new SwingWorker<Boolean, Void>(){
				@Override protected Boolean doInBackground() throws Exception {
					return file.exists();	//kann bei nichtexistenz etwas dauern
				}
				@Override protected void done() {
					try {	if(isDone() && get().equals(Boolean.TRUE)){
				 				menu.add(createRootMenuItem(shareKandidat, file));
								menu.setEnabled(true);
							}
						}
					catch (final InterruptedException ex) {}
					catch (final ExecutionException   ex) {}
				}
			};
			swingWorker.execute();
		}
		private JMenuItem createRootMenuItem(final String shareKandidat, final File root){
			final JMenu menu = new JMenu(shareKandidat);
			menu.setEnabled(root != null);
			menu.setToolTipText(shareKandidat);
			final MenuDateiFactoryCSV menuDateiFactory = new MenuDateiFactoryCSV();
			menu.addMenuListener(new MenuListener() {
				@Override public void menuCanceled(final MenuEvent evt) {}
				@Override public void menuDeselected(final MenuEvent evt) {}
				@Override public void menuSelected(final MenuEvent evt) {
					if(root == null)
						return;
					menu.removeMenuListener(this);
					menu.removeAll();
					menuDateiFactory.populate(menu, root);
				}
			});
			return menu;
		}
		String pcName(final String path) {
			// Input: \\MSTDOALARM\Log\SCR_08_04_16_21.bmp
			// Input: file://///MSTDOALARM/Log/SCR_08_04_16_21.bmp
			//Output:   MSTDOALARM
			final int indexOf = path.indexOf(":");
			if(indexOf > 0)
				return pcName(path.substring(indexOf));
			final String[] split = path.split("[^\\w]");	//nonwordcharacter
			for (int i = 0; i < split.length; i++) {
				final String string = split[i];
				if(		string == null
					|| 	string.isEmpty()
					|| 	string.toLowerCase().equals("file"))
					continue;
				return string;
			}
			return "";
		}
	}//END class MenuCSVManager
//==============================================================================
	/**pp. internal immutable*/
	static class FileComp{
		private final List<File> components;
		//---------------------------------------------------------------------
		public FileComp(final File file) {
			this.components = createComponents(file);
		}
		//---------------------------------------------------------------------
		public File getFile(final EInfoComp comp){
			return this.components.get(comp.ordinal());
		}
		public String getText(final EInfoComp comp){
			final File file = getFile(comp);
			return (file == null) ? ""
								  : file.getName();
		}
		public String getTextLong(final EInfoComp comp){
			final File file = getFile(comp);
			return (file == null) ? ""
								  : file.getPath();
		}
		//---------------------------------------------------------------------
		private List<File> createComponents(final File original) {
			final int n = EInfoComp.values().length;
			final File[] cmpts = new File[n];
//			cmpts[EInfoComp.Original.ordinal()] = original;
 
			final List<File> files = createListOfDirsUpTo(PfadeProtokoll.SRV_NAME
												  , original
													);
			final int nComp = EInfoComp.Datei.ordinal() + 1;
			for (int iComp = 0, iFiles = files.size() - 1
					; (iComp < nComp) && (iFiles >= 0)
					; iComp++, iFiles--) {
				cmpts[iComp] = files.get(iFiles);
			}
			if(files.size() > nComp)
				//zu viele subdirs
				cmpts[nComp - 1] = files.get(0);

			final List<File> asList = Arrays.asList(cmpts);
			return Collections.unmodifiableList(asList);
		}
		private List<File> createListOfDirsUpTo(final String rootString
											  , final File   original) {
			final int capacity = EInfoComp.values().length;
			final List<File> files = new ArrayList<File>(capacity);
			File current = original;

			while ( current.getAbsolutePath().contains(rootString)
				&& !current.getAbsolutePath().endsWith(rootString)	){
				files.add(current);
				current = current.getParentFile();
			};

			return files;
		}
	}
}
//=============================================================================
