/**
 * May  6, 2008 - May  6, 2008	ws:	Creation from scratch
 * Aug  4, 2008 - Aug  4, 2008	ws:	add JMenuBar
 * Aug 26, 2008 - Sep  2, 2008	ws:	auch mit LogSourceSpezifisch only
 * Oct 21, 2008 - Oct 21, 2008	ws:	extend JDialogWithCloseOnEscape statt JDialog
 * Jan  8, 2009 - Jan  8, 2009	ws:	title with in XTor calcAnnotatedTitle()
 * Feb  5, 2009 - Feb  5, 2009	ws:	getLoggingJTabbedPane().dispose();
 * Jul 30, 2009 - Jul 30, 2009	ws:	system Log Source in eigener Klasse
 * Jan 15, 2010 - Jan 15, 2010	ws:	XTor super(...., modal = FALSE) wegen threading issues
 * Apr 28, 2010 - Apr 28, 2010	ws:	allow modal = FALSE for crashframe
 */
package de.desy.mst.libs.framework.mstapp.logging.gui;

import java.awt.Dialog;
import java.awt.Frame;
import java.io.File;
import java.io.IOException;

import javax.swing.JMenuBar;

import de.desy.mst.libs.framework.mstapp.IMstAppKernel;
import de.desy.mst.libs.framework.mstapp.Main;
import de.desy.mst.libs.framework.mstapp.MstApp;
import de.desy.mst.libs.framework.mstapp.Screen;
import de.desy.mst.libs.framework.mstapp.ini.ITabelle;
import de.desy.mst.libs.framework.mstapp.util.gui.JDialogWithCloseOnEscape;

/**
 * Zeigt das Protokoll/Dateien als Dialog
 * @author ws
 * @version 1.0.0
 */
@SuppressWarnings({"rawtypes", "unchecked"})
public class ViewerDialog extends JDialogWithCloseOnEscape{
	private static final long serialVersionUID = 1L;
	//=============================================================================
	public static ITabelle createLogSource(final File file) throws IOException {
		return File_LogSourceFactory.createBestLogSource(file);
	}
	public static ViewerDialog createSystemLoggingDialog(final Frame owner, final MstApp mstApp){
		   return new ViewerDialog(owner
				   				 , mstApp
				   				 , __LSSystem.getInstance()
				   				 , LoggingJFileChooser.getSystemProviderTitle()
				   				 , "System Log/Protokoll wird angezeigt");
	}
	public static ViewerDialog createGeneralLoggingDialog(final Dialog owner, final IMstAppKernel mstAppK, final boolean modal){
		return new ViewerDialog(owner, mstAppK, modal);
	}
	public static ViewerDialog createGeneralLoggingDialog(final Frame owner, final IMstAppKernel mstAppK, final boolean modal){
		return new ViewerDialog(owner, mstAppK, modal);
	}
	public static ViewerDialog createGeneralLoggingDialog(final Frame owner, final MstApp mstApp){
		return new ViewerDialog(owner, mstApp);
	}
	/**ITabelle muss eine LogSource sein (HACK)*/
	public static ViewerDialog createLogSourceDialog(final Frame owner, final MstApp mstApp, final ITabelle logSource, final String name) {
		return new ViewerDialog(owner
				, mstApp
				, (ALogSource) logSource
				, name
				, "\"" + name + "\" wird angezeigt");
	}
//=============================================================================
	final LoggingJTabbedPane loggingJTabbedPane;
//=============================================================================
	/**Allgemeiner Dialog mit Tabbed Pane damit der Benutzer auswaehlen kann*/
	private ViewerDialog(final Dialog owner, final IMstAppKernel mstAppK, final boolean modal){
		super(owner, Main.calcAnnotatedTitle("Protokoll und Log Eintrge"), modal);
		this.loggingJTabbedPane = new LoggingJTabbedPane(mstAppK);
		initialize();
	}
	/**Allgemeiner Dialog mit Tabbed Pane damit der Benutzer auswaehlen kann*/
	private ViewerDialog(final Frame owner, final IMstAppKernel mstAppK, final boolean modal){
		super(owner, Main.calcAnnotatedTitle("Protokoll und Log Eintrge"), modal);
		this.loggingJTabbedPane = new LoggingJTabbedPane(mstAppK);
		initialize();
	}
	private ViewerDialog(final Frame owner, final IMstAppKernel mstAppK) {
		this(owner, mstAppK, false);
	}
	/**Spezifischer Dialog mit nur der angegebenen logSource*/
	private <L, M extends AMsgModel<L>> ViewerDialog(final Frame owner
												   , final MstApp mstApp
												   , final ALogSource<L, M> logSource
												   , final String title
												   , final String tip) {
		super(owner, Main.calcAnnotatedTitle(title), false);
		Screen.FULL_SCREEN.setBoundsOnComponent(this);
		this.loggingJTabbedPane = new LoggingJTabbedPane(mstApp);
		final LoggingTableDisplay<L, M> loggingTableDisplay = getLoggingJTabbedPane().externalOnNewLogSource(logSource, title, tip);
		this.setContentPane(loggingTableDisplay);
	}
	private void initialize() {
		Screen.FULL_SCREEN.setBoundsOnComponent(this);
		setJMenuBar(createJMenuBar(getLoggingJTabbedPane()));
		this.setContentPane(getLoggingJTabbedPane());
	}
//=============================================================================
	private JMenuBar createJMenuBar(final LoggingJTabbedPane loggingJTabbedPane) {
		final JMenuBar menuBar = new JMenuBar();
		menuBar.setBorderPainted(false);
		menuBar.add(loggingJTabbedPane.getJMenuLog());
		menuBar.add(loggingJTabbedPane.getJMenuCSV());
		return menuBar;
	}
	@Override public void dispose() {
		getLoggingJTabbedPane().dispose();
		super.dispose();
	}
	private LoggingJTabbedPane getLoggingJTabbedPane() {
		return this.loggingJTabbedPane;
	}
}
