/**
 *	Jul 22, 2009 - Jul 24, 2009	ws:	creation from scratch 
 *	Jul 28, 2009 - Jul 28, 2009	ws:	added: getAutoAppendServer() etc.
 *	Aug  3, 2009 - Aug 17, 2009	ws:	added: getAccessory()
 *	Sep 14, 2009 - Sep 21, 2009	ws:	added: I*Provider and its Support
 */

package de.desy.mst.libs.framework.mstapp.logging.gui;

import java.awt.Component;
import java.io.IOException;
import java.util.List;

import de.desy.mst.libs.framework.mstapp.logging.LogMsg;
import de.desy.mst.libs.framework.mstapp.logging.gui.LogMsgAuswertung.FieldInfo;
import de.desy.mst.libs.framework.mstapp.logging.gui.__LSMstLogInTineSrv_SpecGUIFactory.SPECCASE;
import de.desy.mst.libs.framework.mstapp.logging.map_tinelogsrv.MstLog4TineLog_Facade;
import de.desy.mst.libs.framework.mstapp.logging.map_tinelogsrv.MstLog4TineLog_Facade.ClogMapper;
import de.desy.mst.libs.framework.mstapp.logging.map_tinelogsrv.MstLog4TineLog_Facade.SystemInfoSummary;
import de.desy.tine.server.logger.Clog;

/**
 * 	@author ws
 *	@version 1.0.0
 */
class __LSMstLogInTineSrv 	extends 	ALogSource<LogMsg, MsgModel_MstLog>
							implements 	ISysInfosProvider{
	//=========================================================================
	static class LSInfo{
		static LSInfo createLSInfoUeb(final int seitTagen, final ILogSourceListener lsListener, final __LSMstLogInTineSrv systemLS){
			return new LSInfo(SPECCASE.Uebersicht, seitTagen, null, null, lsListener, systemLS);
		}
		static LSInfo createLSInfoApp(final int seitTagen, final String appName, final ILogSourceListener lsListener, final __LSMstLogInTineSrv systemLS){
			return new LSInfo(SPECCASE.Applikation, seitTagen, appName, null, lsListener, systemLS);
		}
		static LSInfo createLSInfoRun(final int seitTagen, final String appName, final String sRunId, final ILogSourceListener lsListener, final __LSMstLogInTineSrv systemLS){
			return new LSInfo(SPECCASE.Run, seitTagen, appName, sRunId, lsListener, systemLS);
		}
		//---------------------------------------------------------------------
		final SPECCASE speccase;
		final int      seitTagen;
		final String   appName;
		final String   sRunId;
		final ILogSourceListener lsListener;
		final __LSMstLogInTineSrv systemLS;
		//---------------------------------------------------------------------
		private LSInfo(final SPECCASE speccase
					 , final int seitTagen
					 , final String appName
					 , final String sRunId
					 , final ILogSourceListener lsListener
					 , final __LSMstLogInTineSrv systemLS){
			this.speccase  = speccase;
			this.seitTagen = seitTagen;
			this.appName = appName;
			this.sRunId  = sRunId;
			
			this.lsListener = lsListener;
			this.systemLS = systemLS;
		}
		//---------------------------------------------------------------------
		@Override public final String toString(){
			return (this.appName   == null ? "" : ("\"" + this.appName + "\" ")) 
				 + (this.sRunId    == null ? "" : ("("  + this.sRunId  + ") "))
				 + ("seit" + this.seitTagen + " Tagen");
		}
		/**pp*/ String getTag()		{return this.appName;}
		/**pp*/ String getLogger()	{return this.sRunId;}
		/**pp*/ LogSource_Clog createLogSource_Clog() {
			return new LogSource_Clog(this.seitTagen, this.getLogger(), this.getTag(), this.speccase.getContext());
		}
		/**pp*/ __LSMstLogInTineSrv getOrCreateSystemLS(final __LSMstLogInTineSrv lsMstLogInTineSrv) {
			if(this.systemLS != null)
				return this.systemLS;
			else if(lsMstLogInTineSrv.getLsInfo().speccase == SPECCASE.Uebersicht)
				return lsMstLogInTineSrv;
			else return createSystemLS(7, this.lsListener);
		} 
		//---------------------------------------------------------------------
		private final __LSMstLogInTineSrv createSystemLS(final int seitTagen, final ILogSourceListener lsListener){
			final LSInfo lsInfo = LSInfo.createLSInfoUeb(seitTagen, lsListener, null);
			return new __LSMstLogInTineSrv(lsInfo);
		} 
	}//END class: LSInfo
	//=========================================================================
	private static final String SYSTEM_BEZEICHNUNG = "System MstApp Logs im TineServer";
	private static ClogMapper createSystemMapper() {
		return MstLog4TineLog_Facade.getInstance().createClogMapper(null);
	}
	private static ClogMapper createMapper(final __IRList<Clog> messages) {
		for (final Clog clog : messages) 
			if(MstLog4TineLog_Facade.SYSTEM_KONTEXT.equals(clog.getContext()))
				return MstLog4TineLog_Facade.getInstance().createClogMapper(clog);
		return createSystemMapper();	
	}
//-----------------------------------------------------------------------------
	/**pp*/ static final __LSMstLogInTineSrv createSystemLS(final int seitTagen
														 , final ILogSourceListener lsListener){
		final LSInfo lsInfo = LSInfo.createLSInfoUeb(seitTagen, lsListener, null);
		return new __LSMstLogInTineSrv(lsInfo);
	}
	/**pp*/ static final __LSMstLogInTineSrv createApplicationLS(final int seitTagen
															  , final String appName
															  , final ILogSourceListener lsListener
															  , final __LSMstLogInTineSrv systemLS){
		final LSInfo lsInfo = LSInfo.createLSInfoApp(seitTagen, appName, lsListener, systemLS);
		return new __LSMstLogInTineSrv(lsInfo);
	}
	/**pp*/ static final __LSMstLogInTineSrv createRunLS(final int seitTagen
													  , final String appName
													  , final String sRunId
													  , final ILogSourceListener lsListener
													  , final __LSMstLogInTineSrv systemLS){
		final LSInfo lsInfo = LSInfo.createLSInfoRun(seitTagen, appName, sRunId, lsListener, systemLS);
		return new __LSMstLogInTineSrv(lsInfo);
	}
//=============================================================================
	
	private final LSInfo lsInfo;
	
	private final LogSource_Clog lsTine;
	private final ClogMapper mapper;
	private final String bezeichnung;
//-----------------------------------------------------------------------------
	private __LSMstLogInTineSrv(final LSInfo lsInfo){
		super(new MsgModel_MstLog(), null);
		
		this.lsInfo = lsInfo;
		
		this.lsTine = lsInfo.createLogSource_Clog();
		this.mapper = createMapper(this.lsTine.getMessages());
		this.bezeichnung =   __LSMstLogInTineSrv.SYSTEM_BEZEICHNUNG;
	}
//-----------------------------------------------------------------------------
	@Override public Component getAccessory  () {
		return new __LSMstLogInTineSrv_SpecGUIFactory(this).get();
	}
	@Override public String    getBezeichnung() {return this.bezeichnung;}
	@Override public __IRList<LogMsg> getMessages() {
		return new __ListMapper(getLSTine().getMessages(), getMapper());
	}
	@Override public boolean hasMassiveDecodingProblems() {
		return getLSTine().hasMassiveDecodingProblems();
	}
	@Override public void reloadAllData() throws IOException {
		getLSTine().reloadAllData();
	}
	@Override public String toString() {return getBezeichnung();}
//-----------------------------------------------------------------------------
	@Override public final String[] getAppNames(){
		final FieldInfo<String, LogMsg> fieldInfo = getFieldInfo(getApplicationField());
		return fieldInfo.getElementsAsSortedArray(new String[0]);
	}
	@Override public final SystemInfoSummary[] getSISs(final String appName){
		final List<Clog> msgs = this.getLSTine().getMessages().getBaseList();
		return MstLog4TineLog_Facade.getInstance()
									.getSystemInfoSummaryArray(msgs, appName);
	}
	
	/**pp*/ final LSInfo getLsInfo() {return this.lsInfo;}
	/**pp*/ final LogSource_Clog	getLSTine() {return this.lsTine;}
	/**pp*/ final ClogMapper		getMapper() {return this.mapper;}
//-----------------------------------------------------------------------------
	private AField<String, LogMsg> getApplicationField() {
		return MsgModel_MstLog.getInstance().getApplicationField();
	}
	private FieldInfo<String, LogMsg> getFieldInfo(final AField<String, LogMsg> aField) {
		assureHasAuswertung();
		return getAuswertung().getFieldInfo(aField);
	}
	private void assureHasAuswertung() {
		if(!hasAuswertung())
			updateAuswertung();
	}
}
							
//=============================================================================
							
//Following interfaces separately defined for Testing aid
/**pp*/ interface IAppNamesProvider {String[] getAppNames();}
/**pp*/ interface ISysInfosProvider extends IAppNamesProvider{
	SystemInfoSummary[] getSISs(final String appName);
}
