/**
 * May 20, 2009 - May 28, 2009	ws:	Creation from scratch
 */
package de.desy.mst.libs.framework.mstapp.logging.map_tinelogsrv;

import java.util.Date;

import de.desy.mst.libs.framework.mstapp.logging.LogMsg;
import de.desy.tine.server.logger.ClsLog.ClogPriority;
import de.desy.tine.server.logger.ClsLog.ClogStatus;

/**
 * Creates the HeartBeat LogInfo's
 * @author ws
 * @version 1.0.0
 */
class __SystemInfoFactory{
	private final String tContext;
	/**prototype use and storage of startdate,pcname, runid*/
	private final LogMsg firstLogMsg;
	private final String callerOrLogger;
//-----------------------------------------------------------------------------
	/**firstLogMsg: Referenz fuer StartZeit, PCName, Applikation, RunID*/
	__SystemInfoFactory(final String tContext, final LogMsg firstLogMsg) {
		this.tContext = tContext;

		this.firstLogMsg 	= firstLogMsg;
		this.callerOrLogger = __MapRunId.get().map(firstLogMsg.runId);
	}
//-----------------------------------------------------------------------------
	public final Date 	getDateStart() {return getFirstLogMsg().date;}
	public final String getPcName   () {return getFirstLogMsg().pcName ;}

	public final String getTag  	() {return getFirstLogMsg().applikation ;}
	public final String getCallerOrLogger() {return this.callerOrLogger;}

	public final __ClsLogInfoSystem create(final long msNow, final long nHB){
		return new __ClsLogInfoSystem(createMapTextSystem(msNow, nHB).tText
									, getTag()
									, getCallerOrLogger()
									, ClogPriority.CLOG_PRIORITY_USEFUL	//1
									, ClogStatus  .CLOG_STATUS_INFO		//1
									 );
	}
//-----------------------------------------------------------------------------
	private __MapTextSystem createMapTextSystem(final long msNow, final long nHB) {
		return __MapTextSystem.create(msNow, nHB, getDateStart(), getPcName(), getTContext());
	}
	private final LogMsg getFirstLogMsg()	{return this.firstLogMsg;}
	private final String getTContext() 		{return this.tContext;}
}
