/**
 * Feb 18, 2009 - Feb 18, 2009	ws:	Creation from scratch
 */
package de.desy.mst.libs.framework.mstapp.mode;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.print.PrinterException;
import java.text.MessageFormat;

import javax.print.attribute.HashPrintRequestAttributeSet;
import javax.print.attribute.standard.JobName;
import javax.print.attribute.standard.OrientationRequested;
import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;

import de.desy.mst.libs.framework.mstapp.logging.LogMsg;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.preferences.IPrefContainer;
import de.desy.mst.libs.framework.mstapp.preferences.helper.APrefClientPanelEinfach;
import de.desy.mst.libs.framework.mstapp.security.MstSecurity;
import de.desy.mst.libs.framework.mstapp.tabellendaten.entry.OPModeACLEntry;
import de.desy.mst.libs.framework.mstapp.util.gui.GUIFactory;


/**
 * Fuer die schnelle Uebersicht zum einfachen Debuggen von Konfigurationsproblemen.
 * @author ws
 * @version 1.0.0
 */
public class PrefOpModeKonfigurationPanel  extends APrefClientPanelEinfach {
	private static final long serialVersionUID = 1L;
//=============================================================================
	final JTable table;
//=============================================================================
	public PrefOpModeKonfigurationPanel(final IPrefContainer prefContainer) {
		super(prefContainer);
		this.setLayout(new BorderLayout());

		this.table = createTable(MstSecurity.get());
		this.add(new JScrollPane(this.table), BorderLayout.CENTER);
		
		final Box southBox = Box.createHorizontalBox();
		southBox.add(Box.createHorizontalGlue());
		southBox.add(createJBPrint());
		this.add(southBox, BorderLayout.SOUTH);
	}
//=============================================================================
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.preferences.IPrefClient#onReset()
	 */
	@Override public void onReset() {}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.preferences.IPrefClient#onSet()
	 */
	@Override public void onSet() throws Exception {}
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.preferences.helper.APrefClientPanel#onDispose()
	 */ 
	@Override public void onDispose() {}
//=============================================================================
	private JTable getTable() {return this.table;}
	private JButton createJBPrint() {
		final String toolTip = "Die ganze Tabelle ausdrucken (sichtbarer und so vorhanden unsichtbarer Teil).";
		final ActionListener listener = new ActionListener(){
			@Override public void actionPerformed(final ActionEvent evt){
				final String documentName = "Operations Modus Konfiguration";
				final MessageFormat headerFormat = null;
				final MessageFormat footerFormat = new MessageFormat(calcFooterString());
				final HashPrintRequestAttributeSet attr = new HashPrintRequestAttributeSet();
				attr.add(OrientationRequested.LANDSCAPE);
				attr.add(new JobName("Tabelle: " + documentName, null));
				try {
					final boolean notCanceled = getTable().print(JTable.PrintMode.FIT_WIDTH, headerFormat, footerFormat, true, attr, true);
					Logger.SWFW.info("PrefOpModeKonfigurationPanel Ausdruck von: " + documentName + (notCanceled ? "" : " CANCELED"));
				} catch (final PrinterException ex) {
					final String msg = "PrefOpModeKonfigurationPanel: Kann " + documentName + " nicht drucken: " + ex;
					Logger.SWFW.error(msg);
					JOptionPane.showMessageDialog(PrefOpModeKonfigurationPanel.this, msg);
				}
			}

			private String calcFooterString() {
				final MstSecurity sec = MstSecurity.get();
				return "Quelle: \"" + sec.getAppName() + " (" + LogMsg.THIS_RUN_RUNID + ") auf dem PC "
					 + sec.getHostName() + "\"\t - {0} -";
			}
		};
		return GUIFactory.createImageButton("print24.gif", toolTip, listener, this.getClass());
	}
	private JTable createTable(final MstSecurity sec) {
		final OPModeACLEntry acl = sec.getOPModeACLEntry();
		final Object[] columnNames = {"Was", 			"Wert", ""};
		final Object[][] rowData   ={{"KONFIGURATION:",	"",		""}

								   , {"Default", 		acl.defaultOpMode.name,		 ""}
								   , {"Maximal", 		acl.maxOpMode.name,			 ""}
								   , {"Maximal Test",	acl.maxTestServerOpMode.name,""}

								   , {"INPUT:", 		"", 		""}
								   , {"Benutzer", 		acl.pcUser, sec.getUser()}
								   , {"PC Name", 		acl.pcName, sec.getHostName()}
								   , {"App Name", 		acl.appName,sec.getAppName()}

								   , {"TECHNISCHES:",	"",			""}
								   , {"ACL Name", 		acl.aclName,""}
								   , {"OAZ Nummer", 	acl.oazNr,	""}
									};

		final JTable table = new JTable(new DefaultTableModel(rowData, columnNames)){
			private static final long serialVersionUID = 1L;
			private static final String TOOLTIP_SUFFIX_1 = " (Input, aber nicht"
						 + " notwendig verwendet - im Gegensatz zu Spalte Wert)";
			//Implement table cell tool tips.
			@Override public String getToolTipText(final MouseEvent e) {
			    final java.awt.Point p = e.getPoint();
			    final int row = rowAtPoint(p);		if(row < 0)		return null;
			    final int col = columnAtPoint(p);	if(col < 0)		return null;
			    final String contents = "" + getModel().getValueAt(row, col);
			    if(!contents.isEmpty() && letzteSpalte(col))
			    	return contents + TOOLTIP_SUFFIX_1;
				return contents;
			}
			private boolean letzteSpalte(final int col) {
				return convertColumnIndexToModel(col) == (columnNames.length - 1);
			}

		};

		final DefaultTableCellRenderer renderer = new DefaultTableCellRenderer(){
			private static final long serialVersionUID = 1L;
			@Override
			public Component getTableCellRendererComponent(final JTable table, final Object value, final boolean isSelected, final boolean hasFocus, final int row, final int column) {
				final Component cmp = super.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
				if(	!value.toString().isEmpty()
				 && table.getValueAt(row, 1).toString().isEmpty()
				 && table.getValueAt(row, 2).toString().isEmpty()
				  ){
					final Font font = cmp.getFont();
					if(!font.isBold())
						cmp.setFont(GUIFactory.createFont(font, Font.BOLD));
				}
				return cmp;
			}
		};
		table.setDefaultRenderer(Object.class, renderer);
		table.setDefaultRenderer(String.class, renderer);

		return table;
	}
}
