/**
 * ws:	May 21, 2007 - May 21, 2007 creation from PrefEinstellungen(Panel) (Wst)
 */
package de.desy.mst.libs.framework.mstapp.preferences.helper;

import java.awt.BorderLayout; 

import javax.swing.JLabel;

import de.desy.mst.libs.framework.mstapp.preferences.IPrefContainer;
import de.desy.mst.libs.framework.mstapp.preferences.IPreferences;
import de.desy.mst.libs.framework.mstapp.util.gui.GUIFactory;

/**
 * Container Klasse fuer Preferences.
 * <br> Ein Kommentar wird angezeigt.
 * <br> Diese Klasse ist rein passiv. Insbesondere wird nichts geaendert oder
 * gespeichert. Auch werden die Tochter Preferences hier nicht verwaltet 
 * (sondern im PrefManager).
 * 
 * @author ws (nach wst)
 * @version 1.0.0
 */
public class PrefGenericParent extends APreferences {
	private final String kommentar;
//=============================================================================	
	/**
	 * @param title		Titel dieser Container Preferenz
	 * @param kommentar	Kommentar wird passiv angezeigt
	 * @param parent	optionaler Container dieses Containers (Grossvater der Kinder)
	 */
	public PrefGenericParent(final String title, final String kommentar, final IPreferences parent) {
		super(title, parent);
		this.kommentar = kommentar;
	}
	/**
	 * Ohne parent dieses parents
	 * @param title		Titel dieser Preferenz
	 * @param kommentar	Kommentar wird passiv angezeigt
	 */
	public PrefGenericParent(final String title, final String kommentar) {
		this(title, kommentar, null);
	}
	//=============================================================================	
	/* (non-Javadoc)
	 * @see de.desy.mst.libs.framework.mstapp.preferences.helper.APreferences#createPrefClientPanel(de.desy.mst.libs.framework.mstapp.preferences.IPrefContainer)
	 */
	@Override public APrefClientPanel createPrefClientPanel(final IPrefContainer prefContainer) {
		return new PrefGenericParentPanel(prefContainer, this.kommentar);
	}
//=============================================================================
	private class PrefGenericParentPanel extends APrefClientPanelEinfach{
		private static final long serialVersionUID = 1L;
		//---------------------------------------------------------------------
		/**kommentar wird angezeigt sonst ganz passiv*/
		public PrefGenericParentPanel(final IPrefContainer prefContainer, final String kommentar) {
			super(prefContainer);
			this.setLayout(new BorderLayout());
			final JLabel label = new JLabel("<html> <center>" + kommentar);
			label.setFont(GUIFactory.createButtonFont());
			this.add(label, BorderLayout.CENTER);
//			prefContainer.setChanged(false);	//fr immer und ewig
		}
		//---------------------------------------------------------------------
		/* (non-Javadoc) 
		 * @see de.desy.mst.libs.framework.mstapp.preferences.helper.APrefClientPanel#onDispose()
		 */
		@Override public void onDispose()		{/*nothing to do*/}
		/* (non-Javadoc)
		 * @see de.desy.mst.libs.framework.mstapp.preferences.IPrefClient#onReset()
		 */
		@Override public void onReset()					{/*nothing to do*/}
		/* (non-Javadoc)
		 * @see de.desy.mst.libs.framework.mstapp.preferences.IPrefClient#onSet()
		 */
		@Override public void onSet() throws Exception	{/*nothing to doe*/}
	}
}
