/**
 *  Created on 	Aug 24, 2005 - Aug 24, 2005
 *  			Jul 20, 2006 - ...			ws: STATUS_ABFRAGE_PREFIX = "StatusXML1+" -> "StatusXML2+"
 */
package de.desy.mst.libs.framework.mstapp.tabellendaten.entry;

/**
 * Hilfsklasse fuer echtes AEntry Status.
 * Aufgaben sind hart kodiert.
 * Bei neuen Aufgaben muss die Source angepasst werden 
 * (einfach und so praktischer, da als EntwicklungsZeitKonzept gebraucht).
 * Bitte danach AufgabenTest erfolgreich laufen lassen.
 * 
 * @author ws
 * @version 1.0.0
 */
public enum Aufgabe {
		Allgemeine				//	0	Alter Bereich: 0 -99
	,	Korrekturspulen			//	1	Alter Bereich: 100-199
	,	Hauptmagnete			//	2	Alter Bereich: 200-299
	,	OFFEN_3					//	3	Alter Bereich: 300-399
	,	OFFEN_4					//	4	Alter Bereich: 400-499
	,	HF						//	5	Alter Bereich: 500-599
	,	Monitore				//	6	Alter Bereich: 600-699
	,	OFFEN_7					//	7	Alter Bereich: 700-799
	,	OFFEN_8					//	8	Alter Bereich: 800-899
	,	Klima					//	9	Alter Bereich: 900-999
	,	PersonenInterlock		//	10	Alter Bereich: 1000-1099
	,	Scraper					//	11	Alter Bereich: 1100-1199
	,	ChopperStatus			//	12	Alter Bereich: 1240-1249
	,	Synchrotronmagnete		//	13	Alter Bereich: 1300-1399
	,	Schrittmotorsteuerung	//	14	Alter Bereich: 1450-1489/1497
	,	Targetsteuerung			//	15	Alter Bereich: 1500-1599
	,   D2_Energien             //  16  Neuer Bereich: 1600-1699
	;	
//=============================================================================

	private final static String STATUS_ABFRAGE_PREFIX = "StatusXML2+";
		
//=============================================================================

	/**@throws ArrayIndexOutOfBoundsException, bei entsprechender nr*/
	public final static Aufgabe getByAufgNr(int aufgNr){
		return values()[aufgNr]; 
	}
	
	public static String createStatusAbfrage(int aufgNr) {
		return STATUS_ABFRAGE_PREFIX + aufgNr;
	}
	
}
