/**
 * 	Apr 13, 2015 - Jul 16, 2015	ws:	created from scratch
 */
package de.desy.mst.libs.framework.mstapp.tabellendaten.entry;

import de.desy.mst.libs.framework.mstapp.Main;
import de.desy.mst.libs.framework.mstapp.ParamDecoder;
import de.desy.mst.libs.framework.mstapp.logging.Logger;
import de.desy.mst.libs.framework.mstapp.mode.input.OPModeACLEntryFactory_Tine;

/**
 * Composite that takes care of what all MstApp should use as a standard.
 * <br> You can change the basic standard by replacing MAIN_IMPL
 * @author ws
 */
public class OPModeACLEntryFactory_Default extends OPModeACLEntryFactory {
	public  static final OPModeACLEntryFactory INSTANCE  = new OPModeACLEntryFactory_Default();
//	private static final OPModeACLEntryFactory MAIN_IMPL =    _OPModeACLEntryFactory_SQLSrv._INSTANCE;
	private static final OPModeACLEntryFactory getImplementation() {
		return Main.mstwebUsageSettings.isUse_mstweb4ACL() 
					? _OPModeACLEntryFactory_SQLSrv._INSTANCE
					: new _OPModeACLEntryFactory_cached(OPModeACLEntryFactory_Tine.INSTANCE);
	}
	//=============================================================================================
	@Override public OPModeACLEntry getOPModeACLEntry(final String pcUser, final String pcName, final String appName) {
		if(useLocalSecurity()){
			Logger.SWFW.warn("IM JUNIT DEBUG MODUS. Use getDefaultOPModeACLEntry(...)");
			return getNullOPModeACLEntry(pcUser, pcName, appName);
		}
		final OPModeACLEntry entry = getImplementation().getOPModeACLEntry(pcUser, pcName, appName);
		return entry == null ? getNullOPModeACLEntry(pcUser, pcName, appName)
							 : entry;
	}
	@Override @Deprecated public boolean usesOldSQLWay() {return getImplementation().usesOldSQLWay();}
	//------------------------------------------------------------MAIN_IMPL--------------------------------
	/**only for junit tests*/
	@SuppressWarnings("deprecation") 
	private boolean useLocalSecurity() {
		return ParamDecoder._ImplementationSwitches.DEBUGSWITCHES.LOCALSECURITY.isOn();
	}
}
