/**
 *  Created on	May 31, 2006 - Jun 06, 2006
 */
package de.desy.mst.libs.framework.mstapp.tabellendaten.entry;

import java.util.Date;

/**
 * Meta Tabellen Information aus:<BR>
 * [Petra3].[TabellenToJavaVerz]
 * @author ws
 * @version 1.0.0
 */
public class TabellenEntry  extends AEntry2<Integer, String> {
	public final int		tbId;
	public final String		name;
	public final int		versionId;
	public final String		javaTabelle;
	public final String		javaEntry;
	public final String		dbTabelle;
	public final String		dbAbfrage;
	public final boolean	validTable;
	public final Date		lastDataChange;
	
//=============================================================================
	
	public TabellenEntry(final int tbId, final String name, final int versionId, final String javaTabelle, final String javaEntry, final String dbTabelle, final String dbAbfrage, final boolean validTable, final Date lastDataChange) {
		super();
		this.tbId 			= tbId;
		this.name 			= name;
		this.versionId 			= versionId;
		this.javaTabelle 	= javaTabelle;
		this.javaEntry		= javaEntry;
		this.dbTabelle 		= dbTabelle;
		this.dbAbfrage 		= dbAbfrage;
		this.validTable 	= validTable;
		this.lastDataChange = lastDataChange;
	}
	public TabellenEntry(final int tbId, final String name, final int versionId, final String javaTabelle
			           , final String javaEntry, final String dbTabelle
			           , final String dbAbfrage, final boolean validTable, final Date lastDataChange
	           	       , final Object ... unsupportedExtraParams) {
		this(tbId, name, versionId, javaTabelle, javaEntry, dbTabelle, dbAbfrage, validTable, lastDataChange);
		handleUnsupportedExtraParams(this, unsupportedExtraParams);
	}
	
//=============================================================================
	
/* (non-Javadoc) @see de.desy.mst.mstapp.tabellendaten.entry.AEntry2#getKey2()*/
@Override public String getKey2() {return this.getName();}
/* (non-Javadoc) @see de.desy.mst.mstapp.tabellendaten.entry.AEntry#getKey()  */
@Override public Integer getKey() {return Integer.valueOf(this.getTbId());}
/* (non-Javadoc) @see de.desy.mst.mstapp.tabellendaten.entry.AEntry#inSeinenWertenGleich(de.desy.mst.mstapp.tabellendaten.entry.AEntry)*/
@Override public boolean inSeinenWertenGleich(final AEntry<Integer> otherEntry) {
		if(!(otherEntry instanceof TabellenEntry)) {return false;}
		final TabellenEntry other = (TabellenEntry) otherEntry;
		return  this.tbId		== other.	tbId
			&& 	this.name.equals			(other.name)
			&& 	this.versionId	== other.versionId
			&& 	this.javaTabelle.equals	(other.javaTabelle)
			&& 	this.javaEntry.equals	(other.javaEntry)
			&& 	this.dbTabelle.equals	(other.dbTabelle)
			&& 	this.dbAbfrage.equals	(other.dbAbfrage)
			&& 	this.validTable	== other.	validTable
			&& 	this.lastDataChange	== other.	lastDataChange
			;
}
	
//=============================================================================

	public boolean inSeinenWertenGleichAusserLastDataChange(final AEntry<Integer> otherEntry) {
		if(!(otherEntry instanceof TabellenEntry)) {return false;}
		final TabellenEntry other = (TabellenEntry) otherEntry;
		return  this.tbId		== other.	tbId
			&& 	this.name.equals			(other.name)
			&& 	this.versionId	== other.versionId
			&& 	this.javaTabelle.equals	(other.javaTabelle)
			&& 	this.javaEntry.equals	(other.javaEntry)
			&& 	this.dbTabelle.equals	(other.dbTabelle)
			&& 	this.dbAbfrage.equals	(other.dbAbfrage)
			&& 	this.validTable	== other.	validTable
			;
}	
public final String getDbAbfrage() 		{return this.dbAbfrage;}
public final String getDbTabelle() 		{return this.dbTabelle;}
public final String getJavaEntry() 		{return this.javaEntry;}
public final String getJavaTabelle() 	{return this.javaTabelle;}
public final Date 	getLastDataChange()	{return this.lastDataChange;}
public final String getName() 			{return this.name;}
public final int 	getTbId() 			{return this.tbId;}
public final boolean isValidTable() 	{return this.validTable;}
public final int 	getVersionId() 		{return this.versionId;}
} 