/**
 *  Created on Dec 15, 2005 - Dec 15, 2005
 *   Aug  7, 2007 - Aug  7, 2007	ws: fixed KURZ TimeFormat 1-24 nach 0-23
 */
package de.desy.mst.libs.framework.mstapp.util;

import java.text.FieldPosition;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * Unsere Standard Formate in Form von statisch erzeugten Objekten.
 * @author ws
 * @version 1.0.0 
 */
public class MstDateFormat extends SimpleDateFormat /*implements IFormatAsString<Date>*/{
	/**KH Version in Frame dd.MM.yy kk:mm:ss*/
	public final static MstDateFormat KURZ = new MstDateFormat("dd.MM.yy HH:mm:ss");
	/**ISO Version (Logger) "yyyy-MM-dd HH:mm:ss[.SSS] Z"*/
	public final static MstDateFormat ISO = KURZ.new ExtraFormatFrSekundenBruchteile("yyyy-MM-dd HH:mm:ss Z", "yyyy-MM-dd HH:mm:ss.SSS Z");
	
//=============================================================================	
	
	public MstDateFormat(final String pattern) {
		super(pattern);
	}
	/**kann leider nicht direkt 'implements IFormatAsString<Date>' sagen, da format(Date) im DateFormat final ist*/
	public IFormatAsString<Date> getIFormatAsString(){ 
		if(this.iFormatAsStringWrapper == null){
			this.iFormatAsStringWrapper = new IFormatAsString<Date>(){
				@Override public String format(final Date date) {return MstDateFormat.this.format(date);}
			};
		}
		return this.iFormatAsStringWrapper;
	}
//=============================================================================	

	private static final long serialVersionUID = 1L;
	class ExtraFormatFrSekundenBruchteile extends MstDateFormat{
		private static final long serialVersionUID = 1L;
		private final MstDateFormat spezMDF;
		public ExtraFormatFrSekundenBruchteile(final String pattern, final String patternBruchteile) {
			super(pattern);
			this.spezMDF = new MstDateFormat(patternBruchteile);
		}
		@Override
		public StringBuffer format(final Date date, final StringBuffer toAppendTo, final FieldPosition pos) {
			if(hatSekundenBruchteile(date)){
				return this.spezMDF.format(date, toAppendTo, pos);
			}else{
				return super.format(date, toAppendTo, pos);
			}
		}
		public boolean hatSekundenBruchteile(final Date date) {
			return((date.getTime() % 1000) != 0);	// "%" ist der modulus Operator
		}
	}	//INNER CLASS: ExtraFormatFrSekundenBruchteile
	private IFormatAsString<Date> iFormatAsStringWrapper;
}
 