package de.desy.mst.libs.framework.mstapp.util.machinestates;

/**
 * Defines the machine states
 * 
 * @author R.Bacher
 *
 */

public enum EMachineStatesL2 {
	
	LINAC_BETRIEB_GUN (103, "Gun-Betrieb", "Gun-Operations"),
	LINAC_BETRIEB_PIA (105, "PIA-Betrieb", "PIA-Operations"),
	LINAC_BETRIEB_TEST (106, "Testbetrieb", "Test-Operations"),
	LINAC_BETRIEB_PETRA (110, "Betrieb->PETRA", "User Operations->PETRA"),
	LINAC_BETRIEB_DORIS (111, "Betrieb->DORIS", "User Operations->DORIS"),
	LINAC_BETRIEB_TESTSTRAHL (112, "Betrieb->Teststrahl", "User Operations->Testbeam"),
	LINAC_BETRIEB_KONTROLLRAUM (113, "Betrieb->Kontrollraum", "User Operations->Control Room"),
	LINAC_VORBEREITEN_BETRIEB (200, "Vorbereiten", "Preparing"),	
	LINAC_VORBEREITEN_BETRIEB_GUN (204, "Vorbereiten(Gun-Betrieb)", "Preparing(Gun-Operations)"),
	LINAC_VORBEREITEN_BETRIEB_PIA (205, "Vorbereiten(PIA-Betrieb)", "Preparing(PIA-Operations)"),
	LINAC_VORBEREITEN_BETRIEB_TEST (206, "Vorbereiten(Testbetrieb)", "Preparing(Test-Operations)"),
	LINAC_VORBEREITEN_BETRIEB_PETRA (210, "Vorbereiten(Betrieb->PETRA)", "Preparing(User Operations->PETRA)"),
	LINAC_VORBEREITEN_BETRIEB_DORIS (211, "Vorbereiten(Betrieb->DORIS)", "Preparing(User Operations->DORIS)"),
	LINAC_VORBEREITEN_BETRIEB_TESTSTRAHL (212, "Vorbereiten(Betrieb->Teststrahl)", "Preparing(User Operations->Testbeam)"),
	LINAC_VORBEREITEN_BETRIEB_KONTROLLRAUM (213, "Vorbereiten(Betrieb->Kontrollraum)", "Preparing(User Operations->Control Room)"),
	LINAC_BEREIT (300, "Bereit", "Idle"),
	LINAC_WARTUNG (401, "Wartung", "Maintenance"),
	LINAC_FEHLER (402, "Fehler", "Problems"),
	LINAC_KEINE_STRAHLFREIGABE (403, "Keine Strahlfreigabe", "Beam Permission Unavailable"),
	LINAC_KEIN_STRAHL (404, "Kein Strahl", "No Beam"),
	LINAC_STUDIEN (500, "Studien", "Studies"),
	LINAC_UNBESTIMMT (600, "Unbestimmt", "Undefined");
	
	private final int stateAsNumber;
	private final String stateAsText;
	private final String stateAsTextEngl;
	
	EMachineStatesL2(final int stateAsNumber, final String stateAsText, final String stateAsTextEngl) {
        this.stateAsNumber = stateAsNumber;
        this.stateAsText = stateAsText;
        this.stateAsTextEngl = stateAsTextEngl;
    }
	
	public int stateAsNumber() {
		
		return this.stateAsNumber;
	}
	
	public String stateAsText() {
		
		return this.stateAsText;
	}
	public String stateAsTextEngl() {
		
		return this.stateAsTextEngl;
	}
	
	public static void main(final String[] args) {
		for (final EMachineStatesL2 state : EMachineStatesL2.values()) {
           System.out.println(state + ": " + state.stateAsNumber + ", " + state.stateAsText+ ", " + state.stateAsTextEngl);
		}
    }
} 
