/**
 *	Feb  8, 2010 - Mar 12, 2010	ws:	creation from scratch 
 * 	Jul  8, 2010 - Jul  8, 2010	ws:	pulled up: _ExporterTo_Queue
 */
package de.desy.mst.libs.info.appadmin;

import de.desy.mst.libs.info.appadmin.AppAdmin.ILifeCycleStatistic;

/**
 * @author ws
 * @version 1.0.0
 */
class _LifeCycleStatistic extends    _ExporterTo_Queue 
                          implements ILifeCycleStatistic {
	private final _LifeCycleStatisticTypeEntry lcstEntry;
	//-----------------------------------------------------------------------------
	/**
	 * @param q	nonnull queue for message offering
	 * @param e	for the type of object for lifecycles, e.q. "Panel", "MainPanel"
	 * @throws NullPointerException	if any parameter is null
	 */
	_LifeCycleStatistic(final _Queue q, final _LifeCycleStatisticTypeEntry e) throws NullPointerException{
		super(q);
		__Utils.checkForNull(e, "_LifeCycleStatisticTypeEntry");
		this.lcstEntry = e;
	}
//-----------------------------------------------------------------------------
	public void fireStarted(final String name, final Long lt){fire(createMsg(_EventEntry.STARTED, name, lt));}
	public void fireStopped(final String name, final Long lt){fire(createMsg(_EventEntry.STOPPED, name, lt));}
//-----------------------------------------------------------------------------
	private final _Msg createMsg(final _EventEntry evtEntry
							   , final String      name
							   , final Long        longTag) {
		return new _Msg(_SystemEntry.LIFECYCLE_STATISTIC 
					  , getStatisticTypeEntry()		//Application, MainPanel, Panel, ...
					  , evtEntry					//started, stopped
					  , new _NameEntry(name)		//IonGetterPanel ...
					  , new _LongTagEntry(longTag)	//Nr 1 ...
					   );
	}
	private _StringEntry getStatisticTypeEntry() {return this.lcstEntry;}
}

