/**
 *	Feb 11, 2010 - Mar  9, 2010	ws:	creation from scratch 
 *	Apr 12, 2010 - Apr 12, 2010	ws:	createConnection() throws a JMSException now
 *	Aug  5, 2010 - Aug 12, 2010	ws:	added AppAdmin.Statistic.getApplicationStatistic().fireStarted(...)
 *									changed: fillJMSMsgWithMst to pp and static
 */

package de.desy.mst.libs.info.appadmin;

import com.sun.messaging.TopicConnectionFactory;
import java.util.logging.Level;
import javax.jms.JMSException;
import javax.jms.Message; 
import javax.jms.Session;
import javax.jms.TopicConnection;
import javax.jms.TopicPublisher;
import javax.jms.TopicSession;

/**
 * @author ws
 * @version 1.0.0
 */
class _MsgSenderJMS implements _IMsgSender {
	static Message fillJMSMsgWithMsg(final Message jmsMessage, final _Msg msg) throws JMSException {
		for (final _Entry<?> entry : msg)
			jmsMessage.setStringProperty(entry.getKey(), "" + entry.getValue());
		return jmsMessage;
	}
//=============================================================================	
	private final TopicConnection 	connection; 
	private final TopicSession 		session;
	private final TopicPublisher 	publisher;
//-----------------------------------------------------------------------------	
	public _MsgSenderJMS(final String topicName) throws JMSException{
		this.connection = createConnection();
		this.session 	= this.connection.createTopicSession(false, Session.AUTO_ACKNOWLEDGE);
		this.publisher	= this.session   .createPublisher(this.session.createTopic(topicName));
		_Logging.log(Level.FINE, "Created JMS Publisher on topic '" + topicName + "'.", null);
	}
//-----------------------------------------------------------------------------	
	/* (non-Javadoc)
	 * @see appadmin._IMsgSender#send(appadmin._Msg)
	 */
	@Override public void send(final _Msg msg) {
		try {
			this.publisher.publish(fillJMSMsgWithMsg(this.session.createMessage(), msg));
		} catch (final JMSException ex) {
			_Logging.log(Level.WARNING, "Can not sent Msg.", ex);
		}
	}
	public void stop() {
		try{this.connection.stop();}
		catch (final Throwable th){/*Ignore all problems at this stage.*/}
	}
	Message createAMessageForTesting()throws JMSException {return this.session.createMessage();}
//-----------------------------------------------------------------------------	
	private TopicConnection createConnection() throws JMSException {
		final TopicConnectionFactory tcf = new TopicConnectionFactory();

		final AppAdminContext instance = AppAdminContext.getInstance();
		tcf.setProperty(instance.getJMSMQ_URL_KEY(), instance.getJMSMQ_URL());
		final TopicConnection topicConnection = tcf.createTopicConnection();
		topicConnection.start();
		Runtime.getRuntime().addShutdownHook(new Thread(new Runnable(){
			public void run() {
				AppAdmin.Statistic.fireApplicationStopped(); 
				stop();
			}
		}));
		return topicConnection;
	}
}
