package de.desy.mst.libs.pintlk.badgerviewer.config;

/**
 * @author labudda
 * Proxy / Interface uber das die Konfiguration bestimmt, 
 * ob die aktuelle Umgebung zur Konfiguration gehoert.
 * Dazu wird von der Konfiguration die Methode isAcceptable abgefragt.
 * isExcluded und isIncluded koennen angepasst werden. 
 * Vgl. Windows ACL Deny / Grant permission
 * Per default gehoert die Konfiguration zur Umgebung.
 * 
 */
class ConfigDetector {
	final boolean isAcceptable() {
		if (this.isExcluded()) {
			return false;
		} else {
			return this.isIncluded();
		}
	}
	boolean isExcluded(){return false;}
	boolean isIncluded(){return true;}
}