/**
 * 
 * Last changed: $Date$
 * By: $Author$
 * URL: $HeadURL$
 * $Revision$ 
 *
 */
package de.desy.mst.libs.pintlk.badgerviewer.network;

import de.desy.mst.libs.ser.tclientlib.TineLinkException;

/**
 * @author labudda
 *
 */
public interface IDevice {

	/**
	 * @return Name des vom video angezeigten Beschleunigers
	 * @throws TineLinkException
	 */
	public abstract String getNameOfAccelerator() throws TineLinkException;

	/**
	 * @return Liste der Dachseintraege fuer diesen Beschleuniger
	 * Die Liste darf leer, jedoch niemals null sein
	 * @throws TineLinkException
	 */
	public abstract java.util.AbstractList<DachsEntry> getEntries()
			throws TineLinkException;

	/**
	 * Gibt alle ressources des Geraetes frei.
	 * Es koennen keine weiteren Daten ausgelesen werden.
	 */
	public void terminate();
	/**
	 * @return the name of connected device
	 */
	public String getDeviceName();
	/**
	 * @return message defined by dachs administrators
	 * @throws TineLinkException
	 */
	public String getMessage() throws TineLinkException;
}