package de.desy.mst.libs.pintlk.badgerviewer.network;



/**
 * Beschreibt, wie sich ein Client zu welchem Server verbindet.
 * Dieses Interface soll fuer IServerClient genutzt werden, damit ueber ein Objekt
 * fuer alle Devices die Verbindungsparameter einheitlich gesetzt werden.
 * Das einzelne Device wird hier nicht definiert.
 * @version 1.0
 * @updated 20-Feb-2007 14:35:30
 */
public interface ITineParameter extends java.io.Serializable {

	/**
	 * Mode how to access the device
	 *
	 */
	public int getMode();

	/** Wird das Geraet per poll abgefragt, ist hier die Pollrate definiert 
	 * @return - Pollrate
	 */
	public int getPollrate( );
	
	/** Definiert den Servernamen
	 * @return - Name des TINE device servers
	 */
	public String getServer( );

	/** Definiert den Kontext 
	 * @return - TINE device server context
	 */
	public String getContext();
	

}



