/*
 * Created on May 10, 2007
 *
 */
package de.desy.mst.libs.ser.tclientlib;

/**
 * An Interface for group listeners. Readers can be combined into groups with a
 * common update trigger. A group notifies its listeners when new data have
 * arrived. A listener must implement this interface.
 * 
 * @author jwlg
 * @see TineReaderGroup
 */
public interface IReaderGroupListener {
    /**
     * Called when new data have arrived.
     * 
     * @param group
     *            The calling group.
     */
    public void notifyUpdate(TineReaderGroup group);
}
