package de.desy.mst.libs.ser.tclientlib;

/**
 * An interface for reader listeners. Each reader can have a set of listeners.
 * The listeners must implement this interface. They are notified when the
 * reader and asynchronous data have arrived.
 * 
 * @author jwlg
 * @see ATineReader
 */
public interface IReaderListener {
    /**
     * Called when asynchronous data have arrived.
     * 
     * @param reader
     *            The calling reader.
     */
    public void notifyUpdate(ITineAccessor reader);
}
