/*
 * Created on Nov 18, 2008
 *
 */
package de.desy.mst.libs.ser.tclientlib.connection;

/**
 * Representation of a connection state. Contains possible states of a TINE/CDI
 * connection. Used by state machines.
 */
public enum ConnectionState {

    /** Connection is intentionally disabled. */
    DISABLED,
    /** Connection is broken or not established */
    DISCONNECTED,
    /** Connection has failed */
    FAILED,
    /** Connection is being established */
    CONNECTING,
    /** Connection is OK */
    READY;

    /**
     * Returns true if the state is DISABLED.
     */
    public boolean isDisabled() {
        return (this == DISABLED);
    }

    /**
     * Returns true if the state is not DISABLED.
     * 
     */
    public boolean isEnabled() {
        return (this != DISABLED);
    }

    /**
     * Returns true if the state is READY.
     */
    public boolean isReady() {
        return (this == READY);
    }

}
