package de.desy.mst.libs.ser.tclientlib.writers;
import de.desy.tine.dataUtils.TDataType;
import de.desy.mst.libs.ser.tclientlib.ATineWriter;
import de.desy.mst.libs.ser.tclientlib.TineLinkException;
import de.desy.mst.libs.ser.tclientlib.TLinkAddress;


/**
 * A void writer.
 *
 * The VoidWriter writes to a TINE server without data.
 *
 */
public class VoidWriter extends ATineWriter {
    
     /**
      * Constructor.
      * @param linkAddress The TINE address
      */
    public VoidWriter(TLinkAddress linkAddress) {
        super(linkAddress);
    }

     
     /**
      * Constructor.
      * @param fullDevicePath The full TINE path of
      * the property. It must be in the form 
      * <code>
      * /context/server/device/property
      * </code>.
      */
    public VoidWriter(String fullDevicePath) {
        super(fullDevicePath);
    }
    
    /**
     * Calls the void property on the server.
     * If the operation was not successful,
     * a TineLinkException is thrown.
     * @throws TineLinkException
     */
    public synchronized void setValue() throws TineLinkException {
        if (writeData(new TDataType()) != 0) {
            throw new TineLinkException(getLinkAddress(), getLinkStatus(), getErrorMessage());
        }
    }
}

