/*
 * (c) by DESY 2016 - Group MCS 1, Hamburg, Germany
 * 
 * For more information about the license you should have a look at the
 * following web page:
 * 
 *         http://www.desy.de/legal/license/index_eng.html
 * 
 * If no concrete license can be found at this web page or the connection is
 * broken, then the following license is relevant:
 * 
 * Copyright (C) 2016 DESY.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301  USA
 */
package de.desy.mst.libs.util.helper;

/**
 * Helper class with information about the current version information and release
 * version.  
 * 
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id: CHelperLib.java 73895 2016-11-17 08:39:38Z walla $
 */
@AVersion
(
	application = "MCS Helper Library", major = 2, minor = 0, revision = 2, buildId = "$Revision: 73895 $", releaseDate = "2016/11/16",
	developers = 
	{
		@ADeveloper(email = "marcus.walla[at]desy[dot]de", fullName = "Marcus Walla", group = "MCS 1", phone = "2628", room = "30/506")
	}
)
public final class CHelperLib 
{
    /**
     * Creates a class instance of the version of this helper library.
     */
    private static final Version version = new Version(CHelperLib.class);

    /**
     * Returns the version information.
     * @return version information
     */
    public static final Version getVersion() { return CHelperLib.version; }
}
/* end of file */