/*
 * (c) by DESY 2016 - Group MCS 1, Hamburg, Germany
 * 
 * For more information about the license you should have a look at the
 * following web page:
 * 
 *         http://www.desy.de/legal/license/index_eng.html
 * 
 * If no concrete license can be found at this web page or the connection is
 * broken, then the following license is relevant:
 * 
 * Copyright (C) 2016 DESY.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301  USA
 */
package de.desy.mst.libs.util.helper;

import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Utility class methods.
 * 
 * @author <a href="mailto:marcus.walla(at)desy.de">walla</a>
 * @version $Id$
 */
public class Utilities 
{
    // --- CLASS FIELDS --------------------------------------------------------
    private final static Logger log = LogProvider.getLogger(Utilities.class, Level.INFO, true, LogProvider.ELoggingProperty.MCS_LOGGING);

    // --- CLASS METHODS -------------------------------------------------------
    /**
     * Sleep for {@code delay} milliseconds.
     * @param delay 
     */
    public static final void sleep(final long delay)
    {
        try
        {
            Thread.sleep(delay);
        }
        catch(final InterruptedException exception)
        {
            log.warning("interrupted thread");
        }
    }
}
/* end of file */