<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
>
<!-- xmlns="http://www.w3.org/TR/REC-html40" this PI lets FF fail -->

<xsl:output method="html" omit-xml-declaration="yes"/>

<xsl:template  match="/Objects">
 <html>
  <head>
   <title>Machine Control Applications</title>
  </head>
  <body>
<H1>
Vorlufige Testversion
</H1>
<p>
Auf dieser Website sind Applikationen des Kontrollsystems aufgelistet, 
die keinen Einfluss auf die Bedienung der Beschleuniger haben sollen.
Diese Applikationen knnen grundstzlich von jedem Host im DESY Netzwerk gestartet werden.
Sollten weitere unkritische Applikationen bentigt werden, kann diese Liste ggf. erweitert werden.
Sollte sich im Betrieb der Beschleuniger herausstellen, 
dass eine dieser hier aufgefhrten Applikationen einen Einfluss auf die Bedienung hat,  
wird diese Applikation von dieser Liste entfernt und steht nicht lnger zur Verfgung.
</p>
<p>
Voraussetzungen sind:<br/>
Java Runtime 1.7 update 51 (bis Q1 / 2016)
<br/>oder<br/>
Java Runtime 1.8 update 60 (ab Q1 / 2016)
</p>
<p>
Es ist mglich, dass auf individuell konfigurierten Rechnern individuelle Fehler oder Eigenschaften auftreten.
Diese Fehler werden im Allgemeinen nicht zentral behoben. Zum Beispiel: <br/>
<li>Sicherheitsabfrage wegen eines nicht vertrauenswrdigen Zertifikates.</li>
<br/>
Eine weitreichendere Untersttzung wird fr die Terminaldienste des Kontrollsystems xApps1 und xAppsA geleistet.
</p>

   <table CELLSPACING="3" CELLPADDING="4" >
    <xsl:apply-templates select="/Objects/Object/Property"/>
   </table>
  </body>
 </html>
</xsl:template>


<xsl:template match="/Objects/Object/Property">
 <tr>
  <td><b><xsl:value-of select="./@Name"/></b></td>
 </tr>

  <xsl:for-each select="./Property">
   <xsl:variable name="iconHref" select="./Property[attribute::Name='icon']"/>
   <xsl:variable name="title" select="./Property[attribute::Name='title']"/>
   <xsl:variable name="jnlpHref" select="./Property[attribute::Name='jnlp']"/>
   <tr>
    <td></td>
    <td><img src="{$iconHref}" alt="Alternativtext"/></td>
    <td><a href="{$jnlpHref}"><xsl:value-of select="./Property[attribute::Name='title']"/></a></td>
   </tr>
 </xsl:for-each>
</xsl:template>


</xsl:stylesheet>

